﻿Imports System.Globalization
''' <summary>
''' Converts a given ID of a Konto to
''' bezeichnung of konto self
''' or
''' symbol of konto self
''' </summary>
Public Class konto_id_converter
    Implements IMultiValueConverter

    Dim v_returnsymbol As Boolean = False
    Public Property ReturnSymbol As Boolean
        Get
            Return v_returnsymbol
        End Get
        Set(value As Boolean)
            v_returnsymbol = value
        End Set
    End Property

    Dim v_returnfullname As Boolean = False
    Public Property ReturnFullname As Boolean
        Get
            Return v_returnfullname
        End Get
        Set(value As Boolean)
            v_returnfullname = value
        End Set
    End Property

    ''' <summary>
    ''' Value(0) => ID of Conto
    ''' Values(1) => Collection of konten
    ''' </summary>
    ''' <param name="values"></param>
    ''' <param name="targetType"></param>
    ''' <param name="parameter"></param>
    ''' <param name="culture"></param>
    ''' <returns></returns>
    Public Function Convert(values() As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IMultiValueConverter.Convert
        If values(0) Is Nothing Then Return Nothing
        If values.Length <> 2 OrElse values(0).ToString = "0" OrElse values(0) Is DependencyProperty.UnsetValue OrElse values(0) Is Nothing OrElse values(1) Is Nothing OrElse values(1) Is DependencyProperty.UnsetValue Then
            Return Nothing
        End If

        Dim v_id As Integer = System.Convert.ToInt16(values(0))
        Dim v_kontos As ListCollectionView = TryCast(values(1), ListCollectionView)

        v_kontos.Filter = New Predicate(Of Object)(Function(p) DirectCast(p, konto_v01).kto_id = v_id)
        Dim v_found_kto As konto_v01 = DirectCast(v_kontos.CurrentItem, konto_v01)
        If v_kontos.Count = 1 Then
            v_kontos.Filter = Nothing

            If ReturnSymbol Then
                Return ByteToImage(v_found_kto.symbol_ever)
            Else
                If ReturnFullname Then
                    'Fullname
                    Return v_found_kto.nv_folder_2_konto_back.bezeichnung & " - " & v_found_kto.bezeichnung
                Else
                    'return bezeichnung
                    Return v_found_kto.bezeichnung
                End If

            End If
        Else
            Return Nothing
        End If
    End Function

    Public Function ConvertBack(value As Object, targetTypes() As Type, parameter As Object, culture As CultureInfo) As Object() Implements IMultiValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class
