﻿Imports System.Globalization

''' <summary>
''' Converter for splitting the totamount of a transaction between positive and negative column of datagrid
''' </summary>
Public Class multi_converter_amount
    Implements IMultiValueConverter

    Public Function Convert(values() As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IMultiValueConverter.Convert
        '0: value of the transaction just for recognizing the property changed event
        '1: current transaction
        '2: currently displayed konto (account)
        If values(0) Is Nothing Then Return String.Empty
        If values(1) Is Nothing Then Return String.Empty
        If values(2) Is Nothing Then Return String.Empty

        Dim v_transaction As transactions_v01 = DirectCast(values(1), transactions_v01)
        Dim v_konto As konto_v01 = DirectCast(values(2), konto_v01)
        'if multiplier matches with the parameter then return a value else return empty
        If v_transaction.nv_transtyp_trans_back Is Nothing Then Return 0 'nv_transtyp_trans_back turns nothing during delete operation
        Select Case v_transaction.nv_transtyp_trans_back.multiplier
            Case 1, -1
                '+
                Return String.Format("{0:C2}", v_transaction.real_totamount)
            Case Else
                'transfer
                'wenn eine transferbuchung in der konto_id mit dem aktuellen Konto match ist sie minus
                'wenn eine transferbuchung mit der to_konto_id des aktuellen kontos matched ist sie +
                If v_transaction.konto_id = v_konto.kto_id Then
                    Return String.Format("{0:C2}", v_transaction.totamount * -1)
                Else
                    Return String.Format("{0:C2}", v_transaction.totamount)
                End If
        End Select
        Return String.Format("{0:C2}", v_transaction.real_totamount)

    End Function

    Public Function ConvertBack(value As Object, targetTypes() As Type, parameter As Object, culture As CultureInfo) As Object() Implements IMultiValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class
