﻿Imports System.Globalization

''' <summary>
''' Converter for splitting the totamount of a transaction between positive and negative column of datagrid returns the right color
''' </summary>
Public Class multi_converter_amount_color
    Implements IMultiValueConverter

    Public Function Convert(values() As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IMultiValueConverter.Convert
        '0: current transaction
        '1: currently displayed konto (account)
        'Parameter the current ideal foreground color
        If values(0) Is Nothing Then Return Nothing
        If values(1) Is Nothing Then Return Nothing
        If parameter Is Nothing Then Return Nothing
        Dim vMainModel As HHHB3.ViewModel.MainViewModel = GalaSoft.MvvmLight.Ioc.SimpleIoc.Default.GetInstance(Of HHHB3.ViewModel.MainViewModel)

        Dim v_pos_color As Brush = vMainModel.SettingsCurrent.color_pos_value_brush
        Dim v_neg_color As Brush = vMainModel.SettingsCurrent.color_neg_value_brush


        Dim v_transaction As transactions_v01 = DirectCast(values(0), transactions_v01)
        Dim v_konto As konto_v01 = DirectCast(values(1), konto_v01)
        'Parameter Definition is similar to transaction multiplier
        'if multiplier matches with the parameter then return a value else return empty
        Select Case v_transaction.nv_transtyp_trans_back.multiplier
            Case 1
                '+
                Return v_pos_color
            Case -1
                '-
                Return v_neg_color
            Case Else
                'transfer
                'if a transfer: if konto_id matches the id of the current konto then minus => negative otherwise positiv
                If v_transaction.konto_id = v_konto.kto_id Then
                    Return v_neg_color
                Else
                    Return v_pos_color
                End If
        End Select
        Return parameter
    End Function

    Public Function ConvertBack(value As Object, targetTypes() As Type, parameter As Object, culture As CultureInfo) As Object() Implements IMultiValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class
