﻿Imports System.Globalization
''' <summary>
''' Converts a given ID of a Tag to
''' bezeichnung of tag self
''' or
''' symbol of tag self
''' </summary>
Public Class tag_id_converter
    Implements IMultiValueConverter

    Dim v_returnsymbol As Boolean = False
    Public Property ReturnSymbol As Boolean
        Get
            Return v_returnsymbol
        End Get
        Set(value As Boolean)
            v_returnsymbol = value
        End Set
    End Property

    ''' <summary>
    ''' Value(0) => ID of Tag
    ''' Values(1) => Collection of Tags
    ''' </summary>
    ''' <param name="values"></param>
    ''' <param name="targetType"></param>
    ''' <param name="parameter"></param>
    ''' <param name="culture"></param>
    ''' <returns></returns>
    Public Function Convert(values() As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IMultiValueConverter.Convert
        If values.Length <> 2 OrElse values(0).ToString = "0" OrElse values(0) Is DependencyProperty.UnsetValue OrElse values(0) Is Nothing OrElse values(1) Is Nothing OrElse values(1) Is DependencyProperty.UnsetValue Then
            Return Nothing
        End If

        Dim v_id As Integer = System.Convert.ToInt16(values(0))
        Dim v_tags As ListCollectionView = TryCast(values(1), ListCollectionView)

        v_tags.Filter = New Predicate(Of Object)(Function(p) DirectCast(p, tags_v01).tag_id = v_id)
        Dim v_found_tag As tags_v01 = DirectCast(v_tags.CurrentItem, tags_v01)
        If v_tags.Count = 1 Then
            v_tags.Filter = Nothing

            If ReturnSymbol Then
                Return ByteToImage(v_found_tag.symbol_ever)
            Else
                'return bezeichnung
                Return v_found_tag.bezeichnung
            End If
        Else
            Return Nothing
        End If
    End Function

    Public Function ConvertBack(value As Object, targetTypes() As Type, parameter As Object, culture As CultureInfo) As Object() Implements IMultiValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class
