﻿''' <summary>
''' Basisklasse für ein Menuitem im Avalon Dock.
''' Baseclass for an avalon dock menuitem
''' is also used for the widgets as a baseclass
''' </summary>
Public MustInherit Class avalon_menuitem_base
    Inherits model_base 'Modelbase Klasse für Notifypropertychanged

#Region "Menüsystem"
    ''' <summary>
    ''' Statische Bezeichnung für das Avalon Dock
    ''' </summary>
    ''' <returns></returns>
    Public MustOverride ReadOnly Property bezeichnung As String

    Public Property cmdClose() As New RelayCommand(AddressOf Close, Function() CanClose = True)

    Private _isclosed As Boolean = True

    Public Property IsClosed() As Boolean
        Get
            Return _isclosed
        End Get
        Set(value As Boolean)
            If _isclosed <> value Then
                _isclosed = value
                NotifyPropertyChanged("IsClosed")
            End If
        End Set
    End Property

    Private _CanClose As Boolean = True


    Public Property CanClose() As Boolean
        Get
            Return _CanClose
        End Get
        Set
            If _CanClose <> Value Then
                _CanClose = Value
                NotifyPropertyChanged("CanClose")
            End If
        End Set
    End Property

    Public Overridable Sub Close()
        Debug.Print("Close execute")
        Me.IsClosed = True
        NotifyPropertyChanged("IsClosed")
        Debug.Print("Close executed")
    End Sub
#End Region

End Class
