﻿Imports System.Runtime.InteropServices
Imports System.Text
Imports Microsoft.WindowsAPICodePack.Shell.PropertySystem
Imports MS.WindowsAPICodePack.Internal

Namespace HHHB3.ShellHelpers
    Friend Enum STGM As Long
        STGM_READ = &H0L
        STGM_WRITE = &H1L
        STGM_READWRITE = &H2L
        STGM_SHARE_DENY_NONE = &H40L
        STGM_SHARE_DENY_READ = &H30L
        STGM_SHARE_DENY_WRITE = &H20L
        STGM_SHARE_EXCLUSIVE = &H10L
        STGM_PRIORITY = &H40000L
        STGM_CREATE = &H1000L
        STGM_CONVERT = &H20000L
        STGM_FAILIFTHERE = &H0L
        STGM_DIRECT = &H0L
        STGM_TRANSACTED = &H10000L
        STGM_NOSCRATCH = &H100000L
        STGM_NOSNAPSHOT = &H200000L
        STGM_SIMPLE = &H8000000L
        STGM_DIRECT_SWMR = &H400000L
        STGM_DELETEONRELEASE = &H4000000L
    End Enum

    Friend NotInheritable Class ShellIIDGuid
        Private Sub New()
        End Sub
        Friend Const IShellLinkW As String = "000214F9-0000-0000-C000-000000000046"
        Friend Const CShellLink As String = "00021401-0000-0000-C000-000000000046"
        Friend Const IPersistFile As String = "0000010b-0000-0000-C000-000000000046"
        Friend Const IPropertyStore As String = "886D8EEB-8CF2-4446-8D02-CDBA1DBDCF99"
    End Class

    <ComImport, Guid(ShellIIDGuid.IShellLinkW), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    Friend Interface IShellLinkW
        'ref _WIN32_FIND_DATAW pfd,
        Function GetPath(<Out, MarshalAs(UnmanagedType.LPWStr)> pszFile As StringBuilder, cchMaxPath As Integer, pfd As IntPtr, fFlags As UInteger) As UInt32
        Function GetIDList(ByRef ppidl As IntPtr) As UInt32
        Function SetIDList(pidl As IntPtr) As UInt32
        Function GetDescription(<Out, MarshalAs(UnmanagedType.LPWStr)> pszFile As StringBuilder, cchMaxName As Integer) As UInt32
        Function SetDescription(<MarshalAs(UnmanagedType.LPWStr)> pszName As String) As UInt32
        Function GetWorkingDirectory(<Out, MarshalAs(UnmanagedType.LPWStr)> pszDir As StringBuilder, cchMaxPath As Integer) As UInt32
        Function SetWorkingDirectory(<MarshalAs(UnmanagedType.LPWStr)> pszDir As String) As UInt32
        Function GetArguments(<Out, MarshalAs(UnmanagedType.LPWStr)> pszArgs As StringBuilder, cchMaxPath As Integer) As UInt32
        Function SetArguments(<MarshalAs(UnmanagedType.LPWStr)> pszArgs As String) As UInt32
        Function GetHotKey(ByRef wHotKey As Short) As UInt32
        Function SetHotKey(wHotKey As Short) As UInt32
        Function GetShowCmd(ByRef iShowCmd As UInteger) As UInt32
        Function SetShowCmd(iShowCmd As UInteger) As UInt32
        Function GetIconLocation(<Out, MarshalAs(UnmanagedType.LPWStr)> ByRef pszIconPath As StringBuilder, cchIconPath As Integer, ByRef iIcon As Integer) As UInt32
        Function SetIconLocation(<MarshalAs(UnmanagedType.LPWStr)> pszIconPath As String, iIcon As Integer) As UInt32
        Function SetRelativePath(<MarshalAs(UnmanagedType.LPWStr)> pszPathRel As String, dwReserved As UInteger) As UInt32
        Function Resolve(hwnd As IntPtr, fFlags As UInteger) As UInt32
        Function SetPath(<MarshalAs(UnmanagedType.LPWStr)> pszFile As String) As UInt32
    End Interface

    <ComImport, Guid(ShellIIDGuid.IPersistFile), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    Friend Interface IPersistFile
        Function GetCurFile(<Out, MarshalAs(UnmanagedType.LPWStr)> pszFile As StringBuilder) As UInt32
        Function IsDirty() As UInt32
        Function Load(<MarshalAs(UnmanagedType.LPWStr)> pszFileName As String, <MarshalAs(UnmanagedType.U4)> dwMode As STGM) As UInt32
        Function Save(<MarshalAs(UnmanagedType.LPWStr)> pszFileName As String, fRemember As Boolean) As UInt32
        Function SaveCompleted(<MarshalAs(UnmanagedType.LPWStr)> pszFileName As String) As UInt32
    End Interface
    <ComImport>
    <Guid(ShellIIDGuid.IPropertyStore)>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    Interface IPropertyStore
        Function GetCount(<Out> ByRef propertyCount As UInteger) As UInt32
        Function GetAt(<[In]> propertyIndex As UInteger, ByRef key As PropertyKey) As UInt32
        Function GetValue(<[In]> ByRef key As PropertyKey, <Out> pv As PropVariant) As UInt32
        Function SetValue(<[In]> ByRef key As PropertyKey, <[In]> pv As PropVariant) As UInt32
        Function Commit() As UInt32
    End Interface


    <ComImport, Guid(ShellIIDGuid.CShellLink), ClassInterface(ClassInterfaceType.None)>
    Friend Class CShellLink
    End Class

    Public NotInheritable Class ErrorHelper
        Private Sub New()
        End Sub
        Public Shared Sub VerifySucceeded(hresult As UInt32)
            If hresult > 1 Then
                Throw New Exception("Failed with HRESULT: " + hresult.ToString("X"))
            End If
        End Sub
    End Class
End Namespace