﻿Imports System.ComponentModel
''' <summary>
''' Defined Timeframe with Start and Enddate
''' </summary>
Public Class cls_timeframe_defined

    Inherits model_base

    Dim v_start_date As Date = Date.Now
    Dim v_end_date As Date = Date.Now.AddDays(1)

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "start_date"
                    If start_date = Nothing Then result = "Startdatum ist nicht gewählt oder ungültig"
                    If Not end_date = Nothing Then
                        If start_date > end_date Then result = "Startdatum darf nicht größer als Enddatum sein"
                    End If
                Case "end_date"
                    If end_date = Nothing Then result = "Enddatum ist nicht gewählt oder ungültig"
                    If Not start_date = Nothing Then
                        If end_date < start_date Then result = "Enddatum darf nicht kleiner als Startdatum sein"
                    End If
                Case Else
                    Return result
            End Select
            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If

            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region

    Public Property start_date As Date
        Get
            Return v_start_date
        End Get
        Set(value As Date)
            If v_start_date <> value Then
                v_start_date = value
                NotifyPropertyChanged("start_date")
            End If
        End Set
    End Property

    Public Property end_date As Date
        Get
            Return v_end_date
        End Get
        Set(value As Date)
            If v_end_date <> value Then
                v_end_date = value
                NotifyPropertyChanged("end_date")
            End If
        End Set
    End Property

    Sub New()

    End Sub

    Sub New(DateStart As Date, DateEnd As Date)
        If DateStart <> Nothing Then start_date = DateStart
        If DateEnd <> Nothing Then end_date = DateEnd
    End Sub


End Class
