﻿Imports System.Diagnostics
Imports System.IO
Imports System.Windows
Imports System.Windows.Controls

Imports MS.WindowsAPICodePack.Internal
Imports Microsoft.WindowsAPICodePack.Shell.PropertySystem

'Contained in: C:\Program Files (x86)\Windows Kits\8.1\References\CommonConfiguration\Neutral\Windows.winmd
Imports Windows.UI.Notifications
Imports Windows.Data.Xml.Dom
Imports System.Windows.Threading

Public Class cls_toaster_win10
    Private Const APP_ID As [String] = "MyAreaAT.HHHHB3"
    ' In order to display toasts, a desktop application must have a shortcut on the Start menu.
    ' Also, an AppUserModelID must be set on that shortcut.
    ' The shortcut should be created as part of the installer. The following code shows how to create
    ' a shortcut and assign an AppUserModelID using Windows APIs. You must download and include the 
    ' Windows API Code Pack for Microsoft .NET Framework for this code to function
    '
    ' Included in this project is a wxs file that be used with the WiX toolkit
    ' to make an installer that creates the necessary shortcut. One or the other should be used.
    Public Function TryCreateShortcut() As Boolean
        Dim shortcutPath As [String] = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\Microsoft\Windows\Start Menu\Programs\HHHB3.lnk"
        If Not File.Exists(shortcutPath) Then
            InstallShortcut(shortcutPath)
            Return True
        End If
        Return False
    End Function


    Public Sub define_toaster(header As String, row1 As String, template_type As ToastTemplateType, noaction As Boolean, Optional row2 As String = "")
        Dim toast_template As XmlDocument = ToastNotificationManager.GetTemplateContent(template_type)

        'Text
        Dim text_elements As XmlNodeList = toast_template.GetElementsByTagName("text")
        For i As Integer = 0 To CInt(text_elements.Length) - 1

            If i = 0 Then text_elements(i).AppendChild(toast_template.CreateTextNode(header))
            If i = 1 Then text_elements(i).AppendChild(toast_template.CreateTextNode(row1))
            If i = 2 Then text_elements(i).AppendChild(toast_template.CreateTextNode(row2))
        Next

        Dim pic_path As String = "file:///" + Path.GetFullPath("Idea_48px.png")
        Dim pic_elements As XmlNodeList = toast_template.GetElementsByTagName("image")
        pic_elements(0).Attributes.GetNamedItem("src").NodeValue = pic_path

        Dim toast_bubble As New ToastNotification(toast_template)

        'Nur wenn keine Aktion ausgeführt werden soll auslassen:
        If Not noaction Then
            With toast_bubble
                AddHandler .Activated, AddressOf ToastActivated
                AddHandler .Dismissed, AddressOf ToastDismissed
                AddHandler .Failed, AddressOf ToastFailed
            End With
        End If

        ' Show the toast. Be sure to specify the AppUserModelId on your application's shortcut!
        ToastNotificationManager.CreateToastNotifier(APP_ID).Show(toast_bubble)
    End Sub

    ' Create and show the toast.
    ' See the "Toasts" sample for more detail on what can be done with toasts
    Public Sub ShowToastButton_Click()

        ' Get a toast XML template
        Dim toastXml As XmlDocument = ToastNotificationManager.GetTemplateContent(ToastTemplateType.ToastImageAndText04)

        ' Fill in the text elements
        Dim stringElements As XmlNodeList = toastXml.GetElementsByTagName("text")
        For i As Integer = 0 To CInt(stringElements.Length) - 1
            stringElements(i).AppendChild(toastXml.CreateTextNode("Line " + i.ToString))
        Next

        ' Specify the absolute path to an image
        Dim imagePath As String = "file:///" + Path.GetFullPath("toastImageAndText.png")
        Dim imageElements As XmlNodeList = toastXml.GetElementsByTagName("image")
        imageElements(0).Attributes.GetNamedItem("src").NodeValue = imagePath

        ' Create the toast and attach event listeners
        Dim toast As New ToastNotification(toastXml)

        AddHandler toast.Activated, AddressOf ToastActivated
        AddHandler toast.Dismissed, AddressOf ToastDismissed
        AddHandler toast.Failed, AddressOf ToastFailed

        ' Show the toast. Be sure to specify the AppUserModelId on your application's shortcut!
        ToastNotificationManager.CreateToastNotifier(APP_ID).Show(toast)
    End Sub


    Private Sub InstallShortcut(shortcutPath As [String])
        ' Find the path to the current executable
        Dim exeFullPath As [String] = Process.GetCurrentProcess().MainModule.FileName
        Dim exePath As String = exeFullPath.Remove(exeFullPath.LastIndexOf("\"))
        Dim newShortcut As HHHB3.ShellHelpers.IShellLinkW = DirectCast(New HHHB3.ShellHelpers.CShellLink(), HHHB3.ShellHelpers.IShellLinkW)

        ' Create a shortcut to the exe
        HHHB3.ShellHelpers.ErrorHelper.VerifySucceeded(newShortcut.SetPath(exeFullPath))
        HHHB3.ShellHelpers.ErrorHelper.VerifySucceeded(newShortcut.SetArguments(""))
        HHHB3.ShellHelpers.ErrorHelper.VerifySucceeded(newShortcut.SetIconLocation(exePath & "\" & "hhhb_main6464_6.ico", 0))


        ' Open the shortcut property store, set the AppUserModelId property
        Dim newShortcutProperties As HHHB3.ShellHelpers.IPropertyStore = DirectCast(newShortcut, HHHB3.ShellHelpers.IPropertyStore)

        Using appId As New PROPVARIANT(APP_ID)
            HHHB3.ShellHelpers.ErrorHelper.VerifySucceeded(newShortcutProperties.SetValue(SystemProperties.System.AppUserModel.ID, appId))
            HHHB3.ShellHelpers.ErrorHelper.VerifySucceeded(newShortcutProperties.Commit())
        End Using

        ' Commit the shortcut to disk
        Dim newShortcutSave As HHHB3.ShellHelpers.IPersistFile = DirectCast(newShortcut, HHHB3.ShellHelpers.IPersistFile)

        HHHB3.ShellHelpers.ErrorHelper.VerifySucceeded(newShortcutSave.Save(shortcutPath, True))
    End Sub

    Private Sub ToastActivated(sender As ToastNotification, e As Object)
        'Dispatcher.Invoke(Function()
        '                      Activate()
        '                      Output.Text = "The user activated the toast."

        '                  End Function)

        MessageBox.Show("Toast aktiviert")
    End Sub

    Private Sub ToastDismissed(sender As ToastNotification, e As ToastDismissedEventArgs)
        Dim outputText As [String] = ""
        Select Case e.Reason
            Case ToastDismissalReason.ApplicationHidden
                outputText = "The app hid the toast using ToastNotifier.Hide"
                Exit Select
            Case ToastDismissalReason.UserCanceled
                outputText = "The user dismissed the toast"
                Exit Select
            Case ToastDismissalReason.TimedOut
                outputText = "The toast has timed out"
                Exit Select
        End Select

        'Dispatcher.Invoke(Function()
        '                      Output.Text = outputText

        '                  End Function)
        MessageBox.Show(outputText)
    End Sub

    Private Sub ToastFailed(sender As ToastNotification, e As ToastFailedEventArgs)
        'Dispatcher.Invoke(Function()
        '                      Output.Text = "The toast encountered an error."

        '                  End Function)
        MessageBox.Show("Toast fehler")
    End Sub

End Class