﻿Imports System.Configuration
Imports System.Data.Common
Imports System.Data.Entity.Core.EntityClient

Module mod_dbhelper

    Public Function check_db(v_filepath As String) As Boolean
        If v_filepath = "" Then
            'Nicht gefunden
            Return False
        Else
            If System.IO.File.Exists(v_filepath) Then
                Return True
            Else
                Return False
            End If
        End If

    End Function

    Public Enum set_db_results
        set_new_restart
        was_set
    End Enum

    ''' <summary>
    ''' Setzt die Datenbank neu für EF
    ''' </summary>
    ''' <returns>Returns True when the connectionstring didn't change otherwise false</returns>

    Public Function set_db() As set_db_results
        Dim config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None)
        Dim connectionStringsSection = DirectCast(config.GetSection("connectionStrings"), ConnectionStringsSection)
        Dim v_string1 As String = "Data Source="
        Dim v_string2 As String = "'"

        Dim v_lastused_db_path As String = GetValueFromRegistryKey("db_lastused")

        cls_logger.v_logger.Info("db_lastused before: " & v_lastused_db_path)

        Dim v_constring As String = v_string1 & v_lastused_db_path ' & v_string2
        If connectionStringsSection.ConnectionStrings("hhhb3_model").ConnectionString.Equals(v_constring) = False Then
            connectionStringsSection.ConnectionStrings("hhhb3_model").ConnectionString = v_constring '& ", Password=1234"
            cls_logger.v_logger.Info("db_lastused after: " & v_constring)
            config.Save()
            ConfigurationManager.RefreshSection("connectionStrings")
            cls_logger.v_logger.Info("set_db executed in connectionstring: " & connectionStringsSection.ConnectionStrings("hhhb3_model").ConnectionString.ToString)
            'After changing the connectionstring the application must be restarted:
            Return set_db_results.set_new_restart
        End If
        Return set_db_results.was_set
    End Function

    Public Function set_db_constring() As String
        Dim v_lastused_db_path As String = GetValueFromRegistryKey("db_lastused")
        Return ";Data Source=" & v_lastused_db_path
    End Function

End Module