Imports System
Imports System.Data.Entity
Imports System.Data.Entity.Migrations
Imports System.Linq

Namespace Migrations

    Friend NotInheritable Class Configuration 
        Inherits DbMigrationsConfiguration(Of hhhb3_model)

        Public Sub New()
            AutomaticMigrationsEnabled = True
            AutomaticMigrationDataLossAllowed = True

            ContextKey = "HHHB3.hhhb3_model"
        End Sub

        Protected Overrides Sub Seed(context As hhhb3_model)
            '  This method will be called after migrating to the latest version.

            '  You can use the DbSet(Of T).AddOrUpdate() helper extension method 
            '  to avoid creating duplicate seed data. E.g.
            '
            '    context.People.AddOrUpdate(
            '       Function(c) c.FullName,
            '       New Customer() With {.FullName = "Andrew Peters"},
            '       New Customer() With {.FullName = "Brice Lambson"},
            '       New Customer() With {.FullName = "Rowan Miller"})
            'preset fpr empty entry:
            If Not context.m_person_v01.Where(Function(x) CBool(x.predefined) = True).Count = 1 Then context.m_person_v01.AddOrUpdate(New person_v01 With {.bezeichnung = "---", .predefined = True, .aktiv = True})
            If Not context.m_receiver_v01.Where(Function(x) CBool(x.predefined) = True).Count = 1 Then context.m_receiver_v01.AddOrUpdate(New receiver_v01 With {.bezeichnung = "---", .predefined = True, .aktiv = True})
            If Not context.m_trans_status_v01.Where(Function(x) CBool(x.predefined) = True).Count = 1 Then context.m_trans_status_v01.AddOrUpdate(New trans_status_v01 With {.bezeichnung = "---", .predefined = True, .aktiv = True})
        End Sub

    End Class

End Namespace
