﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema

Public Class documents_v01
    Inherits model_base

    'Interne Variablen
    Dim v_doc_id As Integer
    Dim v_bezeichnung As String
    Dim v_path As String
    Dim v_transaction_id As Nullable(Of Integer)
    Dim v_transaction_rep_id As Nullable(Of Integer)

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "bezeichnung"
                    If String.IsNullOrEmpty(bezeichnung) Then result = "Bezeichnung darf nicht leer sein"
                Case "path"
                    If String.IsNullOrEmpty(path) Then result = "Pfad darf nicht leer sein"
            End Select

            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If
            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region

#Region "Mapped"
    <Key>
    Public Property doc_id As Integer
        Get
            Return v_doc_id
        End Get
        Set(value As Integer)
            If v_doc_id <> value Then
                v_doc_id = value
                NotifyPropertyChanged("doc_id")
            End If
        End Set
    End Property

    Public Property bezeichnung As String
        Get
            Return v_bezeichnung
        End Get
        Set(value As String)
            If v_bezeichnung <> value Then
                v_bezeichnung = value
                NotifyPropertyChanged("bezeichnung")
            End If
        End Set
    End Property

    Public Property path As String
        Get
            Return v_path
        End Get
        Set(value As String)
            If v_path <> value Then
                v_path = value
                NotifyPropertyChanged("path")
            End If
        End Set
    End Property

    Public Property transaction_id As Nullable(Of Integer)
        Get
            Return v_transaction_id
        End Get
        Set(value As Nullable(Of Integer))
            v_transaction_id = value
            NotifyPropertyChanged("transaction_id")
        End Set
    End Property

    Public Property transaction_rep_id As Nullable(Of Integer)
        Get
            Return v_transaction_rep_id
        End Get
        Set(value As Nullable(Of Integer))
            v_transaction_rep_id = value
            NotifyPropertyChanged("transaction_rep_id")
        End Set
    End Property
#End Region


#Region "Navigation Properties"

    Dim v_nv_trans_2_doc_back As transactions_v01
    Dim v_transaction_rep As transactions_repeat_v01

    <ForeignKey("transaction_id")>
    Public Property nv_trans_2_doc_back As transactions_v01
        Get
            Return v_nv_trans_2_doc_back
        End Get
        Set(value As transactions_v01)
            If v_nv_trans_2_doc_back IsNot value Then
                v_nv_trans_2_doc_back = value
                NotifyPropertyChanged("nv_trans_2_doc_back")
            End If
        End Set
    End Property
    '<ForeignKey("transaction_rep_id")>
    'Public Property transaction_rep As transactions_repeat_v01
    '    Get
    '        Return v_transaction_rep
    '    End Get
    '    Set(value As transactions_repeat_v01)
    '        If v_transaction_rep IsNot value Then
    '            v_transaction_rep = value
    '            NotifyPropertyChanged("transaction_rep")
    '        End If
    '    End Set
    'End Property
#End Region
End Class
