﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports LiveCharts

Public Class report_base_v01
    Inherits model_base

    Dim v_id As Integer
    Dim v_rep_bezeichnung As String
    Dim v_date_start As Date = New Date(Date.Now.Year, Date.Now.Month, 1)
    Dim v_date_end As Date = New Date(Date.Now.Year, Date.Now.Month, 1).AddMonths(1).AddDays(-1)
    Dim v_type As String
    Dim v_count As Integer
    Dim v_positive As Boolean = False 'Used also in a capital report to check if the start value should be returned too
    Dim v_selected_folder_ids As String
    Dim v_selected_konto_ids As String
    Dim v_selected_category_ids As String
    'Property to store the selected negative category ids of a periodical report:
    Dim v_selected_period_negative_category_ids As String
    'Property to store the selected period of a periodical report:
    Dim v_selected_period_period As Integer
    Dim v_selected_receiver_ids As String
    Dim v_selected_person_ids As String
    Dim v_print_diagram As Boolean = True
    <Key>
    Public Property Id As Integer
        Get
            Return v_id
        End Get
        Set(value As Integer)
            If v_id <> value Then
                v_id = value
                NotifyPropertyChanged("Id")
            End If
        End Set
    End Property

    Public Property rep_bezeichnung As String
        Get
            Return v_rep_bezeichnung
        End Get
        Set(value As String)
            If v_rep_bezeichnung <> value Then
                v_rep_bezeichnung = value
                NotifyPropertyChanged("rep_bezeichnung")
            End If
        End Set
    End Property

    Public Property date_start As Date
        Get
            Return v_date_start
        End Get
        Set(value As Date)
            If v_date_start <> value Then
                v_date_start = value
                NotifyPropertyChanged("date_start")
                clear_report()
            End If
        End Set
    End Property

    Public Property date_end As Date
        Get
            Return v_date_end
        End Get
        Set(value As Date)
            If v_date_end <> value Then
                v_date_end = value
                NotifyPropertyChanged("date_end")
                clear_report()
            End If
        End Set
    End Property

    Public Property type As String
        Get
            Return v_type
        End Get
        Set(value As String)
            If v_type <> value Then
                v_type = value
                NotifyPropertyChanged("type")
            End If
        End Set
    End Property

    Public Property positive As Boolean
        Get
            Return v_positive
        End Get
        Set(value As Boolean)
            If v_positive <> value Then
                v_positive = value
                NotifyPropertyChanged("positive")
            End If
        End Set
    End Property

    Public Property count As Integer
        Get
            Return v_count
        End Get
        Set(value As Integer)
            If v_count <> value Then
                v_count = value
                NotifyPropertyChanged("count")
                clear_report()
            End If
        End Set
    End Property

    Public Property selected_folder_ids As String
        Get
            Return v_selected_folder_ids
        End Get
        Set(value As String)
            If v_selected_folder_ids <> value Then
                v_selected_folder_ids = value
                NotifyPropertyChanged("selected_folder_ids")
                clear_report()
            End If
        End Set
    End Property

    Public Property selected_konto_ids As String
        Get
            Return v_selected_konto_ids
        End Get
        Set(value As String)
            If v_selected_konto_ids <> value Then
                v_selected_konto_ids = value
                NotifyPropertyChanged("selected_konto_ids")
                clear_report()
            End If
        End Set
    End Property

    Public Property selected_category_ids As String
        Get
            Return v_selected_category_ids
        End Get
        Set(value As String)
            If v_selected_category_ids <> value Then
                v_selected_category_ids = value
                NotifyPropertyChanged("selected_category_ids")
                clear_report()
            End If
        End Set
    End Property

    Public Property selected_period_negative_category_ids As String
        Get
            Return v_selected_period_negative_category_ids
        End Get
        Set(value As String)
            If v_selected_category_ids <> value Then
                v_selected_period_negative_category_ids = value
                NotifyPropertyChanged("selected_period_negative_category_ids")
                clear_report()
            End If
        End Set
    End Property

    Public Property selected_period_period As Integer
        Get
            Return v_selected_period_period
        End Get
        Set(value As Integer)
            If v_selected_period_period <> value Then
                v_selected_period_period = value
                NotifyPropertyChanged("selected_period_period")
            End If
        End Set
    End Property

    Public Property selected_receiver_ids As String
        Get
            Return v_selected_receiver_ids
        End Get
        Set(value As String)
            If v_selected_receiver_ids <> value Then
                v_selected_receiver_ids = value
                NotifyPropertyChanged("selected_receiver_ids")
                clear_report()
            End If
        End Set
    End Property

    Public Property selected_person_ids As String
        Get
            Return v_selected_person_ids
        End Get
        Set(value As String)
            If v_selected_person_ids <> value Then
                v_selected_person_ids = value
                NotifyPropertyChanged("selected_person_ids")
                clear_report()
            End If
        End Set
    End Property

    Public Property print_diagram As Boolean
        Get
            Return v_print_diagram
        End Get
        Set(value As Boolean)
            If v_print_diagram <> value Then
                v_print_diagram = value
                NotifyPropertyChanged("print_diagram")
            End If
        End Set
    End Property

#Region "Not Mapped"
    ''' <summary>
    ''' Determines wether a Report has an amount selector.
    ''' e.g. Top List Reports have an Amount for all others make it invisible
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property has_amount As Visibility
        Get
            If type Is Nothing Or String.IsNullOrEmpty(type) Then
                Return Visibility.Collapsed
            Else
                If type.Contains("top") OrElse type = "rep_periods" Then
                    Return Visibility.Visible
                Else
                    Return Visibility.Collapsed
                End If
            End If
        End Get
    End Property

    ''' <summary>
    ''' Determines wether a Report has an positive or negative selector.
    ''' e.g. Receiver or Person Reports or all top reports
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property has_positive As Visibility
        Get
            If type Is Nothing Or String.IsNullOrEmpty(type) Then
                Return Visibility.Collapsed
            Else
                If type.Contains("top") OrElse type.Contains("person") OrElse type.Contains("receiver") Then
                    Return Visibility.Visible
                Else
                    Return Visibility.Collapsed
                End If
            End If
        End Get
    End Property


    Public ReadOnly Property has_konto_selection As Visibility
        Get
            If type Is Nothing Or String.IsNullOrEmpty(type) Then
                Return Visibility.Collapsed
            Else
                Select Case type
                    Case "rep_capital", "rep_eeinaus", "rep_ein", "rep_aus"
                        Return Visibility.Visible
                    Case Else
                        Return Visibility.Collapsed
                End Select
            End If
        End Get
    End Property

    Public ReadOnly Property has_folder_selection As Visibility
        Get
            If type Is Nothing Or String.IsNullOrEmpty(type) Then
                Return Visibility.Collapsed
            Else
                Select Case type
                    Case "rep_foldertrans"
                        Return Visibility.Visible
                    Case Else
                        Return Visibility.Collapsed
                End Select
            End If
        End Get
    End Property

    Public ReadOnly Property has_category_selection As Visibility
        Get
            If type Is Nothing Or String.IsNullOrEmpty(type) Then
                Return Visibility.Collapsed
            Else
                Select Case type
                    Case "rep_cats"
                        Return Visibility.Visible
                    Case Else
                        Return Visibility.Collapsed
                End Select
            End If
        End Get
    End Property

    Public ReadOnly Property has_period_selections As Visibility
        Get
            If type Is Nothing Or String.IsNullOrEmpty(type) Then
                Return Visibility.Collapsed
            Else
                Select Case type
                    Case "rep_periods"
                        Return Visibility.Visible
                    Case Else
                        Return Visibility.Collapsed
                End Select
            End If
        End Get
    End Property

    Public ReadOnly Property has_period_selections_invert As Visibility
        Get
            If type Is Nothing Or String.IsNullOrEmpty(type) Then
                Return Visibility.Visible
            Else
                Select Case type
                    Case "rep_periods"
                        Return Visibility.Collapsed
                    Case Else
                        Return Visibility.Visible
                End Select
            End If
        End Get
    End Property

    Public ReadOnly Property has_receiver_selection As Visibility
        Get
            If type Is Nothing Or String.IsNullOrEmpty(type) Then
                Return Visibility.Collapsed
            Else
                Select Case type
                    Case "rep_receiver"
                        Return Visibility.Visible
                    Case Else
                        Return Visibility.Collapsed
                End Select
            End If
        End Get
    End Property

    Public ReadOnly Property has_person_selection As Visibility
        Get
            If type Is Nothing Or String.IsNullOrEmpty(type) Then
                Return Visibility.Collapsed
            Else
                Select Case type
                    Case "rep_person"
                        Return Visibility.Visible
                    Case Else
                        Return Visibility.Collapsed
                End Select
            End If
        End Get
    End Property

    Public ReadOnly Property has_capital_selection As Visibility
        Get
            If type Is Nothing Or String.IsNullOrEmpty(type) Then
                Return Visibility.Collapsed
            Else
                Select Case type
                    Case "rep_capital"
                        Return Visibility.Visible
                    Case Else
                        Return Visibility.Collapsed
                End Select
            End If
        End Get
    End Property

    ''' <summary>
    ''' Resets the Report Results incl. the diagramm
    ''' </summary>
    ''' <returns></returns>
    Public Function clear_report() As Boolean
        ResultCapital.Clear()
        ResultFolderTrans.Clear()
        ResultCapitalEndsum = 0
        PrintDocument.Blocks.Clear()
        ResultPeriodsPosCats.Clear()
        ResultPeriodsNegCats.Clear()
        ResultPeriodsHeader.Clear()
        ResultPeriodsPosAmount = 0
        ResultPeriodsNegAmount = 0

        Try
            If Chart_Series IsNot Nothing Then Chart_Series.Clear()
        Catch ex As Exception

        End Try
        Try
            If PieChart_Series IsNot Nothing Then PieChart_Series.Clear()
        Catch ex As Exception

        End Try

        Chart_Labels.Clear()
        Return True
    End Function

#End Region


#Region "Result Collections"

    'Used for Report Capital and Report TopCats
    Dim v_result_capital As New ObservableCollection(Of Tuple(Of String, String, Decimal))
    <NotMapped>
    Public Property ResultCapital As ObservableCollection(Of Tuple(Of String, String, Decimal))
        Get
            Return v_result_capital
        End Get
        Set(value As ObservableCollection(Of Tuple(Of String, String, Decimal)))
            v_result_capital = value
            NotifyPropertyChanged("ResultCapital")
        End Set
    End Property

    Dim v_result_capital_endsum As Decimal = 0
    <NotMapped>
    Public Property ResultCapitalEndsum As Decimal
        Get
            Return v_result_capital_endsum
        End Get
        Set(value As Decimal)
            If v_result_capital_endsum <> value Then
                v_result_capital_endsum = value
                NotifyPropertyChanged("ResultCapitalEndsum")
            End If
        End Set
    End Property

    'Used for Report FolderTrans and Report EinAus and Report Receiver and Report Person
    Dim v_result_foldertrans As New ObservableCollection(Of Tuple(Of String, Decimal))
    <NotMapped>
    Public Property ResultFolderTrans As ObservableCollection(Of Tuple(Of String, Decimal))
        Get
            Return v_result_foldertrans
        End Get
        Set(value As ObservableCollection(Of Tuple(Of String, Decimal)))
            v_result_foldertrans = value
            NotifyPropertyChanged("ResultFolderTrans")
        End Set
    End Property

    'Properties for the Periodical Report:
    Dim v_periods_pos_cats As New ObservableCollection(Of cls_RepPeriodsCategory)

    <NotMapped>
    Public Property ResultPeriodsPosCats As ObservableCollection(Of cls_RepPeriodsCategory)
        Get
            Return v_periods_pos_cats
        End Get
        Set(value As ObservableCollection(Of cls_RepPeriodsCategory))
            v_periods_pos_cats = value
            NotifyPropertyChanged("ResultPeriodsPosCats")
        End Set
    End Property

    Dim v_periods_neg_cats As New ObservableCollection(Of cls_RepPeriodsCategory)

    <NotMapped>
    Public Property ResultPeriodsNegCats As ObservableCollection(Of cls_RepPeriodsCategory)
        Get
            Return v_periods_neg_cats
        End Get
        Set(value As ObservableCollection(Of cls_RepPeriodsCategory))
            v_periods_neg_cats = value
            NotifyPropertyChanged("ResultPeriodsNegCats")
        End Set
    End Property

    <NotMapped>
    Public Property ResultPeriodsHeader As New ObservableCollection(Of cls_RepPeriodsHeaderItem)

    Dim v_resultperiodsposamount As Decimal = 0D
    <NotMapped>
    Public Property ResultPeriodsPosAmount As Decimal
        Get
            Return v_resultperiodsposamount
        End Get
        Set(value As Decimal)
            If v_resultperiodsposamount <> value Then
                v_resultperiodsposamount = value
                NotifyPropertyChanged("ResultPeriodsPosAmount")
                NotifyPropertyChanged("ResultPeriodsDeltaAmount")
            End If
        End Set
    End Property

    Dim v_resultperiodsnegamount As Decimal = 0D
    <NotMapped>
    Public Property ResultPeriodsNegAmount As Decimal
        Get
            Return v_resultperiodsnegamount
        End Get
        Set(value As Decimal)
            If v_resultperiodsnegamount <> value Then
                v_resultperiodsnegamount = value
                NotifyPropertyChanged("ResultPeriodsNegAmount")
                NotifyPropertyChanged("ResultPeriodsDeltaAmount")
            End If
        End Set
    End Property

    Public ReadOnly Property ResultPeriodsDeltaAmount As Decimal
        Get
            Return ResultPeriodsPosAmount + ResultPeriodsNegAmount
        End Get
    End Property

#End Region

#Region "Diagram"
    'Properties for Diagram x/y
    <NotMapped>
    Public Property Chart_Series As New SeriesCollection
    <NotMapped>
    Public Property Chart_Labels As New List(Of String)
    <NotMapped>
    Public Property Chart_Formatter As Func(Of Double, String) = Function(value) value.ToString("N")

    'Properties for a PieChart:
    <NotMapped>
    Public Property PieChart_Series As New SeriesCollection

#End Region

#Region "Printing"
    Dim v_print_document As New FlowDocument With {.PageWidth = 768, .ColumnGap = 0, .IsColumnWidthFlexible = True, .PageHeight = 1104, .ColumnWidth = 768}
    <NotMapped>
    Public Property PrintDocument As FlowDocument
        Get
            Return v_print_document
        End Get
        Set(value As FlowDocument)
            v_print_document = value
            NotifyPropertyChanged("PrintDocument")
        End Set
    End Property


#End Region


#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "rep_bezeichnung"
                    If rep_bezeichnung Is Nothing OrElse String.IsNullOrEmpty(rep_bezeichnung) Then result = "Bezeichnung darf nicht leer sein"
                Case "type"
                    If type Is Nothing OrElse String.IsNullOrEmpty(type) Then result = "Report Typ muss ausgewählt sein"
                Case Else
                    Return result
            End Select
            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If
            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region

#Region "Menüsystem"
    <NotMapped>
    Public Property cmdClose() As New RelayCommand(AddressOf Close, Function() CanClose = True)

    Private _isclosed As Boolean

    <NotMapped>
    Public Property IsClosed() As Boolean
        Get
            Return _isclosed
        End Get
        Set(value As Boolean)
            If _isclosed <> value Then
                _isclosed = value
                NotifyPropertyChanged("isClosed")
            End If
        End Set
    End Property

    Private _CanClose As Boolean = True

    <NotMapped>
    Public Property CanClose() As Boolean
        Get
            Return _CanClose
        End Get
        Set
            If _CanClose <> Value Then
                _CanClose = Value
                NotifyPropertyChanged("CanClose")
            End If
        End Set
    End Property

    Public Sub Close()
        Me.IsClosed = True
        NotifyPropertyChanged("IsClosed")
    End Sub
#End Region

End Class