﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized

Public Class trans_2_kat
    Inherits model_base
    'Interne Variablen
    Dim v_Id As Integer
    Dim v_transaction_id As Integer
    Dim v_amount As Decimal = 0
    Dim v_category_id As Integer

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "transaction_id"
                    If transaction_id = Nothing Then
                        result = "Transaktion nicht übergeben"
                        cls_logger.v_logger.Error("Fehler in der Entität trans_2_kat, es wurde keine TransactionsID übergeben")
                    End If
                Case "amount"
                    If amount = Nothing Then result = "Betrag muss angegeben sein"
                Case "category_id"
                    If category_id = Nothing Then result = "Bitte Kategorie wählen"
            End Select

            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If
            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region

#Region "Mapped"
    <Key>
    Public Property Id As Integer
        Get
            Return v_Id
        End Get
        Set(value As Integer)
            If v_Id <> value Then
                v_Id = value
                NotifyPropertyChanged("Id")
            End If
        End Set
    End Property

    Public Property amount As Decimal
        Get
            Return v_amount
        End Get
        Set(value As Decimal)
            If v_amount <> value Then
                v_amount = value
                NotifyPropertyChanged("amount")
            End If
        End Set
    End Property

    Public Property transaction_id As Integer
        Get
            Return v_transaction_id
        End Get
        Set(value As Integer)
            If v_transaction_id <> value Then
                v_transaction_id = value
                NotifyPropertyChanged("transaction_id")
            End If
        End Set
    End Property

    Public Property category_id As Integer
        Get
            Return v_category_id
        End Get
        Set(value As Integer)
            If v_category_id <> value Then
                v_category_id = value
                NotifyPropertyChanged("category_id")
            End If
        End Set
    End Property
#End Region

#Region "Navigation Properties"

    Dim v_nv_trans_t2k_back As transactions_v01
    Dim v_nv_cat_trans2kat_back As category_v01

    <ForeignKey("transaction_id")>
    Public Property nv_trans_t2k_back As transactions_v01
        Get
            Return v_nv_trans_t2k_back
        End Get
        Set(value As transactions_v01)
            If v_nv_trans_t2k_back IsNot value Then
                v_nv_trans_t2k_back = value
                NotifyPropertyChanged("nv_trans_t2k_back")
            End If
        End Set
    End Property
    <ForeignKey("category_id")>
    Public Property nv_cat_trans2kat_back As category_v01
        Get
            Return v_nv_cat_trans2kat_back
        End Get
        Set(value As category_v01)
            If v_nv_cat_trans2kat_back IsNot value Then
                v_nv_cat_trans2kat_back = value
                NotifyPropertyChanged("nv_cat_trans2kat_back")
            End If
        End Set
    End Property
#End Region

#Region "Extension"
    Dim v_helpname As String
    <NotMapped>
    Public Property bezeichnung_help As String
        Get
            If nv_cat_trans2kat_back Is Nothing Then
                Return v_helpname
            Else
                Return nv_cat_trans2kat_back.bezeichnung
            End If
        End Get
        Set(value As String)
            v_helpname = value
        End Set
    End Property

#End Region
End Class
