﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema

Public Class transrep_2_kat
    Inherits model_base

    'Interne Variablen
    Dim v_id As Integer
    Dim v_amount As Decimal
    Dim v_trans_rep_id As Integer
    Dim v_category_id As Integer

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "transaction_id"
                    If trans_rep_id = Nothing Then
                        result = "Transaktion nicht übergeben"
                        cls_logger.v_logger.Error("Fehler in der Entität transrep_2_kat, es wurde keine TransactionsID übergeben")
                    End If
                Case "amount"
                    If amount = Nothing Then result = "Betrag muss angegeben sein"
                Case "category_id"
                    If category_id = Nothing Then result = "Bitte Kategorie wählen"
            End Select

            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If
            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region

#Region "Mapped"
    <Key>
    Public Property Id As Integer
        Get
            Return v_id
        End Get
        Set(value As Integer)
            If v_id <> value Then
                v_id = value
                NotifyPropertyChanged("Id")
            End If
        End Set
    End Property

    Public Property amount As Decimal
        Get
            Return v_amount
        End Get
        Set(value As Decimal)
            If v_amount <> value Then
                v_amount = value
                NotifyPropertyChanged("amount")
            End If
        End Set
    End Property

    Public Property trans_rep_id As Integer
        Get
            Return v_trans_rep_id
        End Get
        Set(value As Integer)
            If v_trans_rep_id <> value Then
                v_trans_rep_id = value
                NotifyPropertyChanged("trans_rep_id")
            End If
        End Set
    End Property

    Public Property category_id As Integer
        Get
            Return v_category_id
        End Get
        Set(value As Integer)
            If v_category_id <> value Then
                v_category_id = value
                NotifyPropertyChanged("category_id")
            End If
        End Set
    End Property
#End Region

#Region "Navigation Properties"

    Dim v_transrep As transactions_repeat_v01
    Dim v_category As category_v01


    <ForeignKey("trans_rep_id")>
    Public Property transrep As transactions_repeat_v01
        Get
            Return v_transrep
        End Get
        Set(value As transactions_repeat_v01)
            If v_transrep IsNot value Then
                v_transrep = value
                NotifyPropertyChanged("transrep")
            End If
        End Set
    End Property
    <ForeignKey("category_id")>
    Public Property category As category_v01
        Get
            Return v_category
        End Get
        Set(value As category_v01)
            If v_category IsNot value Then
                v_category = value
                NotifyPropertyChanged("category")
            End If
        End Set
    End Property
#End Region

#Region "Extension"
    Dim v_helpname As String
    <NotMapped>
    Public Property bezeichnung_help As String
        Get

            If category Is Nothing Then
                Return v_helpname
            Else
                Return category.bezeichnung
            End If
        End Get
        Set(value As String)
            v_helpname = value
        End Set
    End Property
#End Region

End Class
