﻿Public Class ctrlBudgetSingleLine

    Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        AmountIsWidth = CalculateIsWidth()
    End Sub

#Region "Values"
    Public Shared ReadOnly PropAmountMax As DependencyProperty = DependencyProperty.Register("AmountMax", GetType(Decimal), GetType(ctrlBudgetSingleLine), New UIPropertyMetadata(CDec(100)))
    Public Shared ReadOnly PropAmountIs As DependencyProperty = DependencyProperty.Register("AmountIs", GetType(Decimal), GetType(ctrlBudgetSingleLine), New UIPropertyMetadata(CDec(50)))
    Public Shared ReadOnly PropBackgroundMax As DependencyProperty = DependencyProperty.Register("BackgroundMax", GetType(Brush), GetType(ctrlBudgetSingleLine), New PropertyMetadata(Brushes.Green))
    Public Shared ReadOnly PropBackgroundIs As DependencyProperty = DependencyProperty.Register("BackgroundIs", GetType(Brush), GetType(ctrlBudgetSingleLine), New PropertyMetadata(Brushes.Lime))
    Public Shared ReadOnly PropBackgroundIsOverpass As DependencyProperty = DependencyProperty.Register("BackgroundIsOverpass", GetType(Brush), GetType(ctrlBudgetSingleLine), New PropertyMetadata(Brushes.Red))
    Public Shared ReadOnly PropIsIncome As DependencyProperty = DependencyProperty.Register("IsIncome", GetType(Boolean), GetType(ctrlBudgetSingleLine), New PropertyMetadata(False))

    Public Property AmountMax As Decimal
        Get
            Return CType(GetValue(PropAmountMax), Decimal)
        End Get

        Set(ByVal value As Decimal)
            SetValue(PropAmountMax, value)
        End Set
    End Property

    Public Property AmountIs As Decimal
        Get
            Return CType(GetValue(PropAmountIs), Decimal)
        End Get

        Set(ByVal value As Decimal)
            SetValue(PropAmountIs, value)
            AmountIsWidth = CalculateIsWidth()
        End Set
    End Property

    Public Property BackgroundMax As Brush
        Get
            Return CType(GetValue(PropBackgroundMax), Brush)
        End Get

        Set(ByVal value As Brush)
            SetValue(PropBackgroundMax, value)
        End Set
    End Property

    Public Property BackgroundIsOverpass As Brush
        Get
            Return CType(GetValue(PropBackgroundIsOverpass), Brush)
        End Get

        Set(ByVal value As Brush)
            SetValue(PropBackgroundIsOverpass, value)
        End Set
    End Property

    Public Property BackgroundIs As Brush
        Get
            Return CType(GetValue(PropBackgroundIs), Brush)
        End Get

        Set(ByVal value As Brush)
            SetValue(PropBackgroundIs, value)
        End Set
    End Property

    Public Property IsIncome As Boolean
        Get
            Return CBool(GetValue(PropIsIncome))
        End Get

        Set(ByVal value As Boolean)
            SetValue(PropIsIncome, value)
        End Set
    End Property

    Public Shared ReadOnly PropAmountIsWidthKey As DependencyPropertyKey = DependencyProperty.RegisterReadOnly("AmountIsWidth", GetType(Double), GetType(ctrlBudgetSingleLine), New PropertyMetadata(CDbl(0)))
    Public Shared ReadOnly PropAmountIsWidth As DependencyProperty = PropAmountIsWidthKey.DependencyProperty

    Private Function CalculateIsWidth() As Double
        'Calculate the Width of the Should Object.
        'The Width of the 
        Dim v_realis As Decimal = 0

        If AmountIs > AmountMax Then
            'The AmountIs is bigger than the AmountMax so calculate with a the smaller amountis and set the isbackground to the alternative background.
            v_realis = AmountIs - AmountMax
            BackgroundIs = BackgroundIsOverpass
        Else
            v_realis = AmountIs
        End If
        'According to the formular (isvalue * width)/ amountmax
        Dim v_width_helper As Double = 0
        If ActualWidth = Double.NaN OrElse ActualWidth = 0 Then
            v_width_helper = 1
        Else
            v_width_helper = ActualWidth
        End If
        Dim v_new_width As Decimal = (v_realis * CDec(v_width_helper)) / AmountMax
        Return v_new_width
    End Function

    Public Property AmountIsWidth As Double
        Get
            Return CDbl(GetValue(PropAmountIsWidth))
        End Get
        Protected Set(ByVal value As Double)
            SetValue(PropAmountIsWidthKey, value)
        End Set


    End Property

#End Region

End Class
