﻿Imports System.Collections.ObjectModel
''' <summary>
''' Contains a few properties for having a category added in a periodical report:
''' </summary>
Public Class cls_RepPeriodsCategory
    Inherits GalaSoft.MvvmLight.ObservableObject

    Dim v_catname As String
    Dim v_catid As Integer
    Dim v_income As Boolean = True
    Dim v_totamount As Decimal = 0D

    Sub New()

    End Sub

    Sub New(v_bez As String, v_id As Integer, v_positive As Boolean)
        CatName = v_bez
        CatId = v_id
        isIncome = v_positive
    End Sub

    Public Property CatName As String
        Get
            Return v_catname
        End Get
        Set(value As String)
            If v_catname <> value Then
                v_catname = value
                RaisePropertyChanged("CatName")
            End If
        End Set
    End Property

    Public Property CatId As Integer
        Get
            Return v_catid
        End Get
        Set(value As Integer)
            If v_catid <> value Then
                v_catid = value
                RaisePropertyChanged("CatId")
            End If
        End Set
    End Property

    Public Property isIncome As Boolean
        Get
            Return v_income
        End Get
        Set(value As Boolean)
            If v_income <> value Then
                v_income = value
                RaisePropertyChanged("isIncome")
            End If
        End Set
    End Property

    Public Property TotAmount As Decimal
        Get
            Return v_totamount
        End Get
        Set(value As Decimal)
            If v_totamount <> value Then
                v_totamount = value
                RaisePropertyChanged("TotAmount")
            End If
        End Set
    End Property

    Public Function PeriodTotAmount(v_periodname As String) As Decimal
        If String.IsNullOrEmpty(v_periodname) Then Return 0
        Dim v_period As cls_repperiod_perioditem = Periods.Where(Function(x) x.Bezeichnung = v_periodname).FirstOrDefault
        If v_period Is Nothing Then Return 0
        Return v_period.Amount
    End Function

    Public Property Periods As New ObservableCollection(Of cls_repperiod_perioditem)


End Class
