﻿Imports System.Text
Imports MahApps.Metro.Controls.Dialogs

Public Class ucl_verwaltung_category
    Private Async Sub dataGrid_PreviewExecuted(sender As Object, e As ExecutedRoutedEventArgs)
        If e.Command Is DataGrid.DeleteCommand Then
            Dim v_dg As DataGrid = DirectCast(sender, DataGrid)

            'Check if delete operation is possible
            Dim v_delete_string As New StringBuilder
            v_delete_string.AppendLine("Wollen Sie folgende Elemente löschen?")
            Dim v_delete_errorstring As New StringBuilder
            v_delete_errorstring.AppendLine("Folgende Elemente sind verknüpft und können nicht gelöscht werden:")
            Dim v_error As Boolean = False
            For Each v_obj As category_v01 In v_dg.SelectedItems
                v_delete_string.AppendLine(v_obj.bezeichnung)
                With v_obj
                    If .nv_category_2_budcat.Count > 0 Or .nv_cat_2_transtemp.Count > 0 Or .nv_cat_trans2kat.Count > 0 Or .nv_subcats.Count > 0 Then
                        v_delete_errorstring.AppendLine(v_obj.bezeichnung)
                        v_error = True
                    End If
                End With
            Next


            Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
            If v_error Then
                If v_mainwindow IsNot Nothing Then
                    Await v_mainwindow.ShowMessageAsync("Fehler", "Eine oder mehrere Kategorien können nicht gelöscht werden", MessageDialogStyle.Affirmative)
                End If
                e.Handled = True
                Exit Sub
            Else
                Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
                Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Frage", v_delete_string.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)
                If result = MessageDialogResult.Negative Then e.Handled = True
            End If
        End If
    End Sub

    Private Sub dataGrid_RowEditEnding(sender As Object, e As DataGridRowEditEndingEventArgs)
        Dim v_categories As ListCollectionView = DirectCast(DirectCast(sender, DataGrid).ItemsSource, ListCollectionView)
        If e.EditAction = DataGridEditAction.Commit Then
            Dim v_cat As category_v01 = TryCast(e.Row.DataContext, category_v01)
            v_cat.EndEdit()
            If v_categories.IsAddingNew Then v_categories.CommitNew()
            If v_categories.IsEditingItem Then v_categories.CommitEdit()
        Else
            If v_categories.IsAddingNew Then v_categories.CancelNew()
            If v_categories.IsEditingItem Then v_categories.CancelEdit()
        End If
    End Sub
End Class