﻿Imports System.Text
Imports MahApps.Metro.Controls.Dialogs

Public Class ucl_verwaltung_person
    Private Async Sub DataGrid_PreviewExecuted(sender As Object, e As ExecutedRoutedEventArgs)
        If e.Command Is DataGrid.DeleteCommand Then
            Dim v_dg As DataGrid = DirectCast(sender, DataGrid)

            'Check if delete Operation is possible:
            Dim v_delete_string As New StringBuilder
            v_delete_string.AppendLine("Wollen Sie folgende Elemente löschen?")
            Dim v_delete_errorstring As New StringBuilder
            v_delete_errorstring.AppendLine("Folgende Elemente sind verknüpft oder vordefiniert und können nicht gelöscht werden:")
            Dim v_error As Boolean = False
            For Each v_obj As person_v01 In v_dg.SelectedItems
                v_delete_string.AppendLine(v_obj.bezeichnung)
                'Predefined Values can't be deleted
                If v_obj.predefined Then
                    v_delete_errorstring.AppendLine(v_obj.bezeichnung)
                    v_error = True
                End If
                If v_obj.nv_person_trans.Count > 0 Or v_obj.nv_person_2_transtemp.Count > 0 Then
                    v_delete_errorstring.AppendLine(v_obj.bezeichnung)
                    v_error = True
                End If
            Next

            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            If v_error Then
                Await vMainWindow.ShowMessageAsync("Hinweis", v_delete_errorstring.ToString, MessageDialogStyle.Affirmative)
                e.Handled = True
                Exit Sub
            Else
                Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
                Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Frage", v_delete_string.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)
                If result = MessageDialogResult.Negative Then e.Handled = True
            End If
        End If
    End Sub
End Class
