﻿
Imports System.Data.Entity
Imports GalaSoft.MvvmLight
Imports MahApps.Metro.Controls.Dialogs
Imports System.Windows.Threading
Imports System.Collections.Specialized
Imports System.Threading
Imports System.ComponentModel
Imports System.Configuration
Imports System.Text

Namespace HHHB3.ViewModel
    ''' <summary>
    ''' This class contains properties that the main View can data bind to.
    ''' <para>
    ''' Use the <strong>mvvminpc</strong> snippet to add bindable properties to this ViewModel.
    ''' </para>
    ''' <para>
    ''' You can also use Blend to data bind with the tool's support.
    ''' </para>
    ''' <para>
    ''' See http://www.galasoft.ch/mvvm
    ''' </para>
    ''' </summary>
    Partial Public Class MainViewModel
        Inherits ViewModelBase

        'Live Filterung usw:
        'http://www.jonathanantoine.com/2011/10/05/wpf-4-5-%E2%80%93-part-10-live-shaping/

        'Central class which contains all filters
        Dim Filters As New Filters.all_filters

        'Mahapps Metro DialogCoordinator:
        'at the moment causes some problems when sometimes not displaying the message.
        'Public mahapps_dialog As New DialogCoordinator

        'dispatcher for application
        Private dispatcher As Dispatcher = Dispatcher.CurrentDispatcher

        'Toaster Class:
        Dim ctoast As New cls_toaster_win10

        'Collection of Collections which should attend the INotifycollectionchanged
        Public ICollectionChanged_Collections As INotifyCollectionChanged()

        'Global Busyindicator Status:
        Dim v_isbusy As Boolean = True
        Public Property GlobalBusy As Boolean
            Get
                Return v_isbusy
            End Get
            Set(value As Boolean)
                If v_isbusy <> value Then
                    v_isbusy = value
                    RaisePropertyChanged("GlobalBusy")
                End If
            End Set
        End Property

        ''' <summary>
        ''' Initializes a new instance of the MainViewModel class.
        ''' </summary>
        '''/if (IsInDesignMode)
        '''/{
        '''/    // Code runs in Blend --> create design time data.
        '''/}
        '''/else
        '''/{
        '''/    // Code runs "for real"
        '''/}

        Dim dbo As New hhhb3_model

        Public ReadOnly Property CurrentDatabasePath As String = GetValueFromRegistryKey("db_lastused")

        Public Sub New()
            'Initialisierung des Modells
            Try
                dbo.GetValidationErrors()
            Catch ex As Exception
                If ex.HResult = -2147467259 Then
                    'Database Path is not valid
                    'Clear the path in the registry and restart
                    cls_logger.v_logger.Error("Database Path invalid restart Application with empty lastused path")
                    SetValueFromRegistryKey("db_lastused", "")
                    Dim v_msg As New StringBuilder("Der angegebene Datenbankpfad ist nicht gültig oder kann nicht erreicht werden.")
                    v_msg.AppendLine("Wollen Sie das Programm neu starten?")

                    If MessageBox.Show(v_msg.ToString, "Frage", MessageBoxButton.YesNo, MessageBoxImage.Question) = MessageBoxResult.Yes Then
                        If isRestart = False Then
                            Process.Start(Application.ResourceAssembly.Location, "-isrestart")
                            _Splash.Dispatcher.BeginInvoke(DirectCast(AddressOf CleanUpSplash, Action))
                            Application.Current.Shutdown()
                        Else
                            Environment.Exit(0)
                        End If
                    End If
                    Environment.Exit(0)
                Else
                    Debug.Print(ex.Message)
                    MessageBox.Show("Programm wird beendet, folgender Fehler ist aufgetreten: " & Environment.NewLine & ex.Message, "Validierungsfehler", MessageBoxButton.OK, MessageBoxImage.Error)
                    cls_logger.v_logger.Error("GetValidation Error: " & ex.ToString)
                    Environment.Exit(0)
                End If
            End Try

            'Entitäten laden:
            TrySplashMessage("Themes laden")
            ThemesLoad()
            TrySplashMessage("Menü laden")
            MenuLoad()
            TrySplashMessage("Einstellungen laden")
            SettingsLoad()
            TrySplashMessage("Backupsystem laden")
            BackupLoad()
            TrySplashMessage("Nachrichtensystem laden")
            MessageLoad()
            'Backup durchführen:
#If Not DEBUG Then
            If SettingsCurrent.backup_onstartup Then
                TrySplashMessage("Backup durchführen")
                execute_backup()
            End If
#End If

            TrySplashMessage("Typen laden")
            TypenLoad()
            TrySplashMessage("Status laden")
            StatusLoad()
            TrySplashMessage("Empfänger laden")
            ReceiverLoad()
            TrySplashMessage("Personen laden")
            PersonenLoad()
            TrySplashMessage("Tags laden")
            TagsLoad()
            TrySplashMessage("Kategorien laden")
            CategoriesLoad()
            TrySplashMessage("Dokumentenablage initialisieren")
            DocumentsLoad()
            TrySplashMessage("Ordner laden")
            FoldersLoad()
            TrySplashMessage("Buchungen laden")
            TransactionsLoad()
            TrySplashMessage("Wiederholungsbuchungen laden")
            TransactionsRepeatLoad()
            TrySplashMessage("Vorlagen laden")
            TransactionsTemplateLoad()
            TrySplashMessage("Konten laden")
            KontenLoad()
            BookingJournalLoad()
            TimeFramesTargetLoad()
            TrySplashMessage("Sparziele laden")
            SavingTargetsLoad()
            TimeFramesViewLoad()
            TimeFramesLoad()
            TrySplashMessage("Budgets laden")
            BudgetsLoad()
            TrySplashMessage("Diagramme laden")
            ChartsLoadAndUpdate()
            TrySplashMessage("Berichte laden")
            TimeFramesPeriodsReportLoad()
            ReportsLoad()
            TrySplashMessage("Zuletzt benutzte Datenbanken laden")
            InitLastUsedDBs()
            TrySplashMessage("Jumplist aktivieren")
            activate_jumplist()
            TrySplashMessage("Programminformationen laden")
            InitSpecialFolders()
            TrySplashMessage("About laden")
            AboutLoad()
            TrySplashMessage("Vorgaben setzen")
            SetPresets()
            TrySplashMessage("Dashboard laden")
            DashboardLoad()
            'Note: the Transactions_RepExecute is called after the Mainwindow is loaded otherwise the MetroDialog won't work.
            'Initiate DocWachter:
#If Not DEBUG Then
            TrySplashMessage("Dokumentenüberwachung starten")
            If SettingsCurrent.doc_watcher_use Then
                InitDocWatcher()
                TrySplashMessage("Dokumentenüberwachung wurde gestartet")
            End If
#End If
            'Set Search Entities:
            TrySplashMessage("Gespeicherte Suchen laden")
            SearchesLoad()
            GlobalBusy = False
            TrySplashMessage("Startup abgeschlossen")

        End Sub

        Private Sub checktoaster_cmd()
            'If ctoast.TryCreateShortcut Then
            'ctoast.ShowToastButton_Click()
            ctoast.define_toaster("Überschrift", "Toaster wird beim speichern nur im Debug Mode angezeigt.", Windows.UI.Notifications.ToastTemplateType.ToastImageAndText04, False, "Zeile2")
            'End If
        End Sub


        Private Sub SetPresets()
            preset_date = Date.Now
            preset_receiver_id = CType(Receivers_Aktiv.CurrentItem, receiver_v01).rec_id
            preset_status_id = CType(TransStatus_Aktiv.CurrentItem, trans_status_v01).status_id
            preset_person_id = CType(Persons_Aktiv.CurrentItem, person_v01).pers_id
        End Sub


        'Defining Standard Values:
        Dim v_preset_date As Date = Date.Now
        Public Property preset_date As Date
            Get
                Return v_preset_date
            End Get
            Set(value As Date)
                If v_preset_date <> value Then
                    v_preset_date = value
                    RaisePropertyChanged("preset_date")
                End If
            End Set
        End Property

        Dim v_preset_receiver_id As Integer
        Public Property preset_receiver_id As Integer
            Get
                Return v_preset_receiver_id
            End Get
            Set(value As Integer)
                v_preset_receiver_id = value
                RaisePropertyChanged("preset_receiver_id")
            End Set
        End Property

        Dim v_preset_status_id As Integer
        Public Property preset_status_id As Integer
            Get
                Return v_preset_status_id
            End Get
            Set(value As Integer)
                v_preset_status_id = value
                RaisePropertyChanged("preset_status_id")
            End Set
        End Property

        Dim v_preset_person_id As Integer
        Public Property preset_person_id As Integer
            Get
                Return v_preset_person_id
            End Get
            Set(value As Integer)
                v_preset_person_id = value
                RaisePropertyChanged("preset_person_id")
            End Set
        End Property

        Public Property cmdSaveAll As New RelayCommand(AddressOf SaveAll)

        Private Sub SaveAll()
            dbo.SaveChanges()
        End Sub


#Region "Admin Commands"
        Public Property cmdRecalculateAll As New RelayCommand(AddressOf RecalculateAll, Function() __konten IsNot Nothing AndAlso __konten.Count > 0 AndAlso __transactions IsNot Nothing AndAlso __transactions.Count > 0)
        Public Property cmdRecalculateAccounts As New RelayCommand(AddressOf RecalculateAccounts, Function() __konten IsNot Nothing AndAlso __konten.Count > 0)

        ''' <summary>
        ''' This command recalculates all totalamounts of all Transactions and accounts
        ''' </summary>
        Private Async Sub RecalculateAll()
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Neuberechnung durchführen", "Es wird eine Neuberechnung aller Gesamtwerte der Transaktionen und Konten durchgeführt. Die Ausführung kann je nach Anzahl der Buchungen eine gewisse Zeit dauern. Wollen Sie die Neuberechnung jetzt durchführen?", MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            If result = MessageDialogResult.Affirmative Then
                Dim thr_start As ThreadStart = Sub()
                                                   Application.Current.Dispatcher.Invoke(New Action(Sub()
                                                                                                        For Each v_trans As transactions_v01 In __transactions
                                                                                                            v_trans.TotAmountCalc()
                                                                                                            Debug.Print("Durchlauf Transaktion")
                                                                                                        Next
                                                                                                        For Each v_kto As konto_v01 In __konten
                                                                                                            v_kto.Totalamount_Calculate()
                                                                                                            Debug.Print("Durchlauf Konto")
                                                                                                        Next
                                                                                                        dbo.SaveChanges()
                                                                                                    End Sub))
                                               End Sub
                Dim thr As New Thread(thr_start)
                thr.Start()
                Do While thr.ThreadState = ThreadState.Running
                Loop
                Await vMainWindow.ShowMessageAsync("Berechnung abgeschlossen", "Die Gesamtwerte aller Buchungen und Konten wurden neu berechnet")
            End If
        End Sub

        Private Async Sub RecalculateAccounts()
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Neuberechnung durchführen", "Es wird eine Neuberechnung aller Gesamtwerte der Konten durchgeführt. Die Ausführung kann je nach Anzahl der Konten eine gewisse Zeit dauern. Wollen Sie die Neuberechnung jetzt durchführen?", MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            If result = MessageDialogResult.Affirmative Then
                Dim thr_start As ThreadStart = Sub()
                                                   Application.Current.Dispatcher.Invoke(New Action(Sub()
                                                                                                        For Each v_kto As konto_v01 In __konten
                                                                                                            v_kto.Totalamount_Calculate()
                                                                                                            Debug.Print("Durchlauf Konto")
                                                                                                        Next
                                                                                                        dbo.SaveChanges()
                                                                                                    End Sub))
                                               End Sub
                Dim thr As New Thread(thr_start)
                thr.Start()
                Do While thr.ThreadState = ThreadState.Running
                Loop
                Await vMainWindow.ShowMessageAsync("Berechnung abgeschlossen", "Die Gesamtwerte aller Konten wurden neu berechnet")
            End If
        End Sub

        Public Property cmdRepairDB As New RelayCommand(AddressOf RepairDB)

        Private Async Sub RepairDB()
            'Shrinks the current database:
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Datenbank reparieren", "Die aktuelle Datenbank wird komprimiert und bereinigt, vor Ausführung sollte ein Backup durchgeführt werden. Wollen Sie fortfahren?", MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            If result = MessageDialogResult.Affirmative Then
                Dim config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None)
                Dim connectionStringsSection = DirectCast(config.GetSection("connectionStrings"), ConnectionStringsSection)
                Dim v_constring As String = connectionStringsSection.ConnectionStrings("hhhb3_model").ConnectionString
                If Not String.IsNullOrEmpty(v_constring) Then
                    Dim engine As New System.Data.SqlServerCe.SqlCeEngine(v_constring)
                    engine.Shrink()
                End If
            End If
        End Sub

#End Region


    End Class
End Namespace