﻿Imports System.Collections.ObjectModel
Imports System.Collections.Specialized
Imports System.Text
Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Part of MVM for Archiv
        Dim m_ArchivDisplay As ListCollectionView

        Public Property ArchivDisplay As ListCollectionView
            Get
                Return m_ArchivDisplay
            End Get
            Set(value As ListCollectionView)
                m_ArchivDisplay = value
                RaisePropertyChanged("ArchivDisplay")
            End Set
        End Property

        Public Property cmdArchivShowElement As New RelayCommand(Of String)(Sub(p) ArchivShowElement(p), Function(p) ArchivShowElementCanExecute(p))
        Public Property cmdArchivRestoreElement As New RelayCommand(AddressOf ArchivRestoreElement, AddressOf ArchivRestoreElementCanExecute)
        ''' <summary>
        ''' This command is necessary to receive the currently selected Repeat Transactions from the containing listview of the view
        ''' Command is necessary because datagrid selecteditems is not a dependency property see:
        ''' http://blog.galasoft.ch/posts/2010/05/handling-datagrid-selecteditems-in-an-mvvm-friendly-manner/
        ''' </summary>
        ''' <returns></returns>
        Public Property cmdArchivSelectionChanged As New RelayCommand(Of IList)(Sub(p) ArchivSelectionChanged(p))

        Private Sub ArchivShowElement(v_typ As String)
            If v_typ = Nothing OrElse v_typ = "" OrElse v_typ Is String.Empty Then Exit Sub
            Select Case True
                Case v_typ = "Folder"
                    ArchivDisplay = Folders_Inaktiv
                Case v_typ = "Konto"
                    ArchivDisplay = Konten_Inaktiv
                Case v_typ = "Budget"
                    ArchivDisplay = Budgets_InAktiv
                Case Else
                    ArchivDisplay = Nothing
            End Select
        End Sub

        Private Function ArchivShowElementCanExecute(v_typ As String) As Boolean
            Dim v_return As Boolean = False
            Select Case True
                Case v_typ = "Folder"
                    If Folders_Inaktiv.Count > 0 Then v_return = True
                Case v_typ = "Konto"
                    If Konten_Inaktiv.Count > 0 Then v_return = True
                Case v_typ = "Budget"
                    If Budgets_InAktiv.Count > 0 Then v_return = True
                Case Else
                    v_return = False
            End Select
            Return v_return
        End Function

        Private Async Sub ArchivRestoreElement()
            If ArchivSelectedItems Is Nothing OrElse ArchivSelectedItems.Count = 0 Then Exit Sub
            'New status is selected
            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie folgenden Elemente wieder aktivieren?")
            For Each v_item As Object In ArchivSelectedItems
                Select Case True
                    Case TypeOf (v_item) Is folder_v01
                        v_strbuilder.AppendLine("Ordner - " & DirectCast(v_item, folder_v01).bezeichnung)
                    Case TypeOf (v_item) Is konto_v01
                        v_strbuilder.AppendLine("Konto - " & DirectCast(v_item, konto_v01).bezeichnung)
                    Case TypeOf (v_item) Is budget_v01
                        v_strbuilder.AppendLine("Budget - " & DirectCast(v_item, budget_v01).bezeichnung)
                    Case Else
                        v_strbuilder.AppendLine("unbekanntes Element")
                End Select
            Next
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Objekte aktivieren", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then

                For i As Integer = ArchivSelectedItems.Count - 1 To 0 Step -1
                    Dim v_item As Object = ArchivSelectedItems(i)
                    Select Case True
                        Case TypeOf (v_item) Is folder_v01
                            Dim v_element As folder_v01 = DirectCast(v_item, folder_v01)
                            With v_element
                                .BeginEdit()
                                .aktiv = True
                                .EndEdit()
                                Folders.EditItem(v_element)
                                Folders.CommitEdit()
                                __folders_CollectionChanged(Me, Nothing)
                            End With
                            dbo.SaveChanges()
                        Case TypeOf (v_item) Is konto_v01
                            DirectCast(v_item, konto_v01).aktiv = True
                            Dim v_konto As konto_v01 = DirectCast(v_item, konto_v01)
                            With v_konto
                                .BeginEdit()
                                .aktiv = True
                                .EndEdit()
                                dbo.SaveChanges()
                                __konten_CollectionChanged(Me, Nothing)
                                If Not v_konto.nv_folder_2_konto_back Is Nothing Then v_konto.nv_folder_2_konto_back.refresh_konto_filter()
                            End With
                        Case TypeOf (v_item) Is budget_v01
                            Dim v_budget As budget_v01 = DirectCast(v_item, budget_v01)
                            With v_budget
                                .BeginEdit()
                                .aktiv = True
                                .EndEdit()
                                dbo.SaveChanges()
                                __budgets_CollectionChanged(Me, Nothing)
                            End With
                    End Select
                Next
            End If

            dbo.ChangeTracker.DetectChanges()

        End Sub

        Private Function ArchivRestoreElementCanExecute() As Boolean
            If ArchivSelectedItems Is Nothing OrElse ArchivSelectedItems.Count = 0 Then Return False
            Return True
        End Function

        Dim ArchivSelectedItems As IList(Of Object) = Nothing

        Private Sub ArchivSelectionChanged(v_selected_items As IList)
            If Not ArchivSelectedItems Is Nothing Then ArchivSelectedItems.Clear()
            ArchivSelectedItems = CType(v_selected_items, System.Collections.IList).Cast(Of Object).Cast(Of Object).ToList
        End Sub

    End Class
End Namespace
