﻿Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
#Region "Backupsystem"

        ''' <summary>
        ''' Initializes the backup system
        ''' </summary>
        Private Async Sub BackupLoad()
            'Should a backup be done?
            If SettingsCurrent.backup_onstartup Or SettingsCurrent.backup_onshutdown Then
                If SettingsCurrent.backup_path = "" Then
                    ctoast.define_toaster("Backupsystem", "ist deaktiviert", Windows.UI.Notifications.ToastTemplateType.ToastImageAndText04, True, "Grund: Kein Pfad vorhanden")
                    SettingsCurrent.backup_onshutdown = False
                    SettingsCurrent.backup_onstartup = False
                    dbo.SaveChanges()
                Else
                    If Not IO.Directory.Exists(SettingsCurrent.backup_path) Then
                        Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
                        Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
                        Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Backup-System ", "Das Backupsystem ist deakiviert." & Environment.NewLine & "Soll ein Ordner definiert werden?", MessageDialogStyle.AffirmativeAndNegative, dia_settings)

                        If result = MessageDialogResult.Affirmative Then
                            Try
                                IO.Directory.CreateDirectory(SettingsCurrent.backup_path)
                            Catch ex As Exception
                                ctoast.define_toaster("Backupsystem", "ist deaktiviert", Windows.UI.Notifications.ToastTemplateType.ToastImageAndText04, True, "Grund: Ordner konnte nicht erstellt werden")
                                SettingsCurrent.backup_onshutdown = False
                                SettingsCurrent.backup_onstartup = False
                                dbo.SaveChanges()
                            End Try
                        Else
                            ctoast.define_toaster("Backupsystem", "ist deaktiviert", Windows.UI.Notifications.ToastTemplateType.ToastImageAndText04, True, "Grund: Kein Pfad vorhanden")
                        End If
                    End If
                End If
            End If
        End Sub
        Public Sub execute_backup()
            If IO.Directory.Exists(SettingsCurrent.backup_path) Then
                'Prüfen wieviele Dateien bereits im Ordner sind:
                Dim v_filecount As Integer = 0
                Dim v_dir As New IO.DirectoryInfo(SettingsCurrent.backup_path)
                Dim v_fileext As String = ".hhdb3"

                v_filecount = IO.Directory.GetFiles(SettingsCurrent.backup_path, "*" & v_fileext, IO.SearchOption.TopDirectoryOnly).Length
                'Wenn weniger Dateien sind als die Vorgabe dann backup durchführen:
                Do While v_filecount >= SettingsCurrent.backup_count
                    'Älteste Datei löschen:
                    Dim v_time As DateTime = DateTime.MaxValue
                    Dim v_filename As String = ""
                    For Each v_fileinfo As IO.FileInfo In v_dir.GetFiles
                        If v_fileinfo.Extension = v_fileext Then
                            If v_fileinfo.CreationTime < v_time Then
                                v_time = v_fileinfo.CreationTime
                                v_filename = v_fileinfo.FullName
                            End If
                        End If
                    Next
                    Try
                        If IO.File.Exists(v_filename) Then IO.File.Delete(v_filename)
                    Catch ex As Exception
                        Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
                        v_mainwindow.ShowMessageAsync("Backup-System", "Ältestes Backup konnte nicht gelöscht werden" & Environment.NewLine & "Backup wird dennoch erstellt, maximale Backupanzahl könnte überschritten werden", MessageDialogStyle.Affirmative)
                    End Try
                    v_filecount = IO.Directory.GetFiles(SettingsCurrent.backup_path, "*" & v_fileext, IO.SearchOption.TopDirectoryOnly).Length
                Loop

                Dim v_lastused_db_path As String = GetValueFromRegistryKey("db_lastused")

                'Backup ausführen:
                If IO.File.Exists(v_lastused_db_path) Then
                    Dim v_newfilename As String = SettingsCurrent.backup_path & "\" & IO.Path.GetFileNameWithoutExtension(v_lastused_db_path) & "_" & Date.Now.Year & Date.Now.Month & Date.Now.Day & "_" & Date.Now.Hour.ToString & Date.Now.Minute.ToString & Date.Now.Second.ToString & IO.Path.GetExtension(v_lastused_db_path)
                    If Not IO.File.Exists(v_newfilename) Then
                        IO.File.Copy(v_lastused_db_path, v_newfilename)
                    End If
                    Dim v_header As String = "Backup-System"
                    Dim v_message As String = "Backup wurde erfolgreich durchgeführt"
                    ctoast.define_toaster(v_header, v_message, Windows.UI.Notifications.ToastTemplateType.ToastImageAndText04, True)
                    MessageAdd(New message_v01(v_header, v_message, False, 1, 0))
                    v_header = Nothing
                    v_message = Nothing
                End If
            End If
        End Sub
#End Region


    End Class
End Namespace
