﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Data.Entity
Imports System.IO
Imports System.Printing
Imports System.Text
Imports System.Threading
Imports System.Windows.Markup
Imports System.Xml
Imports LiveCharts
Imports LiveCharts.Wpf
Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Budgets:

        Private WithEvents __budgets As New ObservableCollection(Of budget_v01)
        Public Property Budgets As ListCollectionView
        Public Property Budgets_Aktiv As ListCollectionView
        Public Property Budgets_InAktiv As ListCollectionView

        Public Property Budgets_Fokus As New List(Of Tuple(Of String, String, String)) From
        {
            Tuple.Create("wöchentlich", "week", "Woche"),
            Tuple.Create("monatlich", "month", "Monat"),
            Tuple.Create("viertel-jährlich", "quarteryear", "Quartal"),
            Tuple.Create("halb-jährlich", "halfyear", "Halbjahr"),
            Tuple.Create("jährlich", "year", "Jahr")
        }

        Private Sub BudgetsLoad()
            __budgets.Clear()
            dbo.m_budget_v01.Load
            dbo.m_budget_2_cat_v01.Load
            dbo.m_budget2cat_2_value_v01.Load
            __budgets = dbo.m_budget_v01.Local
            Budgets = New ListCollectionView(__budgets)
            Budgets_Aktiv = New ListCollectionView(__budgets) With {
                .Filter = New Predicate(Of Object)(AddressOf Filters.BudgetsAktiv)}
            Budgets_InAktiv = New ListCollectionView(__budgets) With {
                .Filter = New Predicate(Of Object)(AddressOf Filters.BudgetsInAktiv)}
        End Sub


        Private Sub __budgets_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __budgets.CollectionChanged
            If Not Budgets Is Nothing Then
                If Not Budgets.MoveCurrentToNext Then Budgets.MoveCurrentToPrevious()
            End If
            If Not Budgets_Aktiv Is Nothing Then
                If Not Budgets_Aktiv.MoveCurrentToNext Then Budgets_Aktiv.MoveCurrentToPrevious()
                If Not Budgets_Aktiv.IsAddingNew Or Budgets_Aktiv.IsEditingItem Then Budgets_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.BudgetsAktiv)
            End If
            If Not Budgets_InAktiv Is Nothing Then
                If Not Budgets_InAktiv.MoveCurrentToNext Then Budgets_InAktiv.MoveCurrentToPrevious()
                If Not Budgets_InAktiv.IsAddingNew Or Budgets_InAktiv.IsEditingItem Then Budgets_InAktiv.Filter = New Predicate(Of Object)(AddressOf Filters.BudgetsInAktiv)
            End If
        End Sub

#Region "Commands"

        Public Property cmdBudgetAdd As New RelayCommand(AddressOf BudgetAdd, AddressOf BudgetAddCanExecute)
        Public Property cmdBudgetEdit As New RelayCommand(Of budget_v01)(Sub(p) BudgetEdit(p), Function(p) p IsNot Nothing)
        Public Property cmdBudgetOpen As New RelayCommand(Of budget_v01)(Sub(p) MenuAdd(p), Function(p) p IsNot Nothing)
        Public Property cmdBudgetDelete As New RelayCommand(Of budget_v01)(Sub(p) BudgetDelete(p), Function(p) p IsNot Nothing)
        Public Property cmdBudgetImage As New RelayCommand(Of budget_v01)(Sub(p) BudgetImage(p), Function(p) p IsNot Nothing)
        Public Property cmdBudgetArchive As New RelayCommand(Of budget_v01)(Sub(p) BudgetArchive(p), Function(p) p IsNot Nothing)
        Public Property cmdBudgetSummary As New RelayCommand(Of budget_v01)(Sub(p) BudgetDoReport(p), Function(p) p IsNot Nothing)
        Public Property cmdBudgetPrint As New RelayCommand(Of budget_v01)(Sub(p) BudgetPrint(p), Function(p) p IsNot Nothing)
        Public Property cmdBudgetCategorySearch As New RelayCommand(Of budget2cat_2_value_v01)(Sub(p) BudgetCategorySearch(p), Function(p) p IsNot Nothing)

        'New Category Commands:
        Public Property cmdBudgetKatIncomeAdd As New RelayCommand(Of budget_v01)(Sub(p) BudgetKatIncomeAdd(p), Function(p) BudgetKatIncomeExpendAddCanExecute(p))
        Public Property cmdBudgetKatExpendAdd As New RelayCommand(Of budget_v01)(Sub(p) BudgetKatExpendAdd(p), Function(p) BudgetKatIncomeExpendAddCanExecute(p))
        Public Property cmdBudgetBudCatEdit As New RelayCommand(Of budget_2_cat_v01)(Sub(p) BudgetBudCatEdit(p), Function(p) BudgetBudCatEditCanExecute(p))
        Public Property cmdBudgetBudCatDelete As New RelayCommand(Of budget_2_cat_v01)(Sub(p) BudgetBudCatDelete(p), Function(p) p IsNot Nothing)
        Public Property cmdBudgetCategorySetDivided As New RelayCommand(Of budget_2_cat_v01)(Sub(p) BudgetCategorySetDivided(p), Function(p) BudgetCategorySetDividedAllCanExecute(p))
        Public Property cmdBudgetCategorySetAll As New RelayCommand(Of budget_2_cat_v01)(Sub(p) BudgetCategorySetAll(p), Function(p) BudgetCategorySetDividedAllCanExecute(p))




        Private Sub BudgetAdd()
            'Add a new budget.
            Dim v_dia As New frm_budget_addedit
            Dim v_newbudget As New budget_v01
            With v_dia
                .Title = "Budget hinzufügen"
                .DataContext = v_newbudget
                .ShowDialog()
                If .DialogResult Then
                    Budgets_Aktiv.AddNewItem(v_newbudget)
                    Budgets_Aktiv.CommitNew()
                    Budgets_Aktiv.Filter = Nothing
                    Budgets_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.BudgetsAktiv)
                    Budgets_Aktiv.Refresh()
                    RaisePropertyChanged("Budgets_Aktiv")
                    dbo.SaveChanges()
                End If
            End With
        End Sub

        Private Function BudgetAddCanExecute() As Boolean
            If __konten.Count = 0 Then Return False
            If __transactions.Count = 0 Then Return False
            If __categories.Count = 0 Then Return False
            Return True
        End Function

        Private Sub BudgetEdit(v_budget As budget_v01)
            If v_budget Is Nothing Then Exit Sub
            v_budget.BeginEdit()
            Dim v_dia As New frm_budget_addedit
            With v_dia
                .Title = "Budget bearbeiten"
                .DataContext = v_budget
                .ShowDialog()
                If .DialogResult Then
                    v_budget.EndEdit()
                    dbo.SaveChanges()
                Else
                    v_budget.CancelEdit()
                End If
            End With
        End Sub
        Private Async Sub BudgetDelete(v_budget As budget_v01)
            If v_budget Is Nothing Then Exit Sub
            'New status is selected
            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie das Budget " & v_budget.bezeichnung & " wirklich löschen?")
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Budget löschen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                __budgets.Remove(v_budget)
                dbo.SaveChanges()
                dbo.ChangeTracker.DetectChanges()
            End If
        End Sub

        Private Sub BudgetImage(v_budget As budget_v01)
            If v_budget Is Nothing Then Exit Sub
            Dim v_image As Byte() = get_symbol_from_dialog()
            If v_image IsNot Nothing Then
                v_budget.symbol = v_image
            End If
        End Sub

        Private Async Sub BudgetArchive(v_budget As budget_v01)
            If v_budget Is Nothing Then Exit Sub
            'New status is selected
            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie das Budget " & v_budget.bezeichnung & " wirklich archivieren?")

            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Budget archivieren", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then

                With v_budget
                    .BeginEdit()
                    .aktiv = False
                    .EndEdit()
                End With
                __budgets_CollectionChanged(Me, Nothing)
                dbo.SaveChanges()
            End If
        End Sub

        Private Sub BudgetDoReport(v_budget As budget_v01)
            With v_budget
                GlobalBusy = True
                'Notify the gui that all values should be reevaluted:
                v_budget.notify_changes()
                'Notify all subcats:
                For Each v_subcat As budget_2_cat_v01 In v_budget.nv_budget_2_budcat
                    For Each v_value As budget2cat_2_value_v01 In v_subcat.nv_budget2cat_2_value
                        v_value.notify_all()
                    Next
                    v_subcat.notify_all()
                Next
                v_budget.budget_report = create_report_document(v_budget)
                'Create Diagramms:
                BudgetChartUpdate(v_budget)
                .notify_changes()
                GlobalBusy = False
            End With
        End Sub

        Private Function create_report_document(v_budget As budget_v01) As FlowDocument

            'For one of the next iterations consider to simplify the budget creating process by using some nice subroutines...
            'at the moment some things are double coded not very beautiful.

            If v_budget Is Nothing Then Return Nothing
            If v_budget.nv_budget_2_budcat Is Nothing OrElse v_budget.nv_budget_2_budcat.Count = 0 Then Return Nothing
            'Flowdocument prepared to be printed on landscape A4

            Dim v_rep_local As New FlowDocument With {.PageWidth = 1104, .ColumnGap = 0, .IsColumnWidthFlexible = True, .PageHeight = 768, .ColumnWidth = 1104}

            Dim v_rowcount As Integer = 1
            Dim v_oddrowbrush As Brush = SettingsCurrent.color_background_oddrow_brush
            Dim v_justrowbrush As Brush = SettingsCurrent.color_background_justrow_brush
            Dim v_headerbackgroundbrush As Brush = SettingsCurrent.color_background_header_brush
            Dim v_header_fontsize As Double = SettingsCurrent.header_fontsize - 10
            Dim v_row_fontsize As Double = SettingsCurrent.row_fontsize - 4
            Dim v_foreground_textcolor As Brush = Brushes.Black

            'Defines the headers for table Income and Expends
            Dim v_header As New Dictionary(Of String, Integer) From {
                    New KeyValuePair(Of String, Integer)(“Kategorie", 20),
                    New KeyValuePair(Of String, Integer)("Legende", 15)}

            'Now add all the other columns depending on the settings of the budget:
            For Each v_item As budget2cat_2_value_v01 In v_budget.nv_budget_2_budcat.FirstOrDefault.nv_budget2cat_2_value
                v_header.Add(New KeyValuePair(Of String, Integer)(v_item.bezeichnung, 15))
            Next
            'Add the last Column:
            v_header.Add(New KeyValuePair(Of String, Integer)("Auswertung", 20))


            'Define the report:
            With v_rep_local
                .Blocks.Clear()
                'Header:
                .Blocks.Add(New Paragraph(New Run(v_budget.bezeichnung)) With {.FontSize = 16})
                .Blocks.Add(New Paragraph(New Run(Date.Now.ToShortDateString)) With {.FontSize = 12, .TextAlignment = TextAlignment.Right})
                .Blocks.Add(New Paragraph(New Run()))

                'Incomes:
                .Blocks.Add(New Paragraph(New Run("Einkommen")) With {.FontSize = 16})
                'Define the income header:
                Dim v_income_grid As New Grid With {.ShowGridLines = False}
                With v_income_grid
                    .RowDefinitions.Add(New RowDefinition)
                    For Each v_str As KeyValuePair(Of String, Integer) In v_header
                        .ColumnDefinitions.Add(New ColumnDefinition With {.Width = New GridLength(v_str.Value, GridUnitType.Star)})
                        Dim v_border As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = v_headerbackgroundbrush}
                        Dim v_lbl As New Label With {.Content = v_str.Key, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = v_foreground_textcolor}
                        v_border.Child = v_lbl
                        Grid.SetColumn(v_border, .ColumnDefinitions.Count - 1)
                        Grid.SetRow(v_border, 0)
                        .Children.Add(v_border)
                        v_lbl = Nothing
                    Next
                End With
                .Blocks.Add(New BlockUIContainer(v_income_grid))
                'Add a Row Entry of a Category keep in Mind that the rowspan of the first cell is set so 3!
                For Each v_b2c As budget_2_cat_v01 In v_budget.nv_budget_2_budcat_sorted
                    If Not v_b2c.income Then Continue For
                    Dim v_income_grid_row As New Grid With {.ShowGridLines = False}
                    With v_income_grid_row
                        'Add 3 Rows as 1 Block
                        .RowDefinitions.Add(New RowDefinition)
                        .RowDefinitions.Add(New RowDefinition)
                        .RowDefinitions.Add(New RowDefinition)
                        'Add the columns:
                        For Each v_str As KeyValuePair(Of String, Integer) In v_header
                            .ColumnDefinitions.Add(New ColumnDefinition With {.Width = New GridLength(v_str.Value, GridUnitType.Star)})
                        Next

                        'Add the category name:
                        Dim v_border As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl As New Label With {.Content = v_b2c.nv_category_2_budcat_back.fullname, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                        v_border.Child = v_lbl
                        Grid.SetColumn(v_border, 0)
                        Grid.SetRow(v_border, 0)
                        Grid.SetRowSpan(v_border, 3)
                        .Children.Add(v_border)
                        v_lbl = Nothing
                        v_border = Nothing

                        'Add the legend descriptions:
                        Dim v_border_soll As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_border_ist As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_border_delta As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl_soll As New Label With {.Content = "Soll", .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                        Dim v_lbl_ist As New Label With {.Content = "Ist", .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                        Dim v_lbl_delta As New Label With {.Content = "Abw.", .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                        v_border_soll.Child = v_lbl_soll
                        v_border_ist.Child = v_lbl_ist
                        v_border_delta.Child = v_lbl_delta
                        Grid.SetColumn(v_border_soll, 1)
                        Grid.SetRow(v_border_soll, 0)
                        .Children.Add(v_border_soll)
                        Grid.SetColumn(v_border_ist, 1)
                        Grid.SetRow(v_border_ist, 1)
                        .Children.Add(v_border_ist)
                        Grid.SetColumn(v_border_delta, 1)
                        Grid.SetRow(v_border_delta, 2)
                        .Children.Add(v_border_delta)

                        Dim v_column As Integer = 2
                        'Now add all the values "Soll":
                        For Each v_item As budget2cat_2_value_v01 In v_b2c.nv_budget2cat_2_value
                            Dim v_border_soll_values As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                            Dim v_lbl_soll_values As New Label With {.Content = v_item.should_amount.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                            v_border_soll_values.Child = v_lbl_soll_values
                            Grid.SetColumn(v_border_soll_values, v_column)
                            Grid.SetRow(v_border_soll_values, 0)
                            .Children.Add(v_border_soll_values)
                            v_column += 1
                        Next
                        'Now add the soll summary column:
                        Dim v_border_soll_sum As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl_soll_sum As New Label With {.Content = v_b2c.sum_soll.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = SettingsCurrent.color_pos_value_brush}
                        v_border_soll_sum.Child = v_lbl_soll_sum
                        Grid.SetColumn(v_border_soll_sum, v_column)
                        Grid.SetRow(v_border_soll_sum, 0)
                        .Children.Add(v_border_soll_sum)
                        v_column = 2 'Reset the column counter before adding the new values

                        'Now add all the values "Ist":
                        For Each v_item As budget2cat_2_value_v01 In v_b2c.nv_budget2cat_2_value
                            Dim v_border_ist_values As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                            Dim v_lbl_ist_values As New Label With {.Content = v_item.is_amount.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                            v_border_ist_values.Child = v_lbl_ist_values
                            Grid.SetColumn(v_border_ist_values, v_column)
                            Grid.SetRow(v_border_ist_values, 1)
                            .Children.Add(v_border_ist_values)
                            v_column += 1
                        Next
                        'Now add the ist summary column:
                        Dim v_border_ist_sum As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl_ist_sum As New Label With {.Content = v_b2c.sum_ist.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = SettingsCurrent.color_pos_value_brush}
                        v_border_ist_sum.Child = v_lbl_ist_sum
                        Grid.SetColumn(v_border_ist_sum, v_column)
                        Grid.SetRow(v_border_ist_sum, 1)
                        .Children.Add(v_border_ist_sum)
                        v_column = 2 'Reset the column counter before adding the new values

                        'Now add all the values "Delta":
                        For Each v_item As budget2cat_2_value_v01 In v_b2c.nv_budget2cat_2_value
                            Dim v_foreground As Brush = v_foreground_textcolor
                            Select Case True
                                Case v_item.delta_amount > 0
                                    v_foreground = SettingsCurrent.color_pos_value_brush
                                Case v_item.delta_amount < 0
                                    v_foreground = SettingsCurrent.color_neg_value_brush
                            End Select
                            Dim v_border_delta_values As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                            Dim v_lbl_delta_values As New Label With {.Content = v_item.delta_amount.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground}
                            v_border_delta_values.Child = v_lbl_delta_values
                            Grid.SetColumn(v_border_delta_values, v_column)
                            Grid.SetRow(v_border_delta_values, 2)
                            .Children.Add(v_border_delta_values)
                            v_column += 1
                        Next
                        'Now add the delta summary column:
                        Dim v_border_delta_sum As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl_delta_sum As New Label With {.Content = v_b2c.sum_delta.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                        v_border_delta_sum.Child = v_lbl_delta_sum
                        Grid.SetColumn(v_border_delta_sum, v_column)
                        Grid.SetRow(v_border_delta_sum, 2)
                        .Children.Add(v_border_delta_sum)
                        v_column = 2 'Reset the column counter before adding the new values
                    End With
                    .Blocks.Add(New BlockUIContainer(v_income_grid_row))
                    v_rowcount += 1
                Next

                'Expendes:
                v_rowcount = 1
                .Blocks.Add(New Paragraph(New Run("Ausgaben")) With {.FontSize = 16})
                'Define the income header:
                Dim v_expend_grid As New Grid With {.ShowGridLines = False}
                With v_expend_grid
                    .RowDefinitions.Add(New RowDefinition)
                    For Each v_str As KeyValuePair(Of String, Integer) In v_header
                        .ColumnDefinitions.Add(New ColumnDefinition With {.Width = New GridLength(v_str.Value, GridUnitType.Star)})
                        Dim v_border As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = v_headerbackgroundbrush}
                        Dim v_lbl As New Label With {.Content = v_str.Key, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = v_foreground_textcolor}
                        v_border.Child = v_lbl
                        Grid.SetColumn(v_border, .ColumnDefinitions.Count - 1)
                        Grid.SetRow(v_border, 0)
                        .Children.Add(v_border)
                        v_lbl = Nothing
                    Next
                End With
                .Blocks.Add(New BlockUIContainer(v_expend_grid))
                'Add a Row Entry of a Category keep in Mind that the rowspan of the first cell is set so 3!
                For Each v_b2c As budget_2_cat_v01 In v_budget.nv_budget_2_budcat_sorted
                    If v_b2c.income Then Continue For
                    Dim v_expend_grid_row As New Grid With {.ShowGridLines = False}
                    With v_expend_grid_row
                        'Add 3 Rows as 1 Block
                        .RowDefinitions.Add(New RowDefinition)
                        .RowDefinitions.Add(New RowDefinition)
                        .RowDefinitions.Add(New RowDefinition)
                        'Add the columns:
                        For Each v_str As KeyValuePair(Of String, Integer) In v_header
                            .ColumnDefinitions.Add(New ColumnDefinition With {.Width = New GridLength(v_str.Value, GridUnitType.Star)})
                        Next

                        'Add the category name:
                        Dim v_border As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl As New Label With {.Content = v_b2c.nv_category_2_budcat_back.fullname, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                        v_border.Child = v_lbl
                        Grid.SetColumn(v_border, 0)
                        Grid.SetRow(v_border, 0)
                        Grid.SetRowSpan(v_border, 3)
                        .Children.Add(v_border)
                        v_lbl = Nothing
                        v_border = Nothing

                        'Add the legend descriptions:
                        Dim v_border_soll As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_border_ist As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_border_delta As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl_soll As New Label With {.Content = "Soll", .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                        Dim v_lbl_ist As New Label With {.Content = "Ist", .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                        Dim v_lbl_delta As New Label With {.Content = "Abw.", .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                        v_border_soll.Child = v_lbl_soll
                        v_border_ist.Child = v_lbl_ist
                        v_border_delta.Child = v_lbl_delta
                        Grid.SetColumn(v_border_soll, 1)
                        Grid.SetRow(v_border_soll, 0)
                        .Children.Add(v_border_soll)
                        Grid.SetColumn(v_border_ist, 1)
                        Grid.SetRow(v_border_ist, 1)
                        .Children.Add(v_border_ist)
                        Grid.SetColumn(v_border_delta, 1)
                        Grid.SetRow(v_border_delta, 2)
                        .Children.Add(v_border_delta)

                        Dim v_column As Integer = 2
                        'Now add all the values "Soll":
                        For Each v_item As budget2cat_2_value_v01 In v_b2c.nv_budget2cat_2_value
                            Dim v_border_soll_values As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                            Dim v_lbl_soll_values As New Label With {.Content = v_item.should_amount.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                            v_border_soll_values.Child = v_lbl_soll_values
                            Grid.SetColumn(v_border_soll_values, v_column)
                            Grid.SetRow(v_border_soll_values, 0)
                            .Children.Add(v_border_soll_values)
                            v_column += 1
                        Next
                        'Now add the soll summary column:
                        Dim v_border_soll_sum As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl_soll_sum As New Label With {.Content = v_b2c.sum_soll.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                        v_border_soll_sum.Child = v_lbl_soll_sum
                        Grid.SetColumn(v_border_soll_sum, v_column)
                        Grid.SetRow(v_border_soll_sum, 0)
                        .Children.Add(v_border_soll_sum)
                        v_column = 2 'Reset the column counter before adding the new values

                        'Now add all the values "Ist":
                        For Each v_item As budget2cat_2_value_v01 In v_b2c.nv_budget2cat_2_value
                            Dim v_border_ist_values As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                            Dim v_lbl_ist_values As New Label With {.Content = v_item.is_amount.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                            v_border_ist_values.Child = v_lbl_ist_values
                            Grid.SetColumn(v_border_ist_values, v_column)
                            Grid.SetRow(v_border_ist_values, 1)
                            .Children.Add(v_border_ist_values)
                            v_column += 1
                        Next
                        'Now add the soll summary column:
                        Dim v_border_ist_sum As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl_ist_sum As New Label With {.Content = v_b2c.sum_ist.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_textcolor}
                        v_border_ist_sum.Child = v_lbl_ist_sum
                        Grid.SetColumn(v_border_ist_sum, v_column)
                        Grid.SetRow(v_border_ist_sum, 1)
                        .Children.Add(v_border_ist_sum)
                        v_column = 2 'Reset the column counter before adding the new values

                        'Now add all the values "Delta":
                        For Each v_item As budget2cat_2_value_v01 In v_b2c.nv_budget2cat_2_value
                            Dim v_foreground As Brush = v_foreground_textcolor
                            Select Case True
                                Case v_item.delta_amount > 0
                                    v_foreground = SettingsCurrent.color_pos_value_brush
                                Case v_item.delta_amount < 0
                                    v_foreground = SettingsCurrent.color_neg_value_brush
                            End Select
                            Dim v_border_delta_values As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                            Dim v_lbl_delta_values As New Label With {.Content = v_item.delta_amount.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground}
                            v_border_delta_values.Child = v_lbl_delta_values
                            Grid.SetColumn(v_border_delta_values, v_column)
                            Grid.SetRow(v_border_delta_values, 2)
                            .Children.Add(v_border_delta_values)
                            v_column += 1
                        Next
                        'Now add the delta summary column:
                        Dim v_foreground_delta As Brush = v_foreground_textcolor
                        Select Case True
                            Case v_b2c.sum_delta > 0
                                v_foreground_delta = SettingsCurrent.color_pos_value_brush
                            Case v_b2c.sum_delta < 0
                                v_foreground_delta = SettingsCurrent.color_neg_value_brush
                        End Select
                        Dim v_border_delta_sum As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl_delta_sum As New Label With {.Content = v_b2c.sum_delta.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_row_fontsize, .Foreground = v_foreground_delta}
                        v_border_delta_sum.Child = v_lbl_delta_sum
                        Grid.SetColumn(v_border_delta_sum, v_column)
                        Grid.SetRow(v_border_delta_sum, 2)
                        .Children.Add(v_border_delta_sum)
                        v_column = 2 'Reset the column counter before adding the new values
                    End With
                    .Blocks.Add(New BlockUIContainer(v_expend_grid_row))
                    v_rowcount += 1
                Next

                'Overall Summary:
                v_rowcount = 1
                .Blocks.Add(New Paragraph(New Run("Auswertung")) With {.FontSize = 16})
                'Define the income header:
                Dim v_summary_grid As New Grid With {.ShowGridLines = False}
                With v_summary_grid
                    .RowDefinitions.Add(New RowDefinition)
                    Dim v_sum_header As New List(Of String) From {"Legende", "Einnahmen", "Ausgaben", "Gesamt"}
                    For Each v_item As String In v_sum_header
                        .ColumnDefinitions.Add(New ColumnDefinition With {.Width = New GridLength(30, GridUnitType.Star)})
                        Dim v_border As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = v_headerbackgroundbrush}
                        Dim v_lbl As New Label With {.Content = v_item, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = v_foreground_textcolor}
                        v_border.Child = v_lbl
                        Grid.SetColumn(v_border, .ColumnDefinitions.Count - 1)
                        Grid.SetRow(v_border, 0)
                        .Children.Add(v_border)
                        v_lbl = Nothing
                    Next

                    'Now add the rows:
                    Dim v_sum_1strow As New List(Of String) From {"Soll", "Ist", "Abw."}
                    For Each v_item As String In v_sum_1strow
                        .RowDefinitions.Add(New RowDefinition)
                        Dim v_border As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_lbl As New Label With {.Content = v_item, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = v_foreground_textcolor}
                        v_border.Child = v_lbl
                        Grid.SetColumn(v_border, 0)
                        Grid.SetRow(v_border, .RowDefinitions.Count - 1)
                        .Children.Add(v_border)
                        v_lbl = Nothing

                        'check what type of values should be added:
                        Select Case True
                            Case v_item = "Soll"
                                'Soll Income:
                                Dim v_border_income_soll As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                                Dim v_lbl_income_soll As New Label With {.Content = v_budget.sum_should_income.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = v_foreground_textcolor}
                                v_border_income_soll.Child = v_lbl_income_soll
                                Grid.SetColumn(v_border_income_soll, 1)
                                Grid.SetRow(v_border_income_soll, .RowDefinitions.Count - 1)
                                .Children.Add(v_border_income_soll)
                                v_lbl = Nothing
                                'Soll Expend:
                                Dim v_border_expend_soll As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                                Dim v_lbl_expend_soll As New Label With {.Content = v_budget.sum_should_expend.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = v_foreground_textcolor}
                                v_border_expend_soll.Child = v_lbl_expend_soll
                                Grid.SetColumn(v_border_expend_soll, 2)
                                Grid.SetRow(v_border_expend_soll, .RowDefinitions.Count - 1)
                                .Children.Add(v_border_expend_soll)
                                v_lbl = Nothing
                                'Soll Sum:
                                Dim v_border_sum_soll As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                                Dim v_lbl_sum_soll As New Label With {.Content = (v_budget.sum_should_income - v_budget.sum_should_expend).ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = If((v_budget.sum_should_income - v_budget.sum_should_expend) >= 0, SettingsCurrent.color_pos_value_brush, SettingsCurrent.color_neg_value_brush)}
                                v_border_sum_soll.Child = v_lbl_sum_soll
                                Grid.SetColumn(v_border_sum_soll, 3)
                                Grid.SetRow(v_border_sum_soll, .RowDefinitions.Count - 1)
                                .Children.Add(v_border_sum_soll)
                                v_lbl = Nothing
                            Case v_item = "Ist"
                                'ist Income:
                                Dim v_border_income_ist As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                                Dim v_lbl_income_ist As New Label With {.Content = v_budget.sum_is_income.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = v_foreground_textcolor}
                                v_border_income_ist.Child = v_lbl_income_ist
                                Grid.SetColumn(v_border_income_ist, 1)
                                Grid.SetRow(v_border_income_ist, .RowDefinitions.Count - 1)
                                .Children.Add(v_border_income_ist)
                                v_lbl = Nothing
                                'ist Expend:
                                Dim v_border_expend_ist As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                                Dim v_lbl_expend_ist As New Label With {.Content = v_budget.sum_is_expend.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = v_foreground_textcolor}
                                v_border_expend_ist.Child = v_lbl_expend_ist
                                Grid.SetColumn(v_border_expend_ist, 2)
                                Grid.SetRow(v_border_expend_ist, .RowDefinitions.Count - 1)
                                .Children.Add(v_border_expend_ist)
                                v_lbl = Nothing
                                'ist Sum:
                                Dim v_border_sum_ist As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                                Dim v_lbl_sum_ist As New Label With {.Content = (v_budget.sum_is_income - v_budget.sum_is_expend).ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = If((v_budget.sum_is_income - v_budget.sum_is_expend) > 0, SettingsCurrent.color_pos_value_brush, SettingsCurrent.color_neg_value_brush)}
                                v_border_sum_ist.Child = v_lbl_sum_ist
                                Grid.SetColumn(v_border_sum_ist, 3)
                                Grid.SetRow(v_border_sum_ist, .RowDefinitions.Count - 1)
                                .Children.Add(v_border_sum_ist)
                                v_lbl = Nothing
                            Case v_item = "Abw."
                                'abw Income:
                                Dim v_income_abw_color As Brush = v_foreground_textcolor
                                Select Case True
                                    Case v_budget.sum_delta_income > 0
                                        v_income_abw_color = SettingsCurrent.color_neg_value_brush
                                    Case v_budget.sum_delta_income < 0
                                        v_income_abw_color = SettingsCurrent.color_pos_value_brush
                                End Select
                                Dim v_border_income_abw As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                                Dim v_lbl_income_abw As New Label With {.Content = v_budget.sum_delta_income.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = v_income_abw_color}
                                v_border_income_abw.Child = v_lbl_income_abw
                                Grid.SetColumn(v_border_income_abw, 1)
                                Grid.SetRow(v_border_income_abw, .RowDefinitions.Count - 1)
                                .Children.Add(v_border_income_abw)
                                v_lbl = Nothing
                                'abw Expend:
                                Dim v_exp_abw_color As Brush = v_foreground_textcolor
                                Select Case True
                                    Case v_budget.sum_delta_expend > 0
                                        v_exp_abw_color = SettingsCurrent.color_pos_value_brush
                                    Case v_budget.sum_delta_expend < 0
                                        v_exp_abw_color = SettingsCurrent.color_neg_value_brush
                                End Select
                                Dim v_border_expend_abw As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                                Dim v_lbl_expend_abw As New Label With {.Content = v_budget.sum_delta_expend.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = v_exp_abw_color}
                                v_border_expend_abw.Child = v_lbl_expend_abw
                                Grid.SetColumn(v_border_expend_abw, 2)
                                Grid.SetRow(v_border_expend_abw, .RowDefinitions.Count - 1)
                                .Children.Add(v_border_expend_abw)
                                v_lbl = Nothing
                                'abw Sum:
                                Dim v_sum_abw_color As Brush = v_foreground_textcolor
                                Select Case True
                                    Case v_budget.sum_delta > 0
                                        v_sum_abw_color = SettingsCurrent.color_pos_value_brush
                                    Case v_budget.sum_delta < 0
                                        v_sum_abw_color = SettingsCurrent.color_neg_value_brush
                                End Select
                                Dim v_border_sum_abw As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                                Dim v_lbl_sum_abw As New Label With {.Content = v_budget.sum_delta.ToString("C"), .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center, .FontSize = v_header_fontsize, .Foreground = v_sum_abw_color}
                                v_border_sum_abw.Child = v_lbl_sum_abw
                                Grid.SetColumn(v_border_sum_abw, 3)
                                Grid.SetRow(v_border_sum_abw, .RowDefinitions.Count - 1)
                                .Children.Add(v_border_sum_abw)
                                v_lbl = Nothing
                        End Select
                        v_rowcount += 1
                    Next
                End With
                .Blocks.Add(New BlockUIContainer(v_summary_grid))
            End With
            Return v_rep_local
        End Function

        Private Sub BudgetPrint(v_budget As budget_v01)
            If v_budget Is Nothing Then Exit Sub
            If v_budget.budget_report_clone Is Nothing Then Exit Sub
            Dim v_print_dia As New PrintDialog
            Dim v_print_server As New LocalPrintServer
            Dim v_print_queue As PrintQueue = v_print_server.DefaultPrintQueue
            Dim v_print_ticket As PrintTicket = v_print_queue.UserPrintTicket
            Dim v_pm_size As PageMediaSize = New PageMediaSize(v_budget.budget_report_clone.PageWidth, v_budget.budget_report_clone.PageHeight)
            v_print_ticket.PageMediaSize = v_pm_size
            v_print_ticket.PageOrientation = PageOrientation.Landscape

            Dim v_docpag As IDocumentPaginatorSource = TryCast(v_budget.budget_report_clone, IDocumentPaginatorSource)

            If v_docpag Is Nothing Then
                cls_logger.v_logger.Error("Umwandlung von v_budget.budget_report_clone in Paginator failed")
                Exit Sub
            End If

            Dim v_imageablearea As System.Printing.PrintDocumentImageableArea = Nothing
            Dim v_docwriter As System.Windows.Xps.XpsDocumentWriter = System.Printing.PrintQueue.CreateXpsDocumentWriter(v_imageablearea)

            v_docpag.DocumentPaginator.ComputePageCount()
            Dim paginator As DocumentPaginator = v_docpag.DocumentPaginator
            paginator = New DocumentPaginatorWrapper(v_docpag.DocumentPaginator, New Size(1104, 768), New Size(20, 45))

            If v_docwriter IsNot Nothing AndAlso v_imageablearea IsNot Nothing Then
                v_docwriter.Write(paginator, v_print_ticket)
            End If
        End Sub

        Private Function BudgetChartUpdate(v_budget As budget_v01) As Boolean
            If v_budget Is Nothing Then Return False
            With v_budget
                Try
                    .Chart_Series_in.Clear()
                    .Chart_Series_out.Clear()
                Catch ex As Exception
                    Debug.Print("Chart Budget Error:" & ex.Exception.ToString)
                End Try

                .Chart_Labels_in.Clear()
                .Chart_Labels_out.Clear()

                'Defining the Columns Income:
                Dim v_column_in_should As New RowSeries With {.Title = "Soll"}
                Dim v_column_in_is As New RowSeries With {.Title = "Ist"}
                Dim v_values_in_should As New ChartValues(Of Double)
                Dim v_values_in_is As New ChartValues(Of Double)

                For Each v_cat As budget_2_cat_v01 In .nv_budget_2_budcat_sorted
                    If v_cat.income Then
                        .Chart_Labels_in.Add(v_cat.nv_category_2_budcat_back.fullname)
                        v_values_in_should.Add(v_cat.sum_soll)
                        v_values_in_is.Add(v_cat.sum_ist)
                    End If
                Next
                v_column_in_should.Values = v_values_in_should
                v_column_in_is.Values = v_values_in_is
                .Chart_Series_in.Add(v_column_in_should)
                .Chart_Series_in.Add(v_column_in_is)


                'Defining the Columns Expenditures:
                Dim v_column_out_should As New RowSeries With {.Title = "Soll"}
                Dim v_column_out_is As New RowSeries With {.Title = "Ist"}
                Dim v_values_out_should As New ChartValues(Of Double)
                Dim v_values_out_is As New ChartValues(Of Double)

                For Each v_cat As budget_2_cat_v01 In .nv_budget_2_budcat_sorted
                    If Not v_cat.income Then
                        .Chart_Labels_out.Add(v_cat.nv_category_2_budcat_back.fullname)
                        v_values_out_should.Add(v_cat.sum_soll)
                        v_values_out_is.Add(v_cat.sum_ist)
                    End If
                Next
                v_column_out_should.Values = v_values_out_should
                v_column_out_is.Values = v_values_out_is
                .Chart_Series_out.Add(v_column_out_should)
                .Chart_Series_out.Add(v_column_out_is)
            End With
            Return True
        End Function

        'Open a search from a category timespan:
        Private Sub BudgetCategorySearch(ByVal v_item As budget2cat_2_value_v01)
            If v_item Is Nothing Then Exit Sub
            Dim v_new_search As New searchdefinition_v01
            With v_new_search
                .search_bezeichnung = String.Format("Suche {0} {1}", v_item.nv_budget_2_cat_back.nv_budget_2_budcat_back.bezeichnung, v_item.bezeichnung)
                .search_category = v_item.nv_budget_2_cat_back.category_id
                .search_category_subcats = v_item.nv_budget_2_cat_back.sumchilds
                .search_time_from = v_item.real_from
                .search_time_to = v_item.real_to
                .aktiv_category = True
                .aktiv_time = True
            End With
            MenuAdd(v_new_search)
        End Sub

        'Add some categories to a budget:

        Private Sub BudgetKatIncomeAdd(v_budget As budget_v01)
            If v_budget Is Nothing Then Exit Sub
            Call AddCattoBudget(v_budget, True)
        End Sub

        Private Sub BudgetKatExpendAdd(v_budget As budget_v01)
            If v_budget Is Nothing Then Exit Sub
            Call AddCattoBudget(v_budget, False)
        End Sub

        'Edit a specific category:
        Private Async Sub BudgetBudCatEdit(v_b2c As budget_2_cat_v01)
            If v_b2c Is Nothing Then Exit Sub
            Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Verstanden", .NegativeButtonText = "Abbrechen"}

            'Check if periods of the budget are corresponding with the amount of values:
            'There are 2 possibilities:
            'First: No Value is added so add all the values to the budget cat
            'Second: The amount of values is not corresponding to the scope_based_value_amount => clear all values and then add new
            If Not v_b2c.nv_budget2cat_2_value.Count = 0 AndAlso v_b2c.nv_budget2cat_2_value.Count <> v_b2c.nv_budget_2_budcat_back.scope_based_value_amount Then
                Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Budget Soll-Werte Vergleich", "Die Anzahl der Perioden innerhalb der Budget Kategorie entspricht nicht der Periodenanzahl des Budgets." & Environment.NewLine & "Anscheinend wurde die Anzahl der Perioden geändert, die Kategorie Perioden werden zurückgesetzt", MessageDialogStyle.AffirmativeAndNegative, dia_settings)
                If result = MessageDialogResult.Affirmative Then
                    While v_b2c.nv_budget2cat_2_value.Count > 0
                        dbo.Entry(v_b2c.nv_budget2cat_2_value.First).State = EntityState.Deleted
                    End While
                    dbo.ChangeTracker.DetectChanges()
                    dbo.SaveChanges()
                Else
                    Exit Sub
                End If
            End If
            If v_b2c.nv_budget2cat_2_value.Count = 0 Then
                'Now add the periods:
                Dim v_budget As budget_v01 = v_b2c.nv_budget_2_budcat_back
                Dim v_date_from As Date = v_budget.start_date
                Dim v_date_to As Date = v_budget.end_date

                For i As Long = 1 To v_budget.scope_based_value_amount
                    Select Case v_budget.budget_scope
                        Case "week"
                            v_date_to = v_date_from.AddDays(6)
                        Case "month"
                            v_date_to = v_date_from.AddMonths(1).AddDays(-1)
                        Case "quarteryear"
                            v_date_to = v_date_from.AddMonths(3).AddDays(-1)
                        Case "halfyear"
                            v_date_to = v_date_from.AddMonths(6).AddDays(-1)
                        Case "year"
                            v_date_to = v_date_from.AddYears(1).AddDays(-1)
                    End Select
                    Dim v_bez As String
                    v_bez = Budgets_Fokus.Where(Function(x) x.Item2 = v_budget.budget_scope).First.Item3 & " " & i.ToString
                    v_b2c.nv_budget2cat_2_value.Add(New budget2cat_2_value_v01 With {.scope_order = CInt(i), .bezeichnung = v_bez, .real_from = v_date_from, .real_to = v_date_to})
                    v_date_from = v_date_to.AddDays(1)
                Next
                v_budget = Nothing
                dbo.SaveChanges()
            End If
            v_b2c.BeginEdit()
            Dim v_dia As New frm_budcat_edit With {.WindowStartupLocation = WindowStartupLocation.CenterScreen, .ShowActivated = True, .DataContext = v_b2c}
            With v_dia
                .ShowDialog()
                If .DialogResult Then
                    v_b2c.EndEdit()
                    dbo.Entry(v_b2c).State = EntityState.Modified
                    dbo.SaveChanges()
                Else
                    v_b2c.CancelEdit()
                End If
            End With
        End Sub

        Private Function BudgetBudCatEditCanExecute(v_b2c As budget_2_cat_v01) As Boolean
            If v_b2c Is Nothing Then Return False
            'check if the parent budget is defined correctly:
            If v_b2c.nv_budget_2_budcat_back Is Nothing Then Return False
            Dim v_cur_bud As budget_v01 = v_b2c.nv_budget_2_budcat_back
            If String.IsNullOrEmpty(v_cur_bud.budget_scope) Then Return False
            If v_cur_bud.start_date = Nothing OrElse v_cur_bud.end_date = Nothing Then Return False
            v_cur_bud = Nothing
            Return True
        End Function

        Private Async Sub BudgetBudCatDelete(v_b2c As budget_2_cat_v01)
            If v_b2c Is Nothing Then Exit Sub
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Budget Kategorie löschen", String.Format("Wollen Sie die Kategorie {0} wirklich aus dem Budget entfernen?", v_b2c.nv_category_2_budcat_back.fullname), MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            If result = MessageDialogResult.Affirmative Then
                'Check if there are any values:
                If v_b2c.nv_budget2cat_2_value IsNot Nothing AndAlso v_b2c.nv_budget2cat_2_value.Count > 0 Then
                    While v_b2c.nv_budget2cat_2_value.Count > 0
                        dbo.Entry(v_b2c.nv_budget2cat_2_value.First).State = EntityState.Deleted
                    End While
                    dbo.SaveChanges()
                End If
                dbo.Entry(v_b2c).State = EntityState.Deleted
                dbo.SaveChanges()
            End If
        End Sub

        Private Async Sub BudgetCategorySetDivided(v_b2c As budget_2_cat_v01)
            If v_b2c Is Nothing Then Exit Sub
            If v_b2c.nv_budget2cat_2_value Is Nothing OrElse v_b2c.nv_budget2cat_2_value.Count = 0 Then Exit Sub

            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine(String.Format("Wollen Sie den Vorgabewert {0} für alle {1} Perioden aufteilen?", v_b2c.should_amount_internal.ToString("N"), v_b2c.nv_budget2cat_2_value.Count.ToString))
            v_strbuilder.AppendLine("Hinweis: Wenn 'Ja, mit überschreiben' gewählt wurde werden alle Werte ersetzt, mit 'Nein, ohne überschreiben' werden nur Werte gleich 0 ersetzt.")
            v_strbuilder.AppendLine("Beispiel: Vorgabewert 100€ für 12 Perioden wird (100/12) 8,33€ als Zielwert für jede Periode übernommen.")

            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja, mit überschreiben", .NegativeButtonText = "Nein", .FirstAuxiliaryButtonText = "Nein, ohne überschreiben"}
            Dim v_dialog_window As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.Windows.OfType(Of Window).SingleOrDefault(Function(x) x.IsActive), MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_dialog_window.ShowMessageAsync("Vorgabewert aufteilen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegativeAndSingleAuxiliary, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                Call SetBudgetShouldAmount(v_b2c, True, True)
            ElseIf result = MessageDialogResult.FirstAuxiliary Then
                Call SetBudgetShouldAmount(v_b2c, True, False)
            End If
        End Sub

        Private Async Sub BudgetCategorySetAll(v_b2c As budget_2_cat_v01)
            If v_b2c Is Nothing Then Exit Sub
            If v_b2c.nv_budget2cat_2_value Is Nothing OrElse v_b2c.nv_budget2cat_2_value.Count = 0 Then Exit Sub

            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine(String.Format("Wollen Sie den Vorgabewert {0} für alle {1} Perioden definieren?", v_b2c.should_amount_internal.ToString("N"), v_b2c.nv_budget2cat_2_value.Count.ToString))
            v_strbuilder.AppendLine("Hinweis: Wenn 'Ja, mit überschreiben' gewählt wurde werden alle Werte ersetzt, mit 'Nein, ohne überschreiben' werden nur Werte gleich 0 ersetzt.")
            v_strbuilder.AppendLine("Beispiel: Vorgabewert 100€ für 12 Perioden wird 100€ als Zielwert für jede Periode übernommen.")
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja, mit überschreiben", .NegativeButtonText = "Nein", .FirstAuxiliaryButtonText = "Nein, ohne überschreiben"}
            Dim v_dialog_window As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.Windows.OfType(Of Window).SingleOrDefault(Function(x) x.IsActive), MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_dialog_window.ShowMessageAsync("Vorgabewert setzen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegativeAndSingleAuxiliary, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                Call SetBudgetShouldAmount(v_b2c, False, True)
            ElseIf result = MessageDialogResult.FirstAuxiliary Then
                Call SetBudgetShouldAmount(v_b2c, False, False)
            End If

        End Sub

        Private Function SetBudgetShouldAmount(v_b2c As budget_2_cat_v01, v_divided As Boolean, v_overwrite As Boolean) As Boolean
            Try
                Dim v_real_amount As Decimal = 0
                If v_divided Then
                    v_real_amount = v_b2c.should_amount_internal / v_b2c.nv_budget2cat_2_value.Count
                Else
                    v_real_amount = v_b2c.should_amount_internal
                End If

                For Each v_item As budget2cat_2_value_v01 In v_b2c.nv_budget2cat_2_value
                    With v_item
                        If v_overwrite Then
                            .BeginEdit()
                            .should_amount = v_real_amount
                            .EndEdit()
                        Else
                            If v_item.should_amount = 0 Then
                                .BeginEdit()
                                .should_amount = v_real_amount
                                .EndEdit()
                            End If
                        End If
                    End With
                Next
                dbo.SaveChanges()
                Return True
            Catch ex As Exception
                cls_logger.v_logger.Error("SetBudgetShouldAmount: " & ex.Message)
                Return False
            End Try
        End Function

        Private Function BudgetCategorySetDividedAllCanExecute(v_b2c As budget_2_cat_v01) As Boolean
            If v_b2c Is Nothing Then Return False
            If v_b2c.nv_budget2cat_2_value Is Nothing OrElse v_b2c.nv_budget2cat_2_value.Count = 0 Then Return False
            Return True
        End Function

        Private Sub AddCattoBudget(v_budget As budget_v01, v_isincome As Boolean)
            Dim v_dialog As New frm_budget_catadd
            Dim v_msg As New StringBuilder
            With v_dialog
                .WindowStartupLocation = WindowStartupLocation.CenterScreen
                .ShowDialog()
                If .DialogResult Then
                    'Get the selected categories:
                    Dim v_selectedcats_untyped As IList(Of Object) = CType(.lvw_cats.SelectedItems, IList(Of Object))
                    If v_selectedcats_untyped Is Nothing OrElse v_selectedcats_untyped.Count = 0 Then Exit Sub
                    For Each v_item As Object In v_selectedcats_untyped
                        'Check if the category exists in the budget:

                        Dim v_cur_cat As category_v01 = DirectCast(v_item, category_v01)
                        If v_cur_cat Is Nothing Then
                            cls_logger.v_logger.Error("Fehler bei AddCattoBudget Kategorie konnte nicht gecastet werden")
                            Continue For
                        End If
                        If v_budget.nv_budget_2_budcat.Where(Function(x) x.category_id = v_cur_cat.cat_id).Count = 0 Then
                            'Does not exist:
                            v_budget.nv_budget_2_budcat.Add(New budget_2_cat_v01 With {.income = v_isincome, .category_id = v_cur_cat.cat_id, .budget_id = v_budget.bud_id, .should_amount_internal = 0})
                            v_msg.AppendLine(String.Format("Kategorie {0} wurde dem Budget als {1}-Kategorie hinzugefügt", v_cur_cat.fullname, If(v_isincome, "Einnahmen", "Ausgaben")))
                        Else
                            v_msg.AppendLine(String.Format("Kategorie {0} wurde dem Budget bereits hinzugefügt => Kategorie wird ignoriert", v_cur_cat.fullname))
                        End If
                        v_cur_cat = Nothing
                    Next
                    dbo.SaveChanges()
                    Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
                    v_mainwindow.ShowMessageAsync("Budget Kategorien hinzufügen", v_msg.ToString, MessageDialogStyle.Affirmative)
                End If
            End With
        End Sub

        Private Function BudgetKatIncomeExpendAddCanExecute(v_budget As budget_v01) As Boolean
            If v_budget Is Nothing Then Return False
            If String.IsNullOrEmpty(v_budget.budget_scope) Then Return False
            If Categories_Aktiv Is Nothing OrElse Categories_Aktiv.Count = 0 Then Return False
            Return True
        End Function
#End Region

    End Class
End Namespace

