﻿Imports System.Collections.ObjectModel
Imports System.Data.Entity
Imports System.Text
Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Folder:

        Private WithEvents __folders As New ObservableCollection(Of folder_v01)
        ''' <summary>
        ''' Alle Transaktionstypen
        ''' </summary>
        ''' <returns></returns>
        Public Property Folders As ListCollectionView
        Public Property Folders_Aktiv As ListCollectionView
        Public Property Folders_Inaktiv As ListCollectionView

        Private Sub FoldersLoad()
            __folders.Clear()
            dbo.m_folder_v01.Load
            __folders = dbo.m_folder_v01.Local
            Folders = New ListCollectionView(__folders)
            Folders_Aktiv = New ListCollectionView(__folders)
            Folders_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.FoldersAktiv)
            Folders_Inaktiv = New ListCollectionView(__folders)
            Folders_Inaktiv.Filter = New Predicate(Of Object)(AddressOf Filters.FoldersInAktiv)
        End Sub

        Private Sub __folders_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __folders.CollectionChanged
            'If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not Folders Is Nothing Then
                If Not Folders.MoveCurrentToNext Then Folders.MoveCurrentToPrevious()
            End If
            If Not Folders_Aktiv Is Nothing Then
                If Not Folders_Aktiv.MoveCurrentToNext Then Folders_Aktiv.MoveCurrentToPrevious()
                If Not Folders_Aktiv.IsAddingNew Or Folders_Aktiv.IsEditingItem Then Folders_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.FoldersAktiv)
            End If
            If Not Folders_Inaktiv Is Nothing Then
                If Not Folders_Inaktiv.MoveCurrentToNext Then Folders_Inaktiv.MoveCurrentToPrevious()
                If Not Folders_Inaktiv.IsAddingNew Or Folders_Inaktiv.IsEditingItem Then Folders_Inaktiv.Filter = New Predicate(Of Object)(AddressOf Filters.FoldersInAktiv)
            End If
        End Sub

#Region "Commands"

        Public Property cmdFolderAdd As New RelayCommand(AddressOf FolderAdd)
        Public Property cmdFolderEdit As New RelayCommand(Of folder_v01)(Sub(p) FolderEdit(p), Function(p) p IsNot Nothing)
        Public Property cmdFolderDelete As New RelayCommand(Of folder_v01)(Sub(p) FolderDelete(p), Function(p) FolderCanDelete(p))
        Public Property cmdFolderArchive As New RelayCommand(Of folder_v01)(Sub(p) FolderArchive(p), Function(p) p IsNot Nothing)

        ''' <summary>
        ''' Hauptfolder hinzufügen
        ''' </summary>
        Private Sub FolderAdd()
            Dim v_dia As New frm_folder_addedit
            Dim v_newfolder As New folder_v01
            With v_dia
                .Title = "Ordner hinzufügen"
                .DataContext = v_newfolder
                .ShowDialog()
                If .DialogResult Then
                    Folders_Aktiv.AddNewItem(v_newfolder)
                    Folders_Aktiv.CommitNew()
                    Folders_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.FoldersAktiv)
                    dbo.SaveChanges()
                End If
            End With
        End Sub

        ''' <summary>
        ''' Folder Editieren
        ''' </summary>
        Private Sub FolderEdit(v_folder As folder_v01)
            If v_folder Is Nothing Then Exit Sub
            v_folder.BeginEdit()
            Dim v_dia As New frm_folder_addedit
            With v_dia
                .Title = "Ordner bearbeiten"
                .DataContext = v_folder
                .ShowDialog()
                If .DialogResult Then
                    v_folder.EndEdit()
                    dbo.SaveChanges()
                Else
                    v_folder.CancelEdit()
                End If
            End With
        End Sub

        ''' <summary>
        ''' Delete a folder
        ''' </summary>
        Private Async Sub FolderDelete(v_folder As folder_v01)
            If v_folder Is Nothing Then Exit Sub
            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie den Ordner " & v_folder.bezeichnung & " wirklich löschen?")
            v_strbuilder.AppendLine("Hinweis: Vorgang kann nicht rückgängig gemacht werden.")
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Ordner löschen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                __folders.Remove(v_folder)
                dbo.SaveChanges()
            End If
        End Sub

        Private Function FolderCanDelete(v_folder As folder_v01) As Boolean
            If v_folder Is Nothing Then Return False
            If v_folder.nv_folder_2_konto.Count > 0 Then
                Return False
            Else
                Return True
            End If
        End Function

        Private Async Sub FolderArchive(v_folder As folder_v01)
            If v_folder Is Nothing Then Exit Sub
            'New status is selected
            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie den Ordner " & v_folder.bezeichnung & " wirklich archivieren?")
            If v_folder.nv_folder_2_konto.Count > 0 Then
                v_strbuilder.AppendLine("Folgende Konten werden ebenfalls archiviert:")
                For Each v_konto As konto_v01 In v_folder.nv_folder_2_konto
                    If v_konto.aktiv Then v_strbuilder.AppendLine(v_konto.bezeichnung)
                Next
            End If

            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Ordner archivieren", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then

                With v_folder
                    .BeginEdit()
                    .aktiv = False
                    .EndEdit()
                End With
                __folders_CollectionChanged(Me, Nothing)

                If v_folder.nv_folder_2_konto.Count > 0 Then
                    For Each v_konto As konto_v01 In v_folder.nv_folder_2_konto
                        With v_konto
                            .BeginEdit()
                            .aktiv = False
                            .EndEdit()
                        End With
                    Next
                    __konten_CollectionChanged(Me, Nothing)
                End If
                dbo.SaveChanges()
            End If

        End Sub

#End Region

    End Class
End Namespace

