﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Data.Entity
Imports System.IO
Imports System.IO.Packaging
Imports System.Printing
Imports System.Text
Imports System.Windows.Markup
Imports System.Windows.Documents
Imports System.Windows.Xps.Packaging
Imports System.Windows.Xps.Serialization
Imports MahApps.Metro.Controls.Dialogs
Imports System.Windows.Xps
Imports System.Threading
Imports System.Windows.Threading

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Konto:

        Private WithEvents __konten As New ObservableCollection(Of konto_v01)
        Public Property Konten As ListCollectionView
        Public Property Konten_Aktiv As ListCollectionView
        Public Property Konten_Inaktiv As ListCollectionView
        Public Property Konten_Favoriten As ListCollectionView
        Public Property Konten_Home As ListCollectionView

        Private Sub KontenLoad()
            __konten.Clear()
            dbo.m_konto_v01.Load
            __konten = dbo.m_konto_v01.Local
            Konten = New ListCollectionView(__konten)
            Konten_Aktiv = New ListCollectionView(__konten) With {
                .Filter = New Predicate(Of Object)(AddressOf Filters.ObjAktiv)
            }
            Konten_Inaktiv = New ListCollectionView(__konten) With {
                .Filter = New Predicate(Of Object)(AddressOf Filters.ObjInaktiv)
            }
            Konten_Favoriten = New ListCollectionView(__konten) With {
                .Filter = New Predicate(Of Object)(AddressOf Filters.KontoFavorit)
            }
            Konten_Home = New ListCollectionView(__konten) With {
                .Filter = New Predicate(Of Object)(AddressOf Filters.KontoOverview)
            }
            Konto_set_stati_all()
        End Sub

        Private Sub __konten_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __konten.CollectionChanged
            'If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not Konten Is Nothing Then
                If Not Konten.MoveCurrentToNext Then Konten.MoveCurrentToPrevious()
            End If
            If Not Konten_Aktiv Is Nothing Then
                If Not Konten_Aktiv.MoveCurrentToNext Then Konten_Aktiv.MoveCurrentToPrevious()
                If Not Konten_Aktiv.IsAddingNew Or Konten_Aktiv.IsEditingItem Then Konten_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.ObjAktiv)
            End If
            If Not Konten_Inaktiv Is Nothing Then
                If Not Konten_Inaktiv.MoveCurrentToNext Then Konten_Inaktiv.MoveCurrentToPrevious()
                If Not Konten_Inaktiv.IsAddingNew Or Konten_Inaktiv.IsEditingItem Then Konten_Inaktiv.Filter = New Predicate(Of Object)(AddressOf Filters.ObjInaktiv)
            End If
            If Not Konten_Favoriten Is Nothing Then
                If Not Konten_Favoriten.MoveCurrentToNext Then Konten_Favoriten.MoveCurrentToPrevious()
                If Not Konten_Favoriten.IsAddingNew Or Konten_Favoriten.IsEditingItem Then Konten_Favoriten.Filter = New Predicate(Of Object)(AddressOf Filters.KontoFavorit)
            End If
            If Not Konten_Home Is Nothing Then
                If Not Konten_Home.MoveCurrentToNext Then Konten_Home.MoveCurrentToPrevious()
                If Not Konten_Home.IsAddingNew Or Konten_Home.IsEditingItem Then Konten_Home.Filter = New Predicate(Of Object)(AddressOf Filters.KontoOverview)
            End If
        End Sub

#Region "Commands"

        Public Property cmdKontoAddDirect As New RelayCommand(Sub() KontoAddDirect(), Function() Folders_Aktiv.Count > 0)
        Public Property cmdKontoAdd As New RelayCommand(Of folder_v01)(Sub(p) KontoAdd(p), Function(p) KontoCanAdd(p))
        Public Property cmdKontoEdit As New RelayCommand(Of konto_v01)(Sub(p) KontoEdit(p), Function(p) p IsNot Nothing)
        Public Property cmdKontoDelete As New RelayCommand(Of konto_v01)(Sub(p) KontoDelete(p), Function(p) KontoCanDelete(p))
        Public Property cmdKontoImage As New RelayCommand(Of konto_v01)(Sub(p) KontoImage(p), Function(p) p IsNot Nothing)
        Public Property cmdFilterKontoView As New RelayCommand(Of konto_v01)(Sub(p) KontoFilterView(p), Function(p) p IsNot Nothing)
        Public Property cmdFilterKontoViewExtended As New RelayCommand(Of konto_v01)(Sub(p) FilterKontoViewExtended(p)) ', Function(p) p IsNot Nothing)
        Public Property cmdKontoArchive As New RelayCommand(Of konto_v01)(Sub(p) KontoArchive(p), Function(p) p IsNot Nothing)
        Public Property cmdKontoStatistikRibbon As New RelayCommand(Of konto_v01)(Sub(p) KontoStatistikRibbon(p), Function(p) KontoStatistikRibbonCanExecute(p))
        Public Property cmdKontoBookingJournal As New RelayCommand(Of konto_v01)(Sub(p) KontoBookingJournal(p), Function(p) p IsNot Nothing)
        Public Property cmdCreateKontoReport As New RelayCommand(Of konto_v01)(Sub(p) CreateKontoReport(p), Function(p) p IsNot Nothing AndAlso p.cvMixedChildren.Count > 0)
        Public Property cmdKontoReportPrint As New RelayCommand(Of cls_menuitem_kontoreport)(Sub(p) KontoReportPrint(p), Function(p) p IsNot Nothing AndAlso p.ReportDocument IsNot Nothing)

        Private Sub KontoImage(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            Dim v_image As Byte() = get_symbol_from_dialog()
            If v_image IsNot Nothing Then
                v_konto.symbol = v_image
            End If
        End Sub

        ''' <summary>
        ''' Konto ohne Ordner preset hinzufügen
        ''' </summary>
        Private Sub KontoAddDirect()
            Dim v_dia As New frm_konto_addedit
            Dim v_newkonto As New konto_v01
            With v_dia
                .Title = "Konto hinzufügen"
                .DataContext = v_newkonto
                .ShowDialog()
                If .DialogResult Then
                    Konten_Aktiv.AddNewItem(v_newkonto)
                    Konten_Aktiv.CommitNew()
                    dbo.SaveChanges()
                    __konten_CollectionChanged(Me, Nothing)
                    If v_newkonto.nv_folder_2_konto_back Is Nothing Then v_newkonto.nv_folder_2_konto_back.refresh_konto_filter()
                End If
            End With
        End Sub

        ''' <summary>
        ''' Konto zu Ordner hinzufügen
        ''' </summary>
        Private Sub KontoAdd(v_folder As folder_v01)
            If v_folder Is Nothing Then Exit Sub

            Dim v_dia As New frm_konto_addedit
            Dim v_newkonto As New konto_v01 With {.parent_folder_id = v_folder.fol_id}
            With v_dia
                .Title = "Konto hinzufügen"
                .DataContext = v_newkonto
                .ShowDialog()
                If .DialogResult Then
                    v_folder.nv_folder_2_konto.Add(v_newkonto)
                    dbo.SaveChanges()
                    __konten_CollectionChanged(Me, Nothing)
                    v_folder.refresh_konto_filter()
                End If
            End With
        End Sub

        Private Function KontoCanAdd(v_folder As folder_v01) As Boolean
            If v_folder Is Nothing Then Return False
            If v_folder.aktiv = True Then
                Return True
            Else
                Return False
            End If
        End Function


        ''' <summary>
        ''' Konto Editieren
        ''' </summary>
        Private Sub KontoEdit(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            v_konto.BeginEdit()
            Dim v_dia As New frm_konto_addedit
            With v_dia
                .Title = "Konto bearbeiten"
                .DataContext = v_konto
                .ShowDialog()
                If .DialogResult Then
                    v_konto.EndEdit()
                    'Recalculate the Konto Value (in case the startvalue has changed:
                    v_konto.Totalamount_Calculate()
                    dbo.SaveChanges()
                Else
                    v_konto.CancelEdit()
                End If
            End With
            If Not v_konto.nv_folder_2_konto_back Is Nothing Then v_konto.nv_folder_2_konto_back.refresh_konto_filter()
            __konten_CollectionChanged(Me, Nothing)
            Konto_set_stati(v_konto)
        End Sub

        ''' <summary>
        ''' Konto löschen
        ''' </summary>
        Private Async Sub KontoDelete(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Frage", String.Format("Wollen Sie das Konto {0} wirklich gelöscht werden?", v_konto.bezeichnung), MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                __konten.Remove(v_konto)
                dbo.SaveChanges()
            End If
        End Sub

        Private Function KontoCanDelete(v_konto As konto_v01) As Boolean
            If v_konto Is Nothing Then Return False
            If v_konto.nv_kto_2_trans.Count > 0 Then
                Return False
            Else
                Return True
            End If
        End Function


        ''' <summary>
        ''' Defines the timeframe which should be showed when viewing an account
        ''' </summary>
        ''' <param name="v_konto">The konto to apply the Filter</param>
        Private Sub KontoFilterView(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            'Execute only if the extended filter is not activated:
            If v_konto.FilterExtendedUse Then Exit Sub
            If v_konto.TimeFrameCurrent = Nothing Then v_konto.TimeFrameCurrent = 2
            If v_konto.ChangeFilterNecessary = False Then Exit Sub
            Dim v_zeitraum As cls_timeframe = __timeframes.Where(Function(x) x.Id = v_konto.TimeFrameCurrent).FirstOrDefault
            If v_zeitraum Is Nothing Then Exit Sub

            Dim v_startdate As Date
            Dim v_enddate As Date

            Select Case v_zeitraum.Id
                Case 2
                    'Aktuelles Monat
                    v_startdate = New Date(Date.Now.Year, Date.Now.Month, 1)
                    v_enddate = v_startdate.AddMonths(1).AddDays(-1)
                    'Set the Dates to pass them to the GUI
                    v_konto.SetShowDates(v_startdate.ToShortDateString, v_enddate.ToShortDateString)
                Case 3
                    'Letztes Monat
                    'Änderung: 1.0.1.3 Berechnung des Start Monats geändert wg. Problem mit Jahreswechsel
                    v_startdate = New Date(Date.Now.Year, Date.Now.Month - 1, 1)
                    v_enddate = v_startdate.AddMonths(1).AddDays(-1)
                    'Set the Dates to pass them to the GUI
                    v_konto.SetShowDates(v_startdate.ToShortDateString, v_enddate.ToShortDateString)
                Case 4
                    'Letzten 2 Monate
                    'Änderung: 1.0.1.3 Berechnung des Start Monats geändert wg. Problem mit Jahreswechsel
                    v_startdate = New Date(Date.Now.Year, Date.Now.Month, 1)
                    v_startdate = v_startdate.AddMonths(-2)
                    v_enddate = v_startdate.AddMonths(2).AddDays(-1)
                    'Set the Dates to pass them to the GUI
                    v_konto.SetShowDates(v_startdate.ToShortDateString, v_enddate.ToShortDateString)
                Case 5
                    'Aktuelles Quartal
                    Select Case Date.Now.Month / 3
                        Case <= 1
                            '1.Quartal
                            v_startdate = New Date(Date.Now.Year, 1, 1)
                        Case <= 2
                            '2.Quartal
                            v_startdate = New Date(Date.Now.Year, 4, 1)
                        Case <= 3
                            '3.Quartal
                            v_startdate = New Date(Date.Now.Year, 7, 1)
                        Case <= 4
                            '4.Quartal
                            v_startdate = New Date(Date.Now.Year, 10, 1)
                    End Select
                    v_enddate = v_startdate.AddMonths(3).AddDays(-1)
                    'Set the Dates to pass them to the GUI
                    v_konto.SetShowDates(v_startdate.ToShortDateString, v_enddate.ToShortDateString)
                Case 6
                    'Aktuelles Halbjahr
                    If Date.Now.Month <= 6 Then
                        '1.Halbjahr
                        v_startdate = New Date(Date.Now.Year, 1, 1)
                        v_enddate = v_startdate.AddMonths(6)
                    Else
                        '2.Halbjahr
                        v_startdate = New Date(Date.Now.Year, 7, 1)
                        v_enddate = New Date(Date.Now.Year, 1, 1).AddYears(1)
                    End If
                    'Set the Dates to pass them to the GUI
                    v_enddate = v_enddate.AddDays(-1)
                    v_konto.SetShowDates(v_startdate.ToShortDateString, v_enddate.ToShortDateString)
                Case 7
                    'Aktuelles Jahr
                    v_startdate = New Date(Date.Now.Year, 1, 1)
                    v_enddate = New Date(Date.Now.Year, 1, 1).AddYears(1).AddDays(-1)
                    'Set the Dates to pass them to the GUI
                    v_konto.SetShowDates(v_startdate.ToShortDateString, v_enddate.ToShortDateString)
                Case 8
                    'Freier Zeitraum
                    'Removed because extended Filter was added Version 1.0.0.9
                    'Dim v_selector As New frm_timeframe
                    'Dim v_timeframe As New cls_timeframe_defined With {.start_date = New Date(Date.Now.Year, Date.Now.Month, 1), .end_date = New Date(Date.Now.Year, Date.Now.Month, DateTime.DaysInMonth(Date.Now.Year, Date.Now.Month))}
                    'With v_selector
                    '    .DataContext = v_timeframe
                    '    .ShowDialog()
                    '    If .DialogResult Then
                    '        v_startdate = v_timeframe.start_date
                    '        v_enddate = v_timeframe.end_date
                    '        'Set the Dates to pass them to the GUI
                    '        v_konto.SetShowDates(v_startdate.ToShortDateString, v_enddate.ToShortDateString)
                    '    Else
                    '        Exit Sub
                    '    End If
                    'End With

            End Select
            'Change 01.05.2017 Remove filter after setting the new date values (optical improvement)
            'Check if a filter is present:
            If v_konto.cvMixedChildren.IsLiveFiltering Then v_konto.cvMixedChildren.Filter = Nothing
            If Not v_konto.cvMixedChildren.Filter Is Nothing Then v_konto.cvMixedChildren.Filter = Nothing

            'Before doing the filtering check if not all transactions should be displayed:
            If v_zeitraum.Id = 1 Then
                v_konto.cvMixedChildren.Filter = Nothing
                v_konto.SetShowDates("", "")
                Exit Sub
            End If
            'V1.0.2.2 Enddate has to be lesser or equal than
            v_konto.cvMixedChildren.Filter = Function(o) TryCast(o, transactions_v01).datum >= v_startdate AndAlso TryCast(o, transactions_v01).datum < v_enddate.AddDays(1)
            KontoSorterView(v_konto)
            v_konto.cvMixedChildren.Refresh()
        End Sub

        Private Sub FilterKontoViewExtended(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            With v_konto
                'Because the toggle button changes the FilterExtendedUse immediatly before executing the command we have to ask for the vis verse boolean case.
                If .FilterExtendedUse = False Then
                    'Is in use deactivate only:
                    .FilterExtendedUse = False
                    v_konto.ChangeFilterNecessary = True
                    'Set the filter to the selected item of the combobox:
                    KontoFilterView(v_konto)
                Else
                    Dim v_adv_filter As New frm_advfilter
                    With v_adv_filter
                        .DataContext = v_konto.filter_ext_definition
                        .ShowDialog()
                        If .DialogResult Then
                            'Set the filter to the Konto
                            v_konto.FilterExtendedUse = True
                            SetExtendedFilter(v_konto)
                        Else
                            v_konto.FilterExtendedUse = False
                            'Set the filter to the selected item of the combobox:
                            KontoFilterView(v_konto)
                        End If
                    End With
                End If
            End With
        End Sub

        Private Sub SetExtendedFilter(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            'Filter in a different thread:
            v_konto.isBusy = True
            Dim thr_start As ThreadStart = Sub()

                                               Application.Current.Dispatcher.Invoke(DispatcherPriority.Background, New Action(Sub()
                                                                                                                                   SetExtendedFilterDo(v_konto)
                                                                                                                               End Sub))
                                               v_konto.isBusy = False
                                           End Sub
            Dim thr As New Thread(thr_start)
            thr.IsBackground = True
            thr.Name = "SetExtendedFilter" & v_konto.bezeichnung
            thr.Start()
        End Sub

        Private Sub SetExtendedFilterDo(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub

            Dim cGroupFilter As New cls_groupfilter

            With v_konto.filter_ext_definition
                '    'Now go through the filterdefinition:
                If .aktiv_typ Then
                    'Typ filter:
                    'Typ IDs are stored in a string with ; as separator:
                    Dim v_typ_ids As String() = .search_typ.Split(";")
                    cGroupFilter.AddFilter(New Predicate(Of Object)(Function(x) v_typ_ids.Contains(DirectCast(x, transactions_v01).transtyp_id.ToString)))
                End If
                If .aktiv_time Then
                    'Datum filter:
                    If .search_time_from <> Nothing AndAlso .search_time_to <> Nothing Then
                        cGroupFilter.AddFilter(New Predicate(Of Object)(Function(x)
                                                                            Try
                                                                                Return CBool(DirectCast(x, transactions_v01).datum >= v_konto.filter_ext_definition.search_time_from AndAlso DirectCast(x, transactions_v01).datum < v_konto.filter_ext_definition.search_time_to.AddDays(1))
                                                                            Catch ex As Exception
                                                                                Return False
                                                                            End Try
                                                                        End Function))
                        v_konto.SetShowDates(.search_time_from.ToShortDateString, .search_time_to.ToShortDateString)
                    End If
                End If
                If .aktiv_status Then
                    'status filter:
                    'status IDs are stored in a string with ; as separator:
                    Dim v_status_ids As String() = .search_status_ids.Split(";")
                    cGroupFilter.AddFilter(New Predicate(Of Object)(Function(x) v_status_ids.Contains(DirectCast(x, transactions_v01).transstatus_id.ToString)))
                End If
                If .aktiv_receiver Then
                    'receiver filter:
                    'receiver IDs are stored in a string with ; as separator:
                    Dim v_receiver_ids As String() = .selected_receiver_ids.Split(";")
                    cGroupFilter.AddFilter(New Predicate(Of Object)(Function(x) v_receiver_ids.Contains(DirectCast(x, transactions_v01).receiver_id.ToString)))
                End If
                If .aktiv_person Then
                    'person filter:
                    'perosn IDs are stored in a string with ; as separator:
                    Dim v_pers_ids As String() = .selected_person_ids.Split(";")
                    cGroupFilter.AddFilter(New Predicate(Of Object)(Function(x) v_pers_ids.Contains(DirectCast(x, transactions_v01).person_id.ToString)))
                End If
                If .aktiv_note Then
                    'Search note:
                    If .search_note_exact Then
                        'Exact Search:
                        cGroupFilter.AddFilter(New Predicate(Of Object)(Function(x) DirectCast(x, transactions_v01).comment.ToLower = v_konto.filter_ext_definition.search_note))
                    Else
                        'contains Search:
                        cGroupFilter.AddFilter(New Predicate(Of Object)(Function(x) DirectCast(x, transactions_v01).comment.ToLower.Contains(v_konto.filter_ext_definition.search_note)))
                    End If
                End If
                If .aktiv_value Then
                    'Search value:
                    If .search_value_from = Nothing Then .search_value_from = 0
                    If .search_value_to = Nothing Then .search_value_to = .search_value_from
                    cGroupFilter.AddFilter(New Predicate(Of Object)(Function(x) DirectCast(x, transactions_v01).get_transfer_totamount(v_konto.kto_id) >= v_konto.filter_ext_definition.search_value_from AndAlso DirectCast(x, transactions_v01).get_transfer_totamount(v_konto.kto_id) <= v_konto.filter_ext_definition.search_value_to))
                End If
                'Now asking for the category:
                If .aktiv_category Then
                    Dim v_cat_ids As String() = .selected_category_ids.Split(";")
                    cGroupFilter.AddFilter(New Predicate(Of Object)(Function(x)
                                                                        Dim v_trans As transactions_v01 = DirectCast(x, transactions_v01)
                                                                        If v_trans Is Nothing Then Return False
                                                                        If v_trans.nv_trans_t2k Is Nothing OrElse v_trans.nv_trans_t2k.Count = 0 Then Return False
                                                                        For Each v_t2k As trans_2_kat In v_trans.nv_trans_t2k
                                                                            If v_cat_ids.Contains(v_t2k.category_id.ToString) Then
                                                                                Return True
                                                                            End If
                                                                        Next
                                                                        Return False
                                                                    End Function))
                End If
                'Now asking for the tags:
                If .aktiv_tag Then
                    Dim v_tag_ids As String() = .selected_tag_ids.Split(";")
                    cGroupFilter.AddFilter(New Predicate(Of Object)(Function(x)
                                                                        Dim v_trans As transactions_v01 = DirectCast(x, transactions_v01)
                                                                        If v_trans Is Nothing Then Return False
                                                                        If v_trans.nv_trans_transtag Is Nothing OrElse v_trans.nv_trans_transtag.Count = 0 Then Return False
                                                                        For Each v_t2t As trans_tag_v01 In v_trans.nv_trans_transtag
                                                                            If v_tag_ids.Contains(v_t2t.tagid.ToString) Then
                                                                                Return True
                                                                            End If
                                                                        Next
                                                                        Return False
                                                                    End Function))
                End If
            End With

            v_konto.cvMixedChildren.Filter = cGroupFilter.Filter

            'If v_konto.cvMixedChildren.CanChangeLiveFiltering Then
            '    v_konto.cvMixedChildren.LiveFilteringProperties.Add("datum")
            '    v_konto.cvMixedChildren.IsLiveFiltering = True
            'End If



        End Sub


        Private Sub KontoSorterView(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            'Prüfen ob nicht bereits ein Filter aktiv ist:
            With v_konto
                .cvMixedChildren.SortDescriptions.Clear()
                .cvMixedChildren.SortDescriptions.Add(New SortDescription With {.PropertyName = "datum", .Direction = ListSortDirection.Descending})
                'FEHLER 2
            End With
        End Sub

        Private Async Sub KontoArchive(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            'New status is selected
            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie das Konto " & v_konto.bezeichnung & " wirklich archivieren?")

            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Konto archivieren", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then

                With v_konto
                    .BeginEdit()
                    .aktiv = False
                    .EndEdit()
                End With
                __konten_CollectionChanged(Me, Nothing)
                dbo.SaveChanges()
            End If
        End Sub


        'sub to perform some statistic operations:
        Private Sub KontoStatistikRibbon(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub

            'Statistic functions are:
            'Min
            'Max
            'Sum
            'Average
            'Standard Deviation
            With v_konto
                .Stat_Min = .SelectedObject.Min(Function(x) x.get_transfer_totamount(v_konto.kto_id))
                .Stat_Max = .SelectedObject.Max(Function(x) x.get_transfer_totamount(v_konto.kto_id))
                .Stat_Sum = .SelectedObject.Sum(Function(x) x.get_transfer_totamount(v_konto.kto_id))
                .Stat_Avg = .SelectedObject.Average(Function(p) p.get_transfer_totamount(v_konto.kto_id))
                .Stat_Count = .SelectedObject.Count
                .Stat_StdDev = CDec(Math.Sqrt(Math.Abs(CDbl(.Stat_Sum)) / .Stat_Count))
            End With
        End Sub

        Private Function KontoStatistikRibbonCanExecute(v_konto As konto_v01) As Boolean
            If v_konto Is Nothing Then Return False
            If v_konto.SelectedObject Is Nothing Then Return False
            If v_konto.SelectedObject.Count = 0 Then Return False
            Return True
        End Function

        Private Sub KontoBookingJournal(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            If v_konto.nv_kto_2_bookjournal Is Nothing Then v_konto.nv_kto_2_bookjournal = New bookjournal_v01
            dbo.SaveChanges()
            MenuAdd(v_konto.nv_kto_2_bookjournal)

        End Sub

        Private Sub CreateKontoReport(ByRef v_konto As konto_v01, Optional ByVal v_searchdefinition As searchdefinition_v01 = Nothing)
            If v_konto Is Nothing AndAlso v_searchdefinition Is Nothing Then Exit Sub

            Dim v_konto_report As New cls_menuitem_kontoreport

            If v_konto Is Nothing Then
                v_konto_report.PublicName = v_searchdefinition.search_bezeichnung
            Else
                v_konto_report.PublicName = v_konto.bezeichnung
            End If


            'Create the flowdocument to display:
            Dim v_rep_local As New FlowDocument With {.PageWidth = 1104, .ColumnGap = 0, .IsColumnWidthFlexible = True, .PageHeight = 768, .ColumnWidth = 1104}

            Dim v_rowcount As Integer = 1
            Dim v_oddrowbrush As Brush = SettingsCurrent.color_background_oddrow_brush
            Dim v_justrowbrush As Brush = SettingsCurrent.color_background_justrow_brush
            Dim v_headerbackgroundbrush As Brush = SettingsCurrent.color_background_header_brush
            Dim v_header_fontsize As Double = SettingsCurrent.header_fontsize
            Dim v_row_fontsize As Double = SettingsCurrent.row_fontsize



            With v_rep_local
                .Blocks.Clear()

                'Define the header depending on the given objects:
                If v_konto Is Nothing Then
                    'Header for a Searchdefinition
                    .Blocks.Add(New Paragraph(New Run(String.Format("Ergebnis für Suche: {0}", v_searchdefinition.search_bezeichnung)) With {.FontSize = v_header_fontsize}))
                    'Creation Date:
                    .Blocks.Add(New Paragraph(New Run(String.Format("Erstellt am {0}", Date.Now.ToShortDateString)) With {.FontSize = v_row_fontsize}) With {.TextAlignment = TextAlignment.Right})
                    'Add Search Parameters:
                    'Depending on what search type is used define the header:
                    .Blocks.Add(New Paragraph(New Run(String.Format("Suchdefinition", v_searchdefinition.search_bezeichnung)) With {.FontSize = If(v_header_fontsize > 3, v_header_fontsize - 2, v_header_fontsize)}))
                    If v_searchdefinition.nv_search_2_searchitem IsNot Nothing AndAlso v_searchdefinition.nv_search_2_searchitem.Count > 0 Then
                        Dim v_list As New List With {.MarkerStyle = TextMarkerStyle.None}
                        'extended search mode:
                        For Each v_item As searchitem_v01 In v_searchdefinition.nv_search_2_searchitem
                            Dim v_sstring As String = String.Format("{0} {1} {2} {3} {4} {5}", v_item.left_parenthesis, v_item.entity_str, v_item.comparer, v_item.search_value_display, v_item.right_parenthesis, v_item.link)
                            v_list.ListItems.Add(New ListItem(New Paragraph(New Run(v_sstring) With {.FontSize = v_row_fontsize})))
                        Next
                        .Blocks.Add(v_list)
                    Else
                        'standard search mode:
                        Dim v_sql_str As String = v_searchdefinition.SQLQuery.Substring(v_searchdefinition.SQLQuery.IndexOf("HAVING") + 7)
                        .Blocks.Add(New Paragraph(New Run(String.Format(v_sql_str, Date.Now.ToShortDateString)) With {.FontSize = v_row_fontsize}) With {.TextAlignment = TextAlignment.Left})
                    End If
                Else
                    .Blocks.Add(New Paragraph(New Run(String.Format("Kontoauszug für {0}", v_konto.bezeichnung)) With {.FontSize = v_header_fontsize}))
                    'Creation Date:
                    .Blocks.Add(New Paragraph(New Run(String.Format("Erstellt am {0}", Date.Now.ToShortDateString)) With {.FontSize = v_row_fontsize}) With {.TextAlignment = TextAlignment.Right})
                    'Timeframe:
                    .Blocks.Add(New Paragraph(New Run(String.Format("Buchungen von {0} bis {0}", v_konto.ShowFrom, v_konto.ShowTo)) With {.FontSize = v_row_fontsize}))
                End If

                'Maybe better to use a dictionary of string,integer....
                Dim v_header As New Dictionary(Of String, Integer) From {
                    New KeyValuePair(Of String, Integer)(“Typ", 8),
                    New KeyValuePair(Of String, Integer)("Link", 10),
                    New KeyValuePair(Of String, Integer)("Status", 12),
                    New KeyValuePair(Of String, Integer)("Datum", 15),
                    New KeyValuePair(Of String, Integer)("Betrag", 15),
                    New KeyValuePair(Of String, Integer)("Kategorie", 20),
                    New KeyValuePair(Of String, Integer)("Empfänger", 20),
                    New KeyValuePair(Of String, Integer)("zu Konto", 20),
                    New KeyValuePair(Of String, Integer)("Person", 20),
                    New KeyValuePair(Of String, Integer)("Bemerkung", 40)}

                If SettingsCurrent.active_person = False Then v_header.Remove("Person")
                If SettingsCurrent.active_receiver = False Then v_header.Remove("Empfänger")
                If SettingsCurrent.active_status = False Then v_header.Remove("Status")

                Dim v_transactionlist_header As New Grid With {.ShowGridLines = False}
                With v_transactionlist_header
                    'Header Row:
                    .RowDefinitions.Add(New RowDefinition)

                    For Each v_str As KeyValuePair(Of String, Integer) In v_header
                        .ColumnDefinitions.Add(New ColumnDefinition With {.Width = New GridLength(v_str.Value, GridUnitType.Star)})
                        Dim v_border As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = v_headerbackgroundbrush}
                        Dim v_lbl As New Label With {.Content = v_str.Key, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center}
                        v_border.Child = v_lbl
                        Grid.SetColumn(v_border, .ColumnDefinitions.Count - 1)
                        Grid.SetRow(v_border, 0)
                        .Children.Add(v_border)
                        v_lbl = Nothing
                    Next
                End With
                .Blocks.Add(New BlockUIContainer(v_transactionlist_header))


                Dim v_itemholder As ListCollectionView
                If v_konto Is Nothing Then
                    v_itemholder = v_searchdefinition.SearchResults
                Else
                    v_itemholder = v_konto.cvMixedChildren
                End If

                For Each v_item As transactions_v01 In v_itemholder
                    Dim v_rowgrid As New Grid
                    With v_rowgrid
                        For Each v_str As KeyValuePair(Of String, Integer) In v_header
                            .ColumnDefinitions.Add(New ColumnDefinition With {.Width = New GridLength(v_str.Value, GridUnitType.Star)})
                        Next
                        'add 1 more as needed for header
                        .RowDefinitions.Add(New RowDefinition)
                        Dim v_lastcolumn_no As Integer = 0
                        'define the row:
                        'Define Typ Image:
                        Dim v_border_typ As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_typ As New Image With {.Source = ConvertImageBytetoBitmapImage(v_item.nv_transtyp_trans_back.symbol_ever), .Width = 16, .Height = 16, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center}
                        v_border_typ.Child = v_typ
                        Grid.SetColumn(v_border_typ, v_lastcolumn_no)
                        Grid.SetRow(v_border_typ, .RowDefinitions.Count - 1)
                        .Children.Add(v_border_typ)
                        v_typ = Nothing
                        v_border_typ = Nothing
                        v_lastcolumn_no += 1
                        'Define Link Image:
                        Dim v_border_link As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_link As New Image With {.Source = ConvertImageBytetoBitmapImage(v_item.link_status_image), .Width = 16, .Height = 16, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center}
                        v_border_link.Child = v_link
                        Grid.SetColumn(v_border_link, v_lastcolumn_no)
                        Grid.SetRow(v_border_link, .RowDefinitions.Count - 1)
                        .Children.Add(v_border_link)
                        v_link = Nothing
                        v_border_link = Nothing
                        v_lastcolumn_no += 1
                        'Define Status Image:
                        Dim v_border_status As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Grid.SetColumn(v_border_status, v_lastcolumn_no)
                        Grid.SetRow(v_border_status, .RowDefinitions.Count - 1)
                        If v_item.nv_transstatus_trans_back IsNot Nothing AndAlso SettingsCurrent.active_status Then
                            Dim v_status As New Image With {.Source = ConvertImageBytetoBitmapImage(v_item.nv_transstatus_trans_back.symbol_ever), .Width = 16, .Height = 16, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Center}
                            v_border_status.Child = v_status
                            v_status = Nothing
                        End If
                        .Children.Add(v_border_status)
                        v_lastcolumn_no += 1
                        v_border_status = Nothing
                        'Define Datum Block
                        Dim v_border_datum As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_datum As New TextBlock With {.Text = v_item.datum.ToShortDateString, .VerticalAlignment = VerticalAlignment.Center, .FontSize = v_row_fontsize, .HorizontalAlignment = HorizontalAlignment.Center}
                        v_border_datum.Child = v_datum
                        Grid.SetColumn(v_border_datum, v_lastcolumn_no)
                        Grid.SetRow(v_border_datum, .RowDefinitions.Count - 1)
                        .Children.Add(v_border_datum)
                        v_datum = Nothing
                        v_border_datum = Nothing
                        v_lastcolumn_no += 1
                        'Define Amount Block
                        Dim v_border_amount As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_amount_value As Decimal = 0
                        If v_konto Is Nothing Then
                            'Search:
                            v_amount_value = v_item.totamount
                        Else
                            v_amount_value = v_item.get_transfer_totamount(v_konto.kto_id)
                        End If
                        Dim v_amount_color As Brush = Brushes.Black
                        'Color:
                        Select Case v_amount_value
                            Case > 0
                                Dim v_brush As Brush = CType(New BrushConverter().ConvertFromString(SettingsCurrent.color_pos_value), Brush)
                                v_amount_color = v_brush
                            Case < 0
                                Dim v_brush As Brush = CType(New BrushConverter().ConvertFromString(SettingsCurrent.color_neg_value), Brush)
                                v_amount_color = v_brush
                        End Select

                        Dim v_amount As New TextBlock With {.Text = v_amount_value.ToString, .VerticalAlignment = VerticalAlignment.Center, .HorizontalAlignment = HorizontalAlignment.Right, .Foreground = v_amount_color, .FontSize = v_row_fontsize}
                        v_border_amount.Child = v_amount
                        Grid.SetColumn(v_border_amount, v_lastcolumn_no)
                        Grid.SetRow(v_border_amount, .RowDefinitions.Count - 1)
                        .Children.Add(v_border_amount)
                        v_amount = Nothing
                        v_border_amount = Nothing
                        v_lastcolumn_no += 1
                        'Define Category Block
                        Dim v_border_cat As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_cat As New TextBlock With {.Text = v_item.single_category_marker, .VerticalAlignment = VerticalAlignment.Center, .FontSize = v_row_fontsize}
                        v_border_cat.Child = v_cat
                        Grid.SetColumn(v_border_cat, v_lastcolumn_no)
                        Grid.SetRow(v_border_cat, .RowDefinitions.Count - 1)
                        .Children.Add(v_border_cat)
                        v_cat = Nothing
                        v_border_cat = Nothing
                        v_lastcolumn_no += 1
                        'Define Receiver:
                        Dim v_border_rec As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Grid.SetColumn(v_border_rec, v_lastcolumn_no)
                        Grid.SetRow(v_border_rec, .RowDefinitions.Count - 1)
                        If v_item.nv_receiver_trans_back IsNot Nothing AndAlso SettingsCurrent.active_receiver Then
                            Dim v_rec As New TextBlock With {.Text = v_item.nv_receiver_trans_back.bezeichnung, .VerticalAlignment = VerticalAlignment.Center, .FontSize = v_row_fontsize}
                            v_border_rec.Child = v_rec
                            v_rec = Nothing
                        End If
                        .Children.Add(v_border_rec)
                        v_border_rec = Nothing
                        v_lastcolumn_no += 1
                        'Define to Konto:
                        Dim v_border_tokonto As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Grid.SetColumn(v_border_tokonto, v_lastcolumn_no)
                        Grid.SetRow(v_border_tokonto, .RowDefinitions.Count - 1)
                        If v_item.nv_kto_2_trans_transfer_back IsNot Nothing Then
                            Dim v_tokto As New TextBlock With {.Text = v_item.nv_kto_2_trans_transfer_back.bezeichnung, .VerticalAlignment = VerticalAlignment.Center, .FontSize = v_row_fontsize}
                            v_border_tokonto.Child = v_tokto
                            v_tokto = Nothing
                        End If
                        .Children.Add(v_border_tokonto)
                        v_border_tokonto = Nothing
                        v_lastcolumn_no += 1
                        'Define Person:
                        Dim v_border_person As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Grid.SetColumn(v_border_person, v_lastcolumn_no)
                        Grid.SetRow(v_border_person, .RowDefinitions.Count - 1)
                        If v_item.nv_person_trans_back IsNot Nothing AndAlso SettingsCurrent.active_person Then
                            Dim v_pers As New TextBlock With {.Text = v_item.nv_person_trans_back.bezeichnung, .VerticalAlignment = VerticalAlignment.Center, .FontSize = v_row_fontsize}
                            v_border_person.Child = v_pers
                            v_pers = Nothing
                        End If
                        .Children.Add(v_border_person)
                        v_border_person = Nothing
                        v_lastcolumn_no += 1
                        'Define Comment:
                        Dim v_border_comment As New Border With {.BorderBrush = Brushes.Black, .BorderThickness = New Thickness(1, 1, 1, 1), .Padding = New Thickness(3), .Background = If(v_rowcount Mod 2 = 0, v_justrowbrush, v_oddrowbrush)}
                        Dim v_comment As New TextBlock With {.Text = v_item.short_comment, .VerticalAlignment = VerticalAlignment.Center, .TextWrapping = TextWrapping.Wrap, .FontSize = v_row_fontsize}
                        v_border_comment.Child = v_comment
                        Grid.SetColumn(v_border_comment, v_lastcolumn_no)
                        Grid.SetRow(v_border_comment, .RowDefinitions.Count - 1)
                        .Children.Add(v_border_comment)
                        v_comment = Nothing
                        v_border_comment = Nothing
                        v_lastcolumn_no = 0

                        'Add 1 to rowcount for coloring:
                        v_rowcount += 1
                    End With

                    .Blocks.Add(New BlockUIContainer(v_rowgrid))
                    v_rowgrid = Nothing
                Next
            End With

            v_konto_report.ReportDocument = v_rep_local
            MenuAdd(v_konto_report)
        End Sub

        Private Sub KontoReportPrint(v_report As cls_menuitem_kontoreport)
            If v_report Is Nothing Then Exit Sub
            If v_report.ReportDocument Is Nothing Then Exit Sub

            Dim v_print_dia As New PrintDialog
            Dim v_print_server As New LocalPrintServer
            Dim v_print_queue As PrintQueue = v_print_server.DefaultPrintQueue
            Dim v_print_ticket As PrintTicket = v_print_queue.UserPrintTicket

            Dim v_pm_size As PageMediaSize = New PageMediaSize(v_report.ReportDocument.PageWidth, v_report.ReportDocument.PageHeight)
            v_print_ticket.PageMediaSize = v_pm_size
            v_print_ticket.PageOrientation = PageOrientation.Landscape

            Dim v_docpag As IDocumentPaginatorSource = TryCast(v_report.ReportDocument, IDocumentPaginatorSource)

            If v_docpag Is Nothing Then
                cls_logger.v_logger.Error("Umwandlung von v_report.ReportDocument in Paginator failed")
                v_report.cmdClose.Execute(Nothing)
                Exit Sub
            End If

            Dim v_imageablearea As System.Printing.PrintDocumentImageableArea = Nothing
            Dim v_docwriter As System.Windows.Xps.XpsDocumentWriter = System.Printing.PrintQueue.CreateXpsDocumentWriter(v_imageablearea)

            v_docpag.DocumentPaginator.ComputePageCount()
            Dim paginator As DocumentPaginator = v_docpag.DocumentPaginator
            paginator = New DocumentPaginatorWrapper(v_docpag.DocumentPaginator, New Size(1104, 768), New Size(20, 45))

            If v_docwriter IsNot Nothing AndAlso v_imageablearea IsNot Nothing Then
                v_docwriter.Write(paginator, v_print_ticket)
            End If
            'Close after print
            v_report.cmdClose.Execute(Nothing)
        End Sub
#End Region


#Region "Konto Stati Handler"

        Private Sub Konto_set_stati_all()
            For Each v_konto As konto_v01 In __konten
                Konto_set_stati(v_konto)
            Next
        End Sub

        ''' <summary>
        ''' Sets the Stati and Values of a given Konto
        ''' </summary>
        ''' <param name="v_konto"></param>
        ''' <returns></returns>
        Private Function Konto_set_stati_do(v_konto As konto_v01) As Boolean
            If v_konto Is Nothing Then Return False
            If v_konto.cvMixedChildren.Count = 0 Then Return False
            If Not v_konto.StatusAmounts Is Nothing Then v_konto.StatusAmounts.Clear()

            Try
                For Each v_item As trans_status_v01 In TransStatus
                    If v_item.nv_transstatus_trans IsNot Nothing AndAlso v_item.nv_transstatus_trans.Count > 0 Then
                        Dim v_amount As Decimal = 0
                        v_amount = v_item.nv_transstatus_trans.Where(Function(x) CBool(x.konto_id = v_konto.kto_id OrElse (x.to_konto_id IsNot Nothing AndAlso x.to_konto_id = v_konto.kto_id))).Sum(Function(x) x.get_transfer_totamount(v_konto.kto_id))
                        If v_amount <> 0 Then
                            v_konto.StatusAmounts.Add(New cls_statusamount(v_item.status_id, v_item.bezeichnung, v_amount, v_konto.start_value))
                        End If
                    End If
                Next
                Return True
            Catch ex As Exception
                cls_logger.v_logger.Error("Konto_set_stati_do failed: " & ex.Message)
            Debug.Print(ex.Message)
            Return False
            End Try
        End Function

        Private Sub Konto_set_stati(v_konto As konto_v01)
            Dim set_statis_thr_start As ThreadStart = Sub()
                                                          Application.Current.Dispatcher.Invoke(DispatcherPriority.Background, New Action(Sub()
                                                                                                                                              Konto_set_stati_do(v_konto)
                                                                                                                                          End Sub))
                                                      End Sub
            Dim set_statis_thr As New Thread(set_statis_thr_start)
            set_statis_thr.IsBackground = True
            set_statis_thr.Name = "Konto_set_stati"
            set_statis_thr.Start()
        End Sub


#End Region

    End Class
End Namespace

