﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Data.Entity
Imports System.Text
Imports System.Threading
Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Enttiy Search:

        'Collection of Entities for Search Selection
        Public Property Search_Entities As New List(Of Tuple(Of String, String))
        'Collection of Left Parenthesis
        Public Property Search_Paren_Left As New List(Of String) From {""}
        'Collection of Left Parenthesis
        Public Property Search_Paren_Right As New List(Of String) From {""}
        Public Property Search_Comparer As New List(Of String) From {"", "<", "<=", "=", ">", ">="}
        Public Property Search_Comparer_StrDate As New List(Of String) From {"", "=", "<>"}
        Public Property Search_Link As New List(Of String) From {"", "AND", "OR"}

        Private WithEvents __searches As New ObservableCollection(Of searchdefinition_v01)()
        Public Property Searches() As ListCollectionView

        Public ReadOnly Property SavedSearchesAvailable As Visibility
            Get
                If __searches.Count > 0 Then
                    Return Visibility.Visible
                Else
                    Return Visibility.Collapsed
                End If
                RaisePropertyChanged("SavedSearchesAvailable")
                RaisePropertyChanged("SavedSearchesAvailableInverse")
            End Get
        End Property

        Public ReadOnly Property SavedSearchesAvailableInverse As Visibility
            Get
                If SavedSearchesAvailable = Visibility.Visible Then
                    Return Visibility.Collapsed
                Else
                    Return Visibility.Visible
                End If
            End Get
        End Property

        'Public Property Search_Operators As New List(Of String) From {"<", "<=", ">", ">=", "<>", "="}
        'Public Property Search_LinkStyle As New List(Of String) From {"", "AND", "OR"}

        Public Property cmdSearchAdd As New RelayCommand(Sub() MenuAdd(New searchdefinition_v01), Function() MenuAddCanExecute(New searchdefinition_v01))
        Public Property cmdSearchOpen As New RelayCommand(Of searchdefinition_v01)(Sub(p) MenuAdd(p), Function(p) p IsNot Nothing)
        Public Property cmdSearchImage As New RelayCommand(Of searchdefinition_v01)(Sub(p) SearchImage(p), Function(p) p IsNot Nothing)
        Public Property cmdSearchSave As New RelayCommand(Of searchdefinition_v01)(Sub(p) SearchSave(p), Function(p) p IsNot Nothing)
        Public Property cmdSearchDelete As New RelayCommand(Of searchdefinition_v01)(Sub(p) SearchDelete(p), Function(p) p IsNot Nothing)
        Public Property cmdSearchExecute As New RelayCommand(Of searchdefinition_v01)(Sub(p) SearchExecute(p), Function(p) p IsNot Nothing)
        Public Property cmdSearchStatistikRibbon As New RelayCommand(Of searchdefinition_v01)(Sub(p) SearchStatistikRibbon(p), Function(p) SearchStatistikRibbonCanExecute(p))
        Public Property cmdCreateSearchReport As New RelayCommand(Of searchdefinition_v01)(Sub(p) CreateSearchReport(p), Function(p) p IsNot Nothing AndAlso p.SearchResults IsNot Nothing AndAlso p.SearchResults.Count > 0)
        Public Property cmdSearchMultiEdit As New RelayCommand(Of searchdefinition_v01)(Sub(p) SearchMultiEdit(p), Function(p) p IsNot Nothing AndAlso DirectCast(p, searchdefinition_v01).SelectedObject.Count > 0)

        'commands for adding a searchitem to a searchdefinition:
        Public Property cmdSearchItemAdd As New RelayCommand(Of searchdefinition_v01)(Sub(p) SearchItemAdd(p), Function(p) p IsNot Nothing)
        Public Property cmdSearchItemDelete As New RelayCommand(Of Object())(Sub(p) SearchItemDelete(p), Function(p) SearchItemDeleteCopyCanExecute(p))
        Public Property cmdSearchItemCopy As New RelayCommand(Of Object())(Sub(p) SearchItemCopy(p), Function(p) SearchItemDeleteCopyCanExecute(p))

        'Commands for handling Transaction Edit/Duplicate and Delete
        Public Property cmdSearchTransactionEdit As New RelayCommand(Of searchdefinition_v01)(Sub(p) SearchTransactionEdit(p), Function(p) p IsNot Nothing AndAlso DirectCast(p, searchdefinition_v01).SelectedObject IsNot Nothing AndAlso DirectCast(p, searchdefinition_v01).SelectedObject.Count > 0)
        Public Property cmdSearchTransactionDelete As New RelayCommand(Of searchdefinition_v01)(Sub(p) SearchTransactionDelete(p), Function(p) p IsNot Nothing AndAlso DirectCast(p, searchdefinition_v01).SelectedObject IsNot Nothing AndAlso DirectCast(p, searchdefinition_v01).SelectedObject.Count > 0)
        Public Property cmdSearchTransactionDuplicate As New RelayCommand(Of searchdefinition_v01)(Sub(p) SearchTransactionDuplicate(p), Function(p) p IsNot Nothing AndAlso DirectCast(p, searchdefinition_v01).SelectedObject IsNot Nothing AndAlso DirectCast(p, searchdefinition_v01).SelectedObject.Count > 0)

        Private Sub SearchesLoad()

            __searches.Clear()
            dbo.m_searchdefinition_v01.Load
            __searches = dbo.m_searchdefinition_v01.Local
            Searches = New ListCollectionView(__searches)
            Searches.MoveCurrentToFirst()


            'define the searchable entities:
            With Search_Entities
                If Not Search_Entities Is Nothing Then .Clear()
                .Add(New Tuple(Of String, String)("Status", "trans_status_v01"))
                .Add(New Tuple(Of String, String)("Typ", "trans_typ_v01"))
                .Add(New Tuple(Of String, String)("Konto", "konto_v01"))
                .Add(New Tuple(Of String, String)("zu Konto", "to_konto_v01"))
                If SettingsCurrent.active_receiver Then .Add(New Tuple(Of String, String)("Empfänger", "receiver_v01"))
                If SettingsCurrent.active_person Then .Add(New Tuple(Of String, String)("Person", "person_v01"))
                If SettingsCurrent.active_tags Then .Add(New Tuple(Of String, String)("Tag", "tags_v01"))
                .Add(New Tuple(Of String, String)("Kategorie", "category_v01"))
                .Add(New Tuple(Of String, String)("Bemerkung", "note"))
                .Add(New Tuple(Of String, String)("Datum", "date"))
                .Add(New Tuple(Of String, String)("Betrag", "value"))
            End With

            'add available parenthesis:
            Dim v_left_paren As String = "("
            Dim v_right_paren As String = ")"
            For i As Integer = 1 To 10
                Search_Paren_Left.Add(v_left_paren)
                Search_Paren_Right.Add(v_right_paren)
                v_left_paren &= "("
                v_right_paren &= ")"
            Next
        End Sub

        Private Sub SearchImage(v_searchitem As searchdefinition_v01)
            If v_searchitem Is Nothing Then Exit Sub
            Dim v_image As Byte() = get_symbol_from_dialog()
            If v_image IsNot Nothing Then
                v_searchitem.symbol = v_image
            End If
        End Sub

        Private Sub SearchSave(v_searchitem As searchdefinition_v01)
            If v_searchitem Is Nothing Then Exit Sub
            With Searches
                If Not .Contains(v_searchitem) Then
                    .AddNewItem(v_searchitem)
                    .CommitNew()
                End If
            End With
            dbo.SaveChanges()
        End Sub

        Private Async Sub SearchDelete(v_searchitem As searchdefinition_v01)
            If v_searchitem Is Nothing Then Exit Sub
            'New status is selected
            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie die gespeicherte Suche " & v_searchitem.search_bezeichnung & " löschen?")
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Suche löschen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                __searches.Remove(v_searchitem)
                dbo.SaveChanges()
            End If
        End Sub

        Private Sub __searches_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __searches.CollectionChanged
            If Not Searches Is Nothing Then
                If Not Searches.MoveCurrentToNext Then Searches.MoveCurrentToPrevious()
            End If
            RaisePropertyChanged("SavedSearchesAvailable")
            RaisePropertyChanged("SavedSearchesAvailableInverse")
        End Sub

        Private Sub SearchExecute(v_search As searchdefinition_v01)
            Dim v_mainwindow As MainWindow = DirectCast(Application.Current.MainWindow, MainWindow)
            'Before performing a search check if searching is possible (mainly used because a cross thread violation will accure if mahapps dialogs are used on main window:
            With v_search
                If .nv_search_2_searchitem.Count > 0 Then
                    If .search_time_from Is Nothing AndAlso .search_time_to Is Nothing Then
                        v_mainwindow.ShowMessageAsync("Fehler", "Suche wird abgebrochen, Zeitangabe(n) nicht vorhanden", MessageDialogStyle.Affirmative)
                        Exit Sub
                    End If
                    If .search_value_from Is Nothing Then
                        v_mainwindow.ShowMessageAsync("Fehler", "Suche wird abgebrochen, Betragsangabe(n) nicht vorhanden", MessageDialogStyle.Affirmative)
                        Exit Sub
                    End If
                End If

                v_search.is_busy = True
                Dim start As ThreadStart = Sub()
                                               Try
                                                   If v_search.SearchResults IsNot Nothing Then v_search.SearchResults = Nothing
                                                   'Check if there should be a standard or extended search performed:
                                                   If v_search.nv_search_2_searchitem.Count > 0 Then
                                                       v_search.SearchResults = New ListCollectionView(dbo.m_transactions_v01.SqlQuery(search_extended_sql_builder(v_search)).ToList)
                                                   Else
                                                       Dim v_query As String = search_standard_sql_builder(v_search)
                                                       'The used query is stored in a notmapped property to provide it for a print (easy but ugly solution...)
                                                       v_search.SQLQuery = v_query
                                                       v_search.SearchResults = New ListCollectionView(dbo.m_transactions_v01.SqlQuery(v_query).ToList)
                                                   End If
                                                   v_search.SearchResults.SortDescriptions.Add(New SortDescription With {.PropertyName = "datum", .Direction = ListSortDirection.Ascending})
                                                   v_search.is_busy = False
                                               Catch ex As Exception
                                                   cls_logger.v_logger.Error(ex.Message)
                                                   Debug.Print(ex.Message)
                                                   v_search.is_busy = False
                                               End Try

                                           End Sub

                Dim thr As New Thread(start)
                thr.Start()
            End With

        End Sub

        Dim v_search_sql As String = "SELECT transactions_v01.trans_id, transactions_v01.comment, transactions_v01.datum, transactions_v01.konto_id, transactions_v01.to_konto_id, transactions_v01.transtyp_id, transactions_v01.transstatus_id, transactions_v01.receiver_id, transactions_v01.person_id, transactions_v01.journal_id, transactions_v01.totamount From (transactions_v01 LEFT JOIN trans_2_kat ON transactions_v01.trans_id = trans_2_kat.transaction_id) LEFT JOIN trans_tag_v01 ON transactions_v01.trans_id = trans_tag_v01.transaction_id GROUP BY transactions_v01.trans_id, transactions_v01.comment, transactions_v01.datum, transactions_v01.konto_id, transactions_v01.to_konto_id, transactions_v01.transtyp_id, transactions_v01.transstatus_id, transactions_v01.receiver_id, transactions_v01.person_id, transactions_v01.totamount, transactions_v01.journal_id, trans_2_kat.Id, trans_2_kat.transaction_id, trans_2_kat.category_id, trans_tag_v01.Id, trans_tag_v01.tagid, trans_tag_v01.transaction_id"

        ''' <summary>
        ''' SQL Builder in case of standard search
        ''' </summary>
        ''' <param name="v_search">Searchdefinition which shall be base for the sql string</param>
        ''' <returns>SQL string for query</returns>
        Private Function search_standard_sql_builder(v_search As searchdefinition_v01) As String

            If v_search Is Nothing Then Return ""
            Dim v_sql As String = v_search_sql
            With v_search
                'Timespan
                If .aktiv_time Then
                    'Check if entries are available and correct:
                    If .search_time_from Is Nothing AndAlso .search_time_to Is Nothing Then
                        Return Nothing
                    End If
                    If v_sql.EndsWith("_id") Then v_sql &= " HAVING "

                    If Not .search_time_from Is Nothing Then
                        Dim v_from As Date = CDate(.search_time_from)
                        Dim v_from_str As String = v_from.Month.ToString & "/" & v_from.Day.ToString & "/" & v_from.Year.ToString
                        v_sql &= "datum >= '" & v_from_str & "'"
                    End If

                    If Not .search_time_to Is Nothing Then
                        Dim v_to As Date = CDate(.search_time_to)
                        Dim v_to_str As String = v_to.Month.ToString & "/" & v_to.Day.ToString & "/" & v_to.Year.ToString
                        If v_sql.EndsWith("'") Then v_sql &= " AND "
                        v_sql &= "datum <= '" & v_to_str & "'"
                    End If
                End If

                'Betrag
                If .aktiv_value Then
                    'Check if entries are available and correct:
                    If .search_value_from Is Nothing Then
                        Return Nothing
                    End If
                    If .search_value_to Is Nothing Then .search_value_to = .search_value_from

                    If v_sql.EndsWith("_id") Then
                        v_sql &= " HAVING "
                    Else
                        v_sql &= " AND"
                    End If
                    v_sql &= " totamount >= " & v_search.search_value_from.ToString & " AND totamount <= " & v_search.search_value_to.ToString

                    'hier musss noch überlegt werden wie mit negativen werten umgegangen wird da in der datenbank die werte neutral gespeichert sind

                End If
                'Bemerkung
                If .aktiv_note Then
                    If v_sql.EndsWith("_id") Then
                        v_sql &= " HAVING "
                    Else
                        v_sql &= " AND"
                    End If

                    If .search_note_exact Then
                        'exact Search
                        v_sql &= " comment like '" & .search_note & "'"
                    Else
                        'contains
                        v_sql &= " comment like '%" & .search_note & "%'"
                    End If
                End If
                'Status
                If .aktiv_status Then
                    If v_sql.EndsWith("_id") Then
                        v_sql &= " HAVING ( "
                    Else
                        v_sql &= " AND ( "
                    End If
                    Dim v_statusid As Integer = CInt(.search_status)
                    v_sql &= "transstatus_id =" & v_statusid
                    v_sql &= ")"
                End If
                'Typ
                If .aktiv_typ Then
                    If v_sql.EndsWith("_id") Then
                        v_sql &= " HAVING ( "
                    Else
                        v_sql &= " AND ( "
                    End If
                    Dim v_typid As Integer = CInt(.search_typ)
                    v_sql &= "transtyp_id =" & v_typid
                    v_sql &= ")"
                End If
                'Konto
                If .aktiv_konto Then
                    If v_sql.EndsWith("_id") Then
                        v_sql &= " HAVING ( "
                    Else
                        v_sql &= " AND ( "
                    End If
                    Dim v_ktoid As Integer = CInt(.search_konto)
                    v_sql &= "konto_id =" & v_ktoid
                    v_sql &= ")"
                End If
                'to Konto
                If .aktiv_tokonto Then
                    If v_sql.EndsWith("_id") Then
                        v_sql &= " HAVING ( "
                    Else
                        v_sql &= " AND ( "
                    End If
                    Dim v_toktoid As Integer = CInt(.search_tokonto)
                    v_sql &= "to_konto_id =" & v_toktoid
                    v_sql &= ")"
                End If
                'Empfänger
                If .aktiv_receiver Then
                    If v_sql.EndsWith("_id") Then
                        v_sql &= " HAVING ( "
                    Else
                        v_sql &= " AND ( "
                    End If
                    Dim v_receiverid As Integer = CInt(.search_receiver)
                    v_sql &= "receiver_id =" & v_receiverid
                    v_sql &= ")"
                End If
                'Person
                If .aktiv_person Then
                    If v_sql.EndsWith("_id") Then
                        v_sql &= " HAVING ( "
                    Else
                        v_sql &= " AND ( "
                    End If
                    Dim v_personid As Integer = CInt(.search_person)
                    v_sql &= "person_id =" & v_personid
                    v_sql &= ")"
                End If
                'Tag
                If .aktiv_tag Then
                    If v_sql.EndsWith("_id") Then
                        v_sql &= " HAVING ( "
                    Else
                        v_sql &= " AND ( "
                    End If
                    Dim v_tagid As Integer = CInt(.search_tag)
                    v_sql &= "trans_tag_v01.tagid =" & v_tagid
                    v_sql &= ")"
                End If
                'Kategorie
                If .aktiv_category Then
                    If .search_category_subcats Then
                        'Search for all Subcats if given category has one:
                        Dim v_maincat As category_v01 = __categories.Where(Function(x) x.cat_id = CInt(.search_category)).FirstOrDefault
                        If v_maincat Is Nothing Then
                            cls_logger.v_logger.Error("Search Basic aktiv category + subcats couldn't retrieve category")
                            Return Nothing
                        End If
                        If v_maincat.nv_subcats Is Nothing OrElse v_maincat.nv_subcats.Count = 0 Then
                            'Search just this category:
                            If v_sql.EndsWith("_id") Then
                                v_sql &= " HAVING ( "
                            Else
                                v_sql &= " AND ( "
                            End If
                            Dim v_catid As Integer = CInt(.search_category)
                            v_sql &= "trans_2_kat.category_id =" & v_catid
                            v_sql &= ")"
                        Else
                            'given category has childs:
                            If v_sql.EndsWith("_id") Then
                                v_sql &= " HAVING ( "
                            Else
                                v_sql &= " AND ( "
                            End If
                            Dim v_catid As Integer = CInt(.search_category)
                            v_sql &= "( trans_2_kat.category_id =" & v_catid
                            For Each v_childcat As category_v01 In v_maincat.nv_subcats
                                v_sql &= " OR trans_2_kat.category_id =" & v_childcat.cat_id
                            Next
                            v_sql &= "))"
                            v_maincat = Nothing
                        End If
                    Else
                        'Search just this category:
                        If v_sql.EndsWith("_id") Then
                            v_sql &= " HAVING ( "
                        Else
                            v_sql &= " AND ( "
                        End If
                        Dim v_catid As Integer = CInt(.search_category)
                        v_sql &= "trans_2_kat.category_id =" & v_catid
                        v_sql &= ")"
                    End If
                End If
            End With
            Debug.Print("Query: " & v_sql)
            Return v_sql
        End Function

        ''' <summary>
        ''' SQL Builder in case of extended search
        ''' </summary>
        ''' <param name="v_search">Searchdefinition which shalle be base for the sql string</param>
        ''' <returns>SQL string for query</returns>
        Private Function search_extended_sql_builder(v_search As searchdefinition_v01) As String
            If v_search Is Nothing Then Return ""
            Dim v_sql As String = v_search_sql & " HAVING "
            With v_search
                For Each v_sitem As searchitem_v01 In .nv_search_2_searchitem
                    If v_sitem.aktiv Then v_sql &= v_sitem.search_term
                Next
            End With
            Debug.Print(v_sql)
            Return v_sql
        End Function

        'sub to perform some statistic operations:
        Private Sub SearchStatistikRibbon(v_search As searchdefinition_v01)
            If v_search Is Nothing Then Exit Sub

            'Statistic functions are:
            'Min
            'Max
            'Sum
            'Average
            'Standard Deviation
            With v_search
                .Stat_Min = .SelectedObject.Min(Function(p) p.totamount)
                .Stat_Max = .SelectedObject.Max(Function(p) p.totamount)
                .Stat_Sum = .SelectedObject.Sum(Function(p) p.totamount)
                .Stat_Avg = .SelectedObject.Average(Function(p) p.totamount)
                .Stat_Count = .SelectedObject.Count
                .Stat_StdDev = CDec(Math.Sqrt(.Stat_Sum / .Stat_Count))
            End With
        End Sub

        Private Function SearchStatistikRibbonCanExecute(v_search As searchdefinition_v01) As Boolean
            If v_search Is Nothing Then Return False
            If v_search.SelectedObject Is Nothing Then Return False
            If v_search.SelectedObject.Count = 0 Then Return False
            Return True
        End Function


        Private Sub CreateSearchReport(v_search As searchdefinition_v01)
            If v_search Is Nothing Then Exit Sub
            If v_search.SearchResults Is Nothing Then Exit Sub
            If v_search.SearchResults.Count = 0 Then Exit Sub
            'We use the konto report:
            CreateKontoReport(Nothing, v_search)
        End Sub

        Private Async Sub SearchMultiEdit(v_searchdef As searchdefinition_v01)
            If v_searchdef Is Nothing Then Exit Sub
            If v_searchdef.SelectedObject.Count = 0 Then Exit Sub
            Dim v_result As Tuple(Of Boolean, cls_multiedit_definition) = Await MultiEditDefinitionandDialog()

            If v_result.Item1 = True Then
                For Each v_trans As transactions_v01 In v_searchdef.SelectedObject
                    v_trans.BeginEdit()
                    With v_result.Item2
                        If .Datum_active Then v_trans.datum = .Datum
                        If .Person_active Then v_trans.person_id = .PersonId
                        If .Receiver_active Then v_trans.receiver_id = .ReceiverId
                        If .Status_active Then v_trans.transstatus_id = .StatusId
                    End With
                    v_trans.EndEdit()
                Next
                dbo.SaveChanges()
                dbo.ChangeTracker.DetectChanges()
                'Update all Charts:
                ChartsLoadAndUpdate()
                'Update all Account Status Amounts:
                Call Konto_set_stati_all()
                'Update of all targetdefinitions:
                Call RecalculateAllSavingTargets()
            End If

        End Sub


        ''' <summary>
        ''' Function to find a Display Value for Extended Search Mode depending on the search enttiy.
        ''' </summary>
        ''' <param name="v_search_entity">Search Entity from the Database</param>
        ''' <returns>Bezeichnung or name to display</returns>
        Public Function SearchItemView(v_search_entity As String, v_search_id As Integer) As String
            If v_search_entity = "" Then Return String.Empty
            If v_search_id = Nothing Then Return String.Empty
            Try
                Select Case v_search_entity
                    Case "trans_status_v01"
                        Dim v_result As trans_status_v01 = __status.First(Function(x) x.status_id = v_search_id)
                        If v_result Is Nothing Then
                            Return String.Empty
                        Else
                            Return v_result.bezeichnung
                        End If
                    Case "trans_typ_v01"
                        Dim v_result As trans_typ_v01 = __typen.First(Function(x) x.typ_id = v_search_id)
                        If v_result Is Nothing Then
                            Return String.Empty
                        Else
                            Return v_result.bezeichnung
                        End If
                    Case "konto_v01", "to_konto_v01"
                        Dim v_result As konto_v01 = __konten.First(Function(x) x.kto_id = v_search_id)
                        If v_result Is Nothing Then
                            Return String.Empty
                        Else
                            Return v_result.bezeichnung
                        End If
                    Case "receiver_v01"
                        Dim v_result As receiver_v01 = __reveicer.First(Function(x) x.rec_id = v_search_id)
                        If v_result Is Nothing Then
                            Return String.Empty
                        Else
                            Return v_result.bezeichnung
                        End If
                    Case "person_v01"
                        Dim v_result As person_v01 = __persons.First(Function(x) x.pers_id = v_search_id)
                        If v_result Is Nothing Then
                            Return String.Empty
                        Else
                            Return v_result.bezeichnung
                        End If
                    Case "tags_v01"
                        Dim v_result As tags_v01 = __tags.First(Function(x) x.tag_id = v_search_id)
                        If v_result Is Nothing Then
                            Return String.Empty
                        Else
                            Return v_result.bezeichnung
                        End If
                    Case "category_v01"
                        Dim v_result As category_v01 = __categories.First(Function(x) x.cat_id = v_search_id)
                        If v_result Is Nothing Then
                            Return String.Empty
                        Else
                            Return v_result.bezeichnung
                        End If
                End Select
            Catch ex As Exception
                cls_logger.v_logger.Error(ex.Message.ToString)
                Return String.Empty
            End Try


            Return String.Empty

        End Function

        Private Sub SearchItemAdd(v_searchdefinition As searchdefinition_v01)
            If v_searchdefinition Is Nothing Then Exit Sub

            Dim v_newitem As New searchitem_v01 With {.entity_str = Search_Entities.First.Item2, .comparer = Search_Comparer.First}
            v_searchdefinition.nv_search_2_searchitem.Add(v_newitem)
            v_newitem.NotifyAll()
            v_newitem = Nothing
        End Sub

        Private Sub SearchItemDelete(paras As Object())
            If paras Is Nothing Then Exit Sub
            Dim v_definition As searchdefinition_v01 = DirectCast(paras(0), searchdefinition_v01)
            Dim v_items As IEnumerable(Of searchitem_v01) = DirectCast(paras(1), IList).Cast(Of searchitem_v01)
            If v_definition Is Nothing Then Exit Sub
            If v_items Is Nothing Then Exit Sub

            While v_items.Count > 0
                v_definition.nv_search_2_searchitem.Remove(v_items.First)
            End While
        End Sub

        Private Sub SearchItemCopy(paras As Object())
            If paras Is Nothing Then Exit Sub
            Dim v_definition As searchdefinition_v01 = DirectCast(paras(0), searchdefinition_v01)
            Dim v_items As IEnumerable(Of searchitem_v01) = DirectCast(paras(1), IList).Cast(Of searchitem_v01)
            If v_definition Is Nothing Then Exit Sub
            If v_items Is Nothing Then Exit Sub

            For Each v_item As searchitem_v01 In v_items
                Dim v_newitem As searchitem_v01 = v_item
                v_newitem.search_id = Nothing
                v_definition.nv_search_2_searchitem.Add(v_newitem)
                v_newitem.NotifyAll()
                v_newitem = Nothing
            Next
        End Sub

        Private Function SearchItemDeleteCopyCanExecute(paras As Object()) As Boolean
            'Issues an error during the avalon document is draged...
            Try
                If paras Is Nothing Then Return False
                Dim v_definition As searchdefinition_v01 = TryCast(paras(0), searchdefinition_v01)
                Dim v_items As IEnumerable(Of searchitem_v01) = TryCast(paras(1), IList).Cast(Of searchitem_v01)
                If v_definition Is Nothing Then Return False
                If v_items Is Nothing Then Return False
                If v_items.Count = 0 Then Return False
                Return True
            Catch ex As Exception
                Return False
            End Try
        End Function

        Private Sub SearchTransactionEdit(v_searchdefinition As searchdefinition_v01)
            If v_searchdefinition Is Nothing Then Exit Sub
            If v_searchdefinition.SelectedObject Is Nothing OrElse v_searchdefinition.SelectedObject.Count = 0 Then Exit Sub

            'Edit the first entry:
            TransactionEdit(v_searchdefinition.SelectedObject.FirstOrDefault)
        End Sub

        Private Async Sub SearchTransactionDelete(v_searchdefinition As searchdefinition_v01)
            If v_searchdefinition Is Nothing Then Exit Sub
            Dim v_question As String
            If v_searchdefinition.SelectedObject.Count = 1 Then
                v_question = "Wollen Sie die gewählte Buchung löschen?"
            Else
                v_question = "Wollen Sie die gewählten {0} Buchungen löschen?"
                v_question = String.Format(v_question, v_searchdefinition.SelectedObject.Count.ToString)
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Löschvorgang bestätigen", v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            If result = MessageDialogResult.Affirmative Then
                Dim v_selobjs_local As List(Of transactions_v01) = CType(v_searchdefinition.SelectedObject, List(Of transactions_v01))
                While v_selobjs_local.Count > 0
                    Dim v_entry As transactions_v01 = v_selobjs_local.First
                    dbo.m_transactions_v01.Remove(v_entry)
                    dbo.ChangeTracker.DetectChanges()
                    v_selobjs_local.Remove(v_entry)
                    v_entry = Nothing
                End While
                dbo.SaveChanges()
            End If

            For Each v_konto As konto_v01 In __konten
                v_konto.notify_kontovaluechange()
            Next
            'Update all Charts:
            ChartsLoadAndUpdate()
            'Update all Account Status Amounts:
            Call Konto_set_stati_all()
            'Update of all targetdefinitions:
            Call RecalculateAllSavingTargets()
            'Redo the Search:
            SearchExecute(v_searchdefinition)
        End Sub

        Private Async Sub SearchTransactionDuplicate(v_searchdefinition As searchdefinition_v01)
            If v_searchdefinition Is Nothing Then Exit Sub
            Dim v_question As String
            If v_searchdefinition.SelectedObject.Count = 1 Then
                v_question = "Wollen Sie die gewählte Buchung duplizieren?"
            Else
                v_question = "Wollen Sie die gewählten {0} Buchungen duplizieren?"
                v_question = String.Format(v_question, v_searchdefinition.SelectedObject.Count.ToString)
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = DirectCast(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Vervielfältigung bestätigen", v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                For Each v_trans As transactions_v01 In v_searchdefinition.SelectedObject
                    Dim v_trans_new As New transactions_v01
                    With v_trans_new
                        .comment = v_trans.comment
                        .datum = v_trans.datum
                        .konto_id = v_trans.konto_id
                        .to_konto_id = v_trans.to_konto_id
                        .transtyp_id = v_trans.transtyp_id
                        .transstatus_id = v_trans.transstatus_id
                        .receiver_id = v_trans.receiver_id
                        .person_id = v_trans.person_id
                    End With

                    For Each v_old_cat As trans_2_kat In v_trans.nv_trans_t2k
                        Dim v_newcat As New trans_2_kat With {.amount = v_old_cat.amount, .category_id = v_old_cat.category_id}
                        v_trans_new.nv_trans_t2k.Add(v_newcat)
                        v_newcat = Nothing
                    Next

                    For Each v_old_tag As trans_tag_v01 In v_trans.nv_trans_transtag
                        Dim v_newtag As New trans_tag_v01 With {.bezeichnung_help = v_old_tag.bezeichnung_help, .tagid = v_old_tag.tagid}
                        v_trans_new.nv_trans_transtag.Add(v_newtag)
                        v_newtag = Nothing
                    Next

                    v_trans_new.TotAmountCalc()
                    Transactions.AddNewItem(v_trans_new)
                    Transactions.MoveCurrentToLast()
                    Transactions.CommitNew()

                    dbo.SaveChanges()
                Next
            End If
            For Each v_konto As konto_v01 In __konten
                v_konto.notify_kontovaluechange()
            Next
            'Update all Charts:
            ChartsLoadAndUpdate()
            'Update all Account Status Amounts:
            Call Konto_set_stati_all()
            'Update of all targetdefinitions:
            Call RecalculateAllSavingTargets()
            'Redo the Search:
            SearchExecute(v_searchdefinition)
        End Sub


    End Class
End Namespace