﻿Imports MahApps.Metro

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial: Themes:

        'Akzent Farben Auflistung:
        Public Property AccentColors() As List(Of AccentColorMenuData)
            Get
                Return m_AccentColors
            End Get
            Set
                m_AccentColors = Value
            End Set
        End Property
        Private m_AccentColors As List(Of AccentColorMenuData)

        'Themes Auflistung:
        Public Property AppThemes() As List(Of AppThemeMenuData)
            Get
                Return m_AppThemes
            End Get
            Set
                m_AppThemes = Value
            End Set
        End Property
        Private m_AppThemes As List(Of AppThemeMenuData)

        Public Property AppIcons As New cls_imagesets_available


        Dim v_imageset_current As ResourceDictionary = Nothing
        Public Property imageset_current As ResourceDictionary
            Get
                Return v_imageset_current
            End Get
            Set(value As ResourceDictionary)
                v_imageset_current = value
            End Set
        End Property




        Private Sub ThemesLoad()
            ' Verfügbare Akzent Farben
            AccentColors = ThemeManager.Accents.[Select](Function(a) New AccentColorMenuData() With {
                .Name = a.Name,
                .ColorBrush = TryCast(a.Resources("AccentColorBrush"), Brush)
            }).ToList()

            ' Verfügbare Themes
            AppThemes = ThemeManager.AppThemes.[Select](Function(a) New AppThemeMenuData() With {
                .Name = a.Name,
                .BorderColorBrush = TryCast(a.Resources("BlackColorBrush"), Brush),
                .ColorBrush = TryCast(a.Resources("WhiteColorBrush"), Brush)
            }).ToList()

            'Find Resourcedictionary of iconsets:
            For Each v_dict As ResourceDictionary In Application.Current.Resources.MergedDictionaries
                If v_dict.Source.ToString.Contains("Icons_") Then
                    imageset_current = v_dict
                    Exit For
                End If
            Next

            'Set current iconset
            Dim v_current_icons As String = GetValueFromRegistryKey("used_icons")
            If Not v_current_icons = String.Empty Then
            Else
                SetValueFromRegistryKey("used_icons", "win10")
            End If
            current_imageset = AppIcons.ImageSets.Where(Function(x) x.Key.ToLower = v_current_icons.ToLower).FirstOrDefault

        End Sub


        ''Theme setzen:
        'Dim appstyle As Tuple(Of AppTheme, Accent) = ThemeManager.DetectAppStyle(Application.Current)
        '' now set the Green accent and dark theme
        'ThemeManager.ChangeAppStyle(Application.Current, ThemeManager.GetAccent("Green"), ThemeManager.GetAppTheme("BaseDark"))

        Public Function change_theme(v_accent As String, v_theme As String) As Boolean


            Dim appstyle As Tuple(Of AppTheme, Accent) = ThemeManager.DetectAppStyle(Application.Current)

            If v_accent = "" And v_theme = "" Then
                Return False
            Else
                If v_accent = "" Then
                    ThemeManager.ChangeAppStyle(Application.Current, ThemeManager.GetAccent(appstyle.Item2.ToString), ThemeManager.GetAppTheme(v_theme))
                    Fluent.ThemeManager.ChangeAppStyle(Application.Current, Fluent.ThemeManager.GetAccent(appstyle.Item2.ToString), Fluent.ThemeManager.GetAppTheme(v_theme))
                    Return True
                End If
                If v_theme = "" Then
                    ThemeManager.ChangeAppStyle(Application.Current, ThemeManager.GetAccent(v_accent), ThemeManager.GetAppTheme(appstyle.Item1.ToString))
                    Fluent.ThemeManager.ChangeAppStyle(Application.Current, Fluent.ThemeManager.GetAccent(v_accent), Fluent.ThemeManager.GetAppTheme(appstyle.Item1.ToString))
                    Return True
                End If
                ThemeManager.ChangeAppStyle(Application.Current, ThemeManager.GetAccent(v_accent), ThemeManager.GetAppTheme(v_theme))
                Fluent.ThemeManager.ChangeAppStyle(Application.Current, Fluent.ThemeManager.GetAccent(v_accent), Fluent.ThemeManager.GetAppTheme(v_theme))
                Return True
            End If
        End Function

        Public ReadOnly Property current_style As Tuple(Of AppTheme, Accent)
            Get
                Return ThemeManager.DetectAppStyle(Application.Current)
            End Get
        End Property

        Dim v_current_theme_color As AppThemeMenuData
        Public Property current_theme_color As AppThemeMenuData
            Get
                Dim v_theme As Tuple(Of AppTheme, Accent) = ThemeManager.DetectAppStyle(Application.Current)
                Dim v_appthemedata As AppThemeMenuData = AppThemes.Where(Function(x) x.Name = v_theme.Item1.Name).First
                If v_appthemedata Is Nothing Then
                    Return Nothing
                Else
                    Return v_appthemedata
                End If
            End Get
            Set(value As AppThemeMenuData)
                SetValueFromRegistryKey("metro_theme", value.Name)
                v_current_theme_color = value
                ThemeManager.ChangeAppTheme(Application.Current, value.Name)
                Fluent.ThemeManager.ChangeAppTheme(Application.Current, value.Name)
            End Set
        End Property

        Dim v_current_accent_color As AccentColorMenuData
        Public Property current_accent_color As AccentColorMenuData
            Get
                Dim v_theme As Tuple(Of AppTheme, Accent) = ThemeManager.DetectAppStyle(Application.Current)
                Dim v_colordata As AccentColorMenuData = AccentColors.Where(Function(x) x.Name = v_theme.Item2.Name).First
                If v_colordata Is Nothing Then
                    Return Nothing
                Else
                    Return v_colordata
                End If
            End Get
            Set(value As AccentColorMenuData)
                SetValueFromRegistryKey("metro_accent", value.Name)
                v_current_accent_color = value
                Dim v_theme As Tuple(Of AppTheme, Accent) = ThemeManager.DetectAppStyle(Application.Current)
                ThemeManager.ChangeAppStyle(Application.Current, ThemeManager.GetAccent(value.Name), current_style.Item1)
                Fluent.ThemeManager.ChangeAppStyle(Application.Current, Fluent.ThemeManager.GetAccent(value.Name), Fluent.ThemeManager.GetAppTheme(v_theme.Item1.Name))


            End Set
        End Property

        Dim v_current_imageset As cls_imageset
        Public Property current_imageset As cls_imageset
            Get
                Return v_current_imageset
            End Get
            Set(value As cls_imageset)
                v_current_imageset = value
                If Not value Is Nothing Then
                    imageset_current.Source = value.imageset
                    SetValueFromRegistryKey("used_icons", value.Key)
                End If
                RaisePropertyChanged("current_imageset")
            End Set
        End Property


    End Class
End Namespace