﻿Imports System.Collections.ObjectModel
Imports System.Data.Entity
Imports System.Text
Imports MahApps.Metro.Controls.Dialogs
Imports Microsoft.WindowsAPICodePack.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Transationen:

        Private WithEvents __transactions As New ObservableCollection(Of transactions_v01)
        Private WithEvents __t2k As New ObservableCollection(Of trans_2_kat)
        ''' <summary>
        ''' Alle Transaktionen
        ''' </summary>
        ''' <returns></returns>
        Public Property Transactions As ListCollectionView

        Private Sub TransactionsLoad()
            __transactions.Clear()
            __t2k.Clear()
            dbo.m_transactions_v01.Load
            dbo.m_trans_2_kat.Load
            __transactions = dbo.m_transactions_v01.Local
            __t2k = dbo.m_trans_2_kat.Local
            Transactions = New ListCollectionView(__transactions)
        End Sub


        Private Sub __transactions_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __transactions.CollectionChanged
            'If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not Transactions Is Nothing Then
                If Not Transactions.MoveCurrentToNext Then Transactions.MoveCurrentToPrevious()
            End If
        End Sub

#Region "Commands"
        Public Property cmdTransactionAdd As New RelayCommand(Of Object())(Sub(p) TransactionAdd(p), Function(p) TransactionAddCanExecute(p))
        Public Property cmdTransactionEdit As New RelayCommand(Of transactions_v01)(Sub(p) TransactionEdit(p), Function(p) p IsNot Nothing)
        Public Property cmdTransactionEditRibbon As New RelayCommand(Of konto_v01)(Sub(p) TransactionEditRibbon(p), Function(p) TransactionEditRibbonCanExecute(p))
        Public Property cmdTransactionsDeleteSearch As New RelayCommand(Of IList(Of Object))(Sub(p) TransactionsDeleteSearch(p), Function(p) p IsNot Nothing AndAlso p.Count > 0)
        Public Property cmdTransactionsDelete As New RelayCommand(Of konto_v01)(Sub(p) TransactionsDelete(p), Function(p) TransactionsDeleteDuplicateRibbonCanExecute(p))
        'Commands for Category handling:
        Public Property cmdTransactionCatAdd As New RelayCommand(Of transactions_v01)(Sub(p) TransactionCatAdd(p), Function(p) p IsNot Nothing)
        Public Property cmdTransactionCatDelete As New RelayCommand(Of Object())(Sub(p) TransactionCatDelete(p), Function(p) TransactionCatCanDelete(p))
        Public Property cmdTransactionCatEdit As New RelayCommand(Of Object())(Sub(p) TransactionCatEdit(p), Function(p) TransactionCatEditCanExecute(p))
        'Commands for Tags handling:
        Public Property cmdTransactionTagDelete As New RelayCommand(Of trans_tag_v01)(Sub(p) TransactionTagDelete(p), Function(p) p IsNot Nothing)
        'commands for Document handling:
        Public Property cmdTransactionDocAdd As New RelayCommand(Of transactions_v01)(Sub(p) TransactionDocAdd(p), Function(p) p IsNot Nothing)
        Public Property cmdTransactionDocDelete As New RelayCommand(Of Object())(Sub(p) TransactionDocDelete(p), Function(p) TransactionDocCanDelete(p))
        Public Property cmdTransactionDocShow As New RelayCommand(Of documents_v01)(Sub(p) TransactionDocShow(p), Function(p) p IsNot Nothing)
        Public Property cmdTransactionSaveChanges As New RelayCommand(Of transactions_v01)(Sub(p) TransactionSaveChanges(p), Function(p) TransactionCanSaveChanges(p))
        Public Property cmdTransactionDuplicateRibbon As New RelayCommand(Of konto_v01)(Sub(p) TransactionDuplicate(p), Function(p) TransactionsDeleteDuplicateRibbonCanExecute(p))
        Public Property cmdTransactionsChangeStatus As New RelayCommand(Of Object())(Sub(p) TransactionsChangeStatus(p), Function(p) TransactionsChangeStatusCanExecute(p))
        Public Property cmdTransactionsMultiEdit As New RelayCommand(Of konto_v01)(Sub(p) TransactionsMultiEdit(p), Function(p) p IsNot Nothing AndAlso DirectCast(p, konto_v01).SelectedObject IsNot Nothing AndAlso DirectCast(p, konto_v01).SelectedObject.Count > 0)

        Private Async Sub TransactionAdd(Optional v_obj As Object() = Nothing, Optional v_doc As documents_v01 = Nothing, Optional v_transtemp As transactions_v01 = Nothing)
            Dim v_dia As New frm_transaction_addedit
            Dim v_newtrans As transactions_v01
            If v_transtemp Is Nothing Then
                v_newtrans = New transactions_v01
            Else
                v_newtrans = v_transtemp
            End If
            Dim v_typ As String = ""
            Dim v_konto As konto_v01 = Nothing
            If v_obj IsNot Nothing Then
                v_typ = v_obj(0).ToString
                v_konto = TryCast(v_obj(1), konto_v01)
            End If
            'Setting the presets is only necessary if not transtemp is passed:
            If v_transtemp Is Nothing Then
                If Not v_newtrans Is Nothing Then
                    If v_typ = "" Then v_typ = "aus"
                    Dim v_transtyp As New trans_typ_v01
                    v_transtyp = __typen.Where(Function(x) x.internal_name = v_typ).First
                    If v_newtrans.transtyp_id = Nothing Then v_newtrans.transtyp_id = v_transtyp.typ_id
                    v_transtyp = Nothing
                    If v_konto Is Nothing Then
                        If Konten_Aktiv.CurrentItem Is Nothing Then Konten_Aktiv.MoveCurrentToFirst()
                        v_newtrans.konto_id = DirectCast(Konten_Aktiv.CurrentItem, konto_v01).kto_id
                    Else
                        v_newtrans.konto_id = v_konto.kto_id
                    End If

                    'Define Standards:
                    With v_newtrans
                        If preset_date <> Nothing Then .datum = preset_date
                        If SettingsCurrent.active_person Then
                            If preset_person_id <> Nothing Then .person_id = preset_person_id
                        End If
                        If SettingsCurrent.active_receiver Then
                            If preset_receiver_id <> Nothing Then .receiver_id = preset_receiver_id
                        End If
                        If SettingsCurrent.active_status Then
                            If preset_status_id <> Nothing Then .transstatus_id = preset_status_id
                        End If

                    End With
                End If
            End If
            'check if a Document is given as a preset (e.g. document manager has found a new document:
            'Wurde bereits ein Dokument mitgegeben:
            If v_doc IsNot Nothing Then
                v_newtrans.nv_trans_2_doc.Add(v_doc)
                For Each v_item As documents_v01 In v_newtrans.nv_trans_2_doc
                    v_item.path = DocRepositoryManager(v_item.path, Dokmanager_action.add)
                Next
            End If

            With v_dia
                .Title = "Buchung hinzufügen"
                .DataContext = v_newtrans
                .ShowDialog()
                If .DialogResult Then

                    'check if a new status shell be added if status is used in database
                    If SettingsCurrent.active_status Then v_newtrans.transstatus_id = Await check_status(.cmb_status.SelectedItem, .cmb_status.Text)
                    'check if a new person shell be added if person is used in database
                    If SettingsCurrent.active_person Then v_newtrans.person_id = Await check_person(.cmb_person.SelectedItem, .cmb_person.Text)
                    'check if a new receiver shell be added if receiver is used in database
                    If SettingsCurrent.active_receiver Then v_newtrans.receiver_id = Await check_receiver(.cmb_empf.SelectedItem, .cmb_empf.Text)


                    If transaction_consistency_checker(v_newtrans) Then
                        Transactions.AddNewItem(v_newtrans)
                        Transactions.CommitNew()
                        dbo.SaveChanges()
                        v_newtrans.nv_kto_2_trans_back.notify_kontovaluechange()
                        dbo.ChangeTracker.DetectChanges()
                        'Update the totalamount:
                        v_newtrans.TotAmountCalc()
                        'update the totalamount of the account:
                        If Not v_newtrans.nv_kto_2_trans_back Is Nothing Then v_newtrans.nv_kto_2_trans_back.Totalamount_Calculate()
                        If Not v_newtrans.nv_kto_2_trans_transfer_back Is Nothing Then v_newtrans.nv_kto_2_trans_transfer_back.Totalamount_Calculate()
                        v_newtrans.NotifyPropertyChanged("tags_str")
                        dbo.SaveChanges()
                        'Check if a sound shell be played after transaction has added
                        If SettingsCurrent.basic_transaction_sound Then Media.SystemSounds.Beep.Play()
                    Else
                        cls_logger.v_logger.Error("Transaction Consistency Check failed")
                        Throw New System.Exception("Validierung der Transaktion fehlgeschlagen, um Fehler zu vermeiden wird das Programm beendet")
                    End If
                End If
            End With
            'Update all Charts:
            ChartsLoadAndUpdate()
            'Update all Account Status Amounts:
            Call Konto_set_stati_all()
            'Update of all targetdefinitions:
            Call RecalculateAllSavingTargets
        End Sub

        Private Function TransactionAddCanExecute(v_obj As Object()) As Boolean
            If Konten_Aktiv.Count = 0 Then Return False
            If v_obj Is Nothing Then Return False
            Dim v_typ As String = v_obj(0).ToString
            If v_typ = "" Then Return False
            Return True

        End Function

        Private Async Sub TransactionEdit(v_trans As transactions_v01)
            If v_trans Is Nothing Then Exit Sub
            'Editieren einer Transaktion:
            Dim v_dia As New frm_transaction_addedit
            v_trans.BeginEdit()
            With v_dia
                .Title = "Buchung bearbeiten"
                .DataContext = v_trans
                .ShowDialog()
                If .DialogResult Then

                    'check if a new status shell be added if status is used in database
                    If SettingsCurrent.active_status Then v_trans.transstatus_id = Await check_status(.cmb_status.SelectedItem, .cmb_status.Text)
                    'check if a new person shell be added if person is used in database
                    If SettingsCurrent.active_person Then v_trans.person_id = Await check_person(.cmb_person.SelectedItem, .cmb_person.Text)
                    'check if a new receiver shell be added if receiver is used in database
                    If SettingsCurrent.active_receiver Then v_trans.receiver_id = Await check_receiver(.cmb_empf.SelectedItem, .cmb_empf.Text)

                    If transaction_consistency_checker(v_trans) Then
                        v_trans.EndEdit()
                        dbo.SaveChanges()
                        v_trans.nv_kto_2_trans_back.notify_kontovaluechange()
                        'Update the totalamount:
                        v_trans.TotAmountCalc()
                        'update the totalamount of the account:
                        If Not v_trans.nv_kto_2_trans_back Is Nothing Then v_trans.nv_kto_2_trans_back.Totalamount_Calculate()
                        If Not v_trans.nv_kto_2_trans_transfer_back Is Nothing Then v_trans.nv_kto_2_trans_transfer_back.Totalamount_Calculate()
                        'update the tag string:
                        v_trans.NotifyPropertyChanged("tags_str")
                        dbo.SaveChanges()
                        dbo.ChangeTracker.DetectChanges()
                    Else
                        cls_logger.v_logger.Error("Transaction Consistency Check failed")
                        Throw New System.Exception("Validierung der Transaktion fehlgeschlagen, um Fehler zu vermeiden wird das Programm beendet")
                    End If
                Else
                    v_trans.CancelEdit()
                End If
            End With
            'Update all Charts:
            ChartsLoadAndUpdate()
            'Update all Account Status Amounts:
            Call Konto_set_stati_all()
            'Update of all targetdefinitions:
            Call RecalculateAllSavingTargets()
            'Notify all Properties of the transactions:
            v_trans.notify_value_changed()
            v_trans.Collection_CollectionChanged(Me, Nothing)
        End Sub

        Private Sub TransactionEditRibbon(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            TransactionEdit(v_konto.SelectedObject.First)
        End Sub

        Private Function TransactionEditRibbonCanExecute(v_konto As konto_v01) As Boolean
            If v_konto Is Nothing Then Return False
            If v_konto.SelectedObject Is Nothing Then Return False
            If v_konto.SelectedObject.Count = 0 Then Return False
            Return True
        End Function

        ''' <summary>
        ''' Checks if a Transaction doesn't provide konto and to_konto if not type is transfer
        ''' if the Transaction has a failure it will be repaired automatically
        ''' </summary>
        ''' <param name="v_trans">Transaction to check</param>
        ''' <returns>Returns false if check fails</returns>
        Private Function transaction_consistency_checker(v_trans As transactions_v01) As Boolean
            With v_trans
                If v_trans Is Nothing Then Return False
                'at this stage the nv_transtyp_trans_back property is empty in case the transaction is added new.
                'so check what item is represented bei transtyp_id

                Dim v_ctranstyp As trans_typ_v01 = __typen.First(Function(x) x.typ_id = .transtyp_id)

                If v_ctranstyp Is Nothing Then Return False

                If v_ctranstyp.multiplier = 0 Then
                    'Transfer:
                    'If transfer then set receiver_id to nothing because receiver of a transfer is another konto
                    If .receiver_id IsNot Nothing Then
                        .receiver_id = Nothing
                    End If
                Else
                    'not a transfer
                    If .to_konto_id IsNot Nothing Then
                        .to_konto_id = Nothing
                    End If
                End If

                'Check if Person is empty:
                With v_trans
                    If .person_id Is Nothing Then
                        .person_id = __persons.Where(Function(x) CBool(x.predefined) = True).FirstOrDefault.pers_id
                    End If
                End With

                'Check if Receiver is empty:
                With v_trans
                    If .receiver_id Is Nothing Then
                        .receiver_id = __reveicer.Where(Function(x) CBool(x.predefined) = True).FirstOrDefault.rec_id
                    End If
                End With

                'check if status is empty
                With v_trans
                    If .transstatus_id Is Nothing Then
                        .transstatus_id = __status.Where(Function(x) CBool(x.predefined) = True).FirstOrDefault.status_id
                    End If
                End With

                Return True
            End With
        End Function

        ''' <summary>
        ''' Checks if a selected status is not saved in database if not creates a new status and gives back the new id
        ''' </summary>
        ''' <param name="v_obj">Selected Item</param>
        ''' <param name="v_text">text which represents the new status</param>
        ''' <returns>ID of the newly added status</returns>
        Private Async Function check_status(v_obj As Object, v_text As String) As Task(Of Integer)
            'It is possible that if the user selects an Item from the list and afterwards changes the text to add a new item
            'In this case we have to check if v_obj is nothing and if not if v_obj.benennung is same as v_text if not => add
            If v_obj Is Nothing Then
                'add new item
                Return Await add_status_direct(v_text)
            Else
                Dim v_status As trans_status_v01 = DirectCast(v_obj, trans_status_v01)
                If v_status.bezeichnung <> v_text Then
                    'Add new Item
                    Return Await add_status_direct(v_text)
                Else
                    Return v_status.status_id
                End If
            End If
        End Function

        Private Async Function add_status_direct(v_bezeichnung As String) As Task(Of Integer)
            If String.IsNullOrEmpty(v_bezeichnung) = False Then
                'New status is selected
                Dim v_strbuilder As New StringBuilder
                v_strbuilder.AppendLine("Wollen Sie den neuen Status " & v_bezeichnung & " anlegen?")
                v_strbuilder.AppendLine("Hinweis: Wenn Sie keinen neuen Status anlegen wird die Buchung mit leerem Status durchgeführt.")
                Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
                Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
                Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Status anlegen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

                If result = MessageDialogResult.Affirmative Then
                    Dim v_newstatus = New trans_status_v01 With {.aktiv = True, .bezeichnung = v_bezeichnung, .predefined = False}
                    TransStatus_Aktiv.AddNewItem(v_newstatus)
                    TransStatus_Aktiv.CommitNew()
                    dbo.SaveChanges()
                    Return v_newstatus.status_id
                Else
                    Return Nothing
                End If
            Else
                Return Nothing
            End If
        End Function

        ''' <summary>
        ''' Checks if a selected person is not saved in database if not creates a new person and gives back the new id
        ''' </summary>
        ''' <param name="v_obj">Selected Item</param>
        ''' <param name="v_text">text which represents the new person</param>
        ''' <returns>ID of the newly added person</returns>
        Private Async Function check_person(v_obj As Object, v_text As String) As Task(Of Integer)
            'It is possible that if the user selects an Item from the list and afterwards changes the text to add a new item
            'In this case we have to check if v_obj is nothing and if not if v_obj.benennung is same as v_text if not => add
            If v_obj Is Nothing Then
                'add new item
                If v_text = String.Empty Then
                    Return Nothing
                Else
                    Return Await add_person_direct(v_text)
                End If
            Else
                Dim v_person As person_v01 = DirectCast(v_obj, person_v01)
                If v_person.bezeichnung <> v_text Then
                    'Add new Item
                    Return Await add_person_direct(v_text)
                Else
                    Return v_person.pers_id
                End If
            End If
        End Function

        Private Async Function add_person_direct(v_name As String) As Task(Of Integer)
            If String.IsNullOrEmpty(v_name) = False Then
                'New status is selected
                Dim v_strbuilder As New StringBuilder
                v_strbuilder.AppendLine("Wollen Sie die neue Person: " & v_name & " anlegen?")
                v_strbuilder.AppendLine("Hinweis: Wenn Sie keine neue Person anlegen wird die Buchung ohne Angabe einer Person durchgeführt.")
                Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
                Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
                Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Person anlegen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

                If result = MessageDialogResult.Affirmative Then
                    Dim v_newperson = New person_v01 With {.aktiv = True, .bezeichnung = v_name}
                    Persons_Aktiv.AddNewItem(v_newperson)
                    Persons_Aktiv.CommitNew()
                    dbo.SaveChanges()
                    Return v_newperson.pers_id
                Else
                    Return Nothing
                End If
            Else
                Return Nothing
            End If
        End Function

        ''' <summary>
        ''' Checks if a selected receiver is not saved in database if not creates a new receiver and gives back the new id
        ''' </summary>
        ''' <param name="v_obj">Selected Item</param>
        ''' <param name="v_text">text which represents the new receiver</param>
        ''' <returns>ID of the newly added status</returns>
        Private Async Function check_receiver(v_obj As Object, v_text As String) As Task(Of Integer)
            'It is possible that if the user selects an Item from the list and afterwards changes the text to add a new item
            'In this case we have to check if v_obj is nothing and if not if v_obj.benennung is same as v_text if not => add
            If v_obj Is Nothing Then
                'add new item
                Return Await add_receiver_direct(v_text)
            Else
                Dim v_receiver As receiver_v01 = DirectCast(v_obj, receiver_v01)
                If v_receiver.bezeichnung <> v_text Then
                    'Add new Item
                    Return Await add_receiver_direct(v_text)
                Else
                    Return v_receiver.rec_id
                End If
            End If
        End Function

        Private Async Function add_receiver_direct(v_bezeichnung As String) As Task(Of Integer)
            If String.IsNullOrEmpty(v_bezeichnung) = False Then
                'New receiver is selected
                Dim v_strbuilder As New StringBuilder
                v_strbuilder.AppendLine("Wollen Sie den neuen Empfänger " & v_bezeichnung & " anlegen?")
                v_strbuilder.AppendLine("Hinweis: Wenn Sie keinen neuen Empfänger anlegen wird die Buchung ohne Angabe eines Empfängers durchgeführt.")
                Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
                Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
                Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Empfänger anlegen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

                If result = MessageDialogResult.Affirmative Then
                    Dim v_newreceiver = New receiver_v01 With {.aktiv = True, .bezeichnung = v_bezeichnung, .predefined = False}
                    Receivers_Aktiv.AddNewItem(v_newreceiver)
                    Receivers_Aktiv.CommitNew()
                    dbo.SaveChanges()
                    Return v_newreceiver.rec_id
                Else
                    Return Nothing
                End If
            Else
                Return Nothing
            End If
        End Function


        Private Async Sub TransactionsDeleteSearch(v_obj As IList(Of Object))
            If v_obj Is Nothing OrElse v_obj.Count = 0 Then Exit Sub

            Dim v_obj_local As New List(Of Object)(v_obj)

            Dim v_question As String
            If v_obj_local.Count = 1 Then
                v_question = "Wollen Sie die gewählte Buchung löschen?"
            Else
                v_question = "Wollen Sie die gewählten {0} Buchungen löschen?"
                v_question = String.Format(v_question, v_obj_local.Count.ToString)
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Löschvorgang bestätigen", v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)


            If result = MessageDialogResult.Affirmative Then
                While v_obj_local.Count > 0
                    Dim v_entry As transactions_v01 = CType(v_obj_local.First, transactions_v01)
                    dbo.m_transactions_v01.Remove(v_entry)
                    dbo.ChangeTracker.DetectChanges()
                    v_obj_local.Remove(v_entry)
                    v_entry = Nothing
                End While
                dbo.SaveChanges()
            End If

            For Each v_konto As konto_v01 In __konten
                'update the totalamount of the account:
                v_konto.Totalamount_Calculate()
                v_konto.notify_kontovaluechange()
            Next
            'Update all Charts:
            ChartsLoadAndUpdate()
            'Update all Account Status Amounts:
            Call Konto_set_stati_all()
            'Update of all targetdefinitions:
            Call RecalculateAllSavingTargets()
        End Sub

        Private Async Sub TransactionsDelete(v_kto As konto_v01)
            If v_kto Is Nothing Then Exit Sub
            Dim v_question As String
            If v_kto.SelectedObject.Count = 1 Then
                v_question = "Wollen Sie die gewählte Buchung löschen?"
            Else
                v_question = "Wollen Sie die gewählten {0} Buchungen löschen?"
                v_question = String.Format(v_question, v_kto.SelectedObject.Count.ToString)
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Löschvorgang bestätigen", v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            If result = MessageDialogResult.Affirmative Then
                Dim v_selobjs_local As List(Of transactions_v01) = CType(v_kto.SelectedObject, List(Of transactions_v01))
                While v_selobjs_local.Count > 0

                    Dim v_entry As transactions_v01 = v_selobjs_local.First
                    'Check if the Transactions have documents:
                    If v_entry.nv_trans_2_doc IsNot Nothing OrElse v_entry.nv_trans_2_doc.Count > 0 Then
                        While v_entry.nv_trans_2_doc.Count > 0
                            DocRepositoryManager(v_entry.nv_trans_2_doc.First.path, Dokmanager_action.delete)
                            DocumentList.Remove(v_entry.nv_trans_2_doc.First)
                        End While
                    End If
                    Dim v_kto_id As Integer = v_entry.konto_id
                    Dim v_tokto_id As Integer? = v_entry.to_konto_id
                    dbo.m_transactions_v01.Remove(v_entry)
                    dbo.ChangeTracker.DetectChanges()
                    v_selobjs_local.Remove(v_entry)
                    v_entry = Nothing
                    'Calculate the new KontoAmounts:
                    __konten.Where(Function(x) x.kto_id = v_kto_id).FirstOrDefault.Totalamount_Calculate()
                    If Not v_tokto_id Is Nothing Then __konten.Where(Function(x) x.kto_id = CInt(v_tokto_id)).FirstOrDefault.Totalamount_Calculate()
                End While
                dbo.SaveChanges()
            End If
            v_kto.notify_kontovaluechange()
            'Update all Charts:
            ChartsLoadAndUpdate()
            'Update all Account Status Amounts:
            Call Konto_set_stati_all()
            'Update of all targetdefinitions:
            Call RecalculateAllSavingTargets()
        End Sub

        Private Async Sub TransactionDuplicate(v_kto As konto_v01)
            If v_kto Is Nothing Then Exit Sub
            Dim v_question As String
            If v_kto.SelectedObject.Count = 1 Then
                v_question = "Wollen Sie die gewählte Buchung duplizieren?"
            Else
                v_question = "Wollen Sie die gewählten {0} Buchungen duplizieren?"
                v_question = String.Format(v_question, v_kto.SelectedObject.Count.ToString)
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = DirectCast(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Vervielfältigung bestätigen", v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                For Each v_trans As transactions_v01 In v_kto.SelectedObject
                    Dim v_trans_new As New transactions_v01
                    With v_trans_new
                        .comment = v_trans.comment
                        .datum = v_trans.datum
                        .konto_id = v_trans.konto_id
                        .to_konto_id = v_trans.to_konto_id
                        .transtyp_id = v_trans.transtyp_id
                        .transstatus_id = v_trans.transstatus_id
                        .receiver_id = v_trans.receiver_id
                        .person_id = v_trans.person_id
                    End With

                    For Each v_old_cat As trans_2_kat In v_trans.nv_trans_t2k
                        Dim v_newcat As New trans_2_kat With {.amount = v_old_cat.amount, .category_id = v_old_cat.category_id}
                        v_trans_new.nv_trans_t2k.Add(v_newcat)
                        v_newcat = Nothing
                    Next

                    For Each v_old_tag As trans_tag_v01 In v_trans.nv_trans_transtag
                        Dim v_newtag As New trans_tag_v01 With {.bezeichnung_help = v_old_tag.bezeichnung_help, .tagid = v_old_tag.tagid}
                        v_trans_new.nv_trans_transtag.Add(v_newtag)
                        v_newtag = Nothing
                    Next

                    v_trans_new.TotAmountCalc()
                    Transactions.AddNewItem(v_trans_new)
                    Transactions.MoveCurrentToLast()
                    Transactions.CommitNew()

                    dbo.SaveChanges()
                Next
            End If
            v_kto.Totalamount_Calculate()
            v_kto.notify_kontovaluechange()
            'Update all Charts:
            ChartsLoadAndUpdate()
            'Update all Account Status Amounts:
            Call Konto_set_stati_all()
            'Update of all targetdefinitions:
            Call RecalculateAllSavingTargets
        End Sub

        Private Function TransactionsCanDelete(v_obj As IList(Of Object)) As Boolean
            If v_obj Is Nothing Then Return False
            If v_obj.Count = 0 Then Return False
            Return True
        End Function

        Private Function TransactionsDeleteDuplicateRibbonCanExecute(v_kto As konto_v01) As Boolean
            If v_kto Is Nothing OrElse v_kto.SelectedObject Is Nothing Then Return False
            If v_kto.SelectedObject.Count = 0 Then
                Debug.Print("TransactionsDeleteDuplicateRibbonCanExecute false")
                Return False
            Else
                Debug.Print("TransactionsDeleteDuplicateRibbonCanExecute true")
                Return True
            End If
        End Function

        ''' <summary>
        ''' Saves Changes in a given Transactions used mainly in ucl_konto at DetailView
        ''' </summary>
        ''' <param name="v_trans"></param>
        Private Async Sub TransactionSaveChanges(v_trans As transactions_v01)
            If v_trans Is Nothing Then Exit Sub


            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Änderungen speichern", "Wollen Sie die Änderungen an der Buchung speichern?", MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                If transaction_consistency_checker(v_trans) Then
                    v_trans.EndEdit()
                    dbo.SaveChanges()
                Else
                    v_trans.CancelEdit()
                End If
                v_trans.EndEdit()
            Else
                v_trans.CancelEdit()
            End If
            'Update all Charts:
            ChartsLoadAndUpdate()
            'Update of all targetdefinitions:
            Call RecalculateAllSavingTargets
        End Sub

        Private Function TransactionCanSaveChanges(v_trans As transactions_v01) As Boolean
            If v_trans Is Nothing Then Return False
            If v_trans.hasErrors Then Return False
            Return True
        End Function

        Private Async Sub TransactionsChangeStatus(v_obj As Object())
            'Defintion:
            'v_obj(0) is pressed Key as string
            'v_obj(1) is current displayed konto (if selected trans are passed by command, amount is not updated) 'Datacontext is type of contentpresenter
            Dim v_cp As ContentPresenter = CType(v_obj(1), ContentPresenter)
            Dim v_key As String = v_obj(0).ToString
            Dim v_konto As konto_v01 = CType(v_cp.Content, konto_v01)
            '1 Step: Find Status corresponding to the key:
            Dim v_status As trans_status_v01 = __status.Where(Function(x) x.shortcut_key = v_key).FirstOrDefault
            If v_status Is Nothing Then Exit Sub

            'Status is found now ask user if he want's to change status of selected transactions:
            Dim v_question As String
            If v_konto.SelectedObject.Count = 1 Then
                v_question = "Wollen Sie den Status der gewählten Buchung in {0} ändern?"
                v_question = String.Format(v_question, v_status.bezeichnung)
            Else
                v_question = "Wollen Sie den Status der gewählten {0} Buchungen in {1} ändern?"
                v_question = String.Format(v_question, v_konto.SelectedObject.Count.ToString, v_status.bezeichnung)
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = DirectCast(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Statusänderung bestätigen", v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                For Each v_trans In v_konto.SelectedObject
                    v_trans.BeginEdit()
                    v_trans.transstatus_id = v_status.status_id
                    v_trans.EndEdit()
                Next
                dbo.SaveChanges()
            End If
            'Update all Account Status Amounts:
            Call Konto_set_stati_all()

        End Sub

        Private Function TransactionsChangeStatusCanExecute(v_obj As Object()) As Boolean
            If v_obj Is Nothing Then Return False
            If v_obj(0) Is Nothing Then Return False
            If DirectCast(v_obj(0), String) = Nothing OrElse DirectCast(v_obj(0), String) = "" Then Return False
            If v_obj(1) Is Nothing Then Return False
            'Because of an unknown reason the datacontext of the ucl_konto is not a konto as expected it's type of ContentPresenter (from Avalondock)
            'so the content property of the contentpresenter has to be checked:
            If TypeOf (v_obj(1)) IsNot ContentPresenter Then Return False
            If DirectCast(v_obj(1), ContentPresenter).Content Is Nothing Then Return False
            If TypeOf (DirectCast(v_obj(1), ContentPresenter).Content) IsNot konto_v01 Then Return False
            Return True
        End Function


        Private Async Sub TransactionsMultiEdit(v_konto As konto_v01)
            If v_konto Is Nothing Then Exit Sub
            If v_konto.SelectedObject Is Nothing Then Exit Sub
            If v_konto.SelectedObject.Count = 0 Then Exit Sub

            Dim v_result As Tuple(Of Boolean, cls_multiedit_definition) = Await MultiEditDefinitionandDialog()

            If v_result.Item1 = True Then
                For Each v_trans As transactions_v01 In v_konto.SelectedObject
                    v_trans.BeginEdit()
                    With v_result.Item2
                        If .Datum_active Then v_trans.datum = .Datum
                        If .Person_active Then v_trans.person_id = .PersonId
                        If .Receiver_active Then v_trans.receiver_id = .ReceiverId
                        If .Status_active Then v_trans.transstatus_id = .StatusId
                    End With
                    v_trans.EndEdit()
                Next
                dbo.SaveChanges()
                dbo.ChangeTracker.DetectChanges()
                'Update all Charts:
                ChartsLoadAndUpdate()
                'Update all Account Status Amounts:
                Call Konto_set_stati_all()
                'Update of all targetdefinitions:
                Call RecalculateAllSavingTargets()
            End If
        End Sub

        Private Async Function MultiEditDefinitionandDialog() As Task(Of Tuple(Of Boolean, cls_multiedit_definition))
            Dim v_editdef As New cls_multiedit_definition
            'Perform a Multiedit Operation on all selected Items:
            Dim v_dia As New frm_multiedit With {.DataContext = v_editdef}
            With v_dia
                .WindowStartupLocation = WindowStartupLocation.CenterScreen
                .ShowDialog()
                If .DialogResult Then
                    Dim v_strbuilder As New StringBuilder
                    v_strbuilder.AppendLine("Wollen Sie folgende Bearbeitungen an den selektieren Buchungen durchführen?")
                    With v_editdef
                        If .Datum_active Then v_strbuilder.AppendLine("Datum")
                        If .Person_active Then v_strbuilder.AppendLine("Person")
                        If .Receiver_active Then v_strbuilder.AppendLine("Empfänger")
                        If .Status_active Then v_strbuilder.AppendLine("Status")
                    End With
                    Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
                    Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
                    Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Mehrfachbearbeitung durchführen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)
                    If result = MessageDialogResult.Affirmative Then
                        Return New Tuple(Of Boolean, cls_multiedit_definition)(True, v_editdef)
                    End If
                End If
            End With
            Return New Tuple(Of Boolean, cls_multiedit_definition)(False, Nothing)
        End Function


#Region "Transaktion Kategorie"

        Private Sub TransactionCatAdd(v_trans As transactions_v01)
            Dim v_t2k As New trans_2_kat
            Dim v_dia As New frm_transcat_addedit
            With v_dia
                .Title = "Eintrag hinzufügen"
                .DataContext = v_t2k
                .ShowDialog()
                If .DialogResult Then
                    'Add
                    v_trans.nv_trans_t2k.Add(v_t2k)
                    v_trans.TotAmountCalc()
                    v_trans.notify_value_changed()
                    dbo.ChangeTracker.DetectChanges()
                Else
                    v_t2k = Nothing
                End If
            End With
        End Sub

        Private Async Sub TransactionCatDelete(v_obj As Object())
            If v_obj Is Nothing Then Exit Sub
            Dim v_trans As transactions_v01 = DirectCast(v_obj(0), transactions_v01)
            Dim v_t2ks As IEnumerable(Of trans_2_kat) = DirectCast(v_obj(1), IList).Cast(Of trans_2_kat)
            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie die folgenden Kategorien innerhalb der Buchung löschen?")
            For Each v_item As trans_2_kat In v_t2ks
                'It's possible that the nv_cat_trans2kat_back property is nothing
                If v_item.nv_cat_trans2kat_back Is Nothing Then
                    v_strbuilder.AppendLine(getCatBezeichnungById(v_item.category_id))
                Else
                    v_strbuilder.AppendLine(v_item.nv_cat_trans2kat_back.bezeichnung)
                End If
            Next
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_dialog_window As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.Windows.OfType(Of Window).SingleOrDefault(Function(x) x.IsActive), MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_dialog_window.ShowMessageAsync("Eintrag löschen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                While v_t2ks.Count > 0
                    If __t2k.Remove(v_t2ks.First) = False Then
                        'Category could not removed from observablecollection => happens if a newly created transaction tries to delete a newly created t2k
                        v_trans.nv_trans_t2k.Remove(v_t2ks.First)
                    End If
                End While
                v_trans.notify_value_changed()
                dbo.SaveChanges()
            End If
        End Sub

        Private Function getCatBezeichnungById(v_catid As Integer) As String
            If v_catid = Nothing Then Return String.Empty
            Dim v_cat As category_v01 = __categories.Where(Function(x) x.cat_id = v_catid).First
            If v_cat Is Nothing Then
                Return String.Empty
            Else
                Return v_cat.bezeichnung
            End If
        End Function

        Private Function TransactionCatCanDelete(v_obj As Object()) As Boolean
            If v_obj Is Nothing Then Return False
            If v_obj(0) Is Nothing Then Return False
            If v_obj(1) Is Nothing Then Return False
            Return True
        End Function

        Private Sub TransactionCatEdit(v_obj As Object())
            If v_obj Is Nothing Then Exit Sub

            Dim v_t2k As trans_2_kat = DirectCast(v_obj(0), trans_2_kat)
            Dim v_trans As transactions_v01 = DirectCast(v_obj(1), transactions_v01)

            If v_t2k Is Nothing OrElse v_trans Is Nothing Then Exit Sub

            Dim v_dia As New frm_transcat_addedit
            v_t2k.BeginEdit()

            With v_dia
                .Title = "Eintrag bearbeiten"
                .DataContext = v_t2k
                .ShowDialog()
                If .DialogResult Then
                    'Bearbeitung speichern
                    v_t2k.EndEdit()
                    If Not v_trans Is Nothing Then v_trans.TotAmountCalc()
                    dbo.SaveChanges()
                    dbo.ChangeTracker.DetectChanges()
                    If Not v_trans Is Nothing Then v_trans.Collection_CollectionChanged(Me, Nothing)
                    If Not v_trans Is Nothing Then v_trans.notify_value_changed()
                Else
                    v_t2k.CancelEdit()
                    v_t2k = Nothing
                End If
            End With
        End Sub

        Private Function TransactionCatEditCanExecute(v_obj As Object()) As Boolean
            If v_obj Is Nothing Then Return False
            If v_obj(0) Is Nothing OrElse v_obj(1) Is Nothing Then Return False
            Return True
        End Function
#End Region

#Region "Tags"
        Private Sub TransactionTagDelete(v_t2tag As trans_tag_v01)
            If v_t2tag Is Nothing Then Exit Sub
            'Deletes a tag
            dbo.m_trans_tag_v01.Remove(v_t2tag)
            dbo.SaveChanges()
            dbo.ChangeTracker.DetectChanges()
        End Sub

#End Region

#Region "Transaktion Documents"

        Private Sub TransactionDocAdd(v_trans As transactions_v01)
            If v_trans Is Nothing Then Exit Sub
            'We open a OpenFile Dialog and preset the "bezeichnung" (name) of the document with a fixed value
            Dim v_filedia As New CommonOpenFileDialog
            Dim v_result As CommonFileDialogResult = v_filedia.ShowDialog
            If v_result = CommonFileDialogResult.Ok Then
                v_trans.nv_trans_2_doc.Add(New documents_v01 With {.bezeichnung = "Neues Dokument", .path = DocRepositoryManager(v_filedia.FileName, Dokmanager_action.add), .transaction_id = v_trans.trans_id})
                dbo.ChangeTracker.DetectChanges()
                dbo.SaveChanges()
            End If
        End Sub

        Private Async Sub TransactionDocDelete(v_obj As Object())
            If v_obj Is Nothing Then Exit Sub

            Dim v_trans As transactions_v01 = DirectCast(v_obj(0), transactions_v01)
            Dim v_deldocs As IEnumerable(Of documents_v01) = DirectCast(v_obj(1), IList).Cast(Of documents_v01)

            Dim v_strbuilder As New StringBuilder
            If v_deldocs.Count = 1 Then
                v_strbuilder.AppendLine("Wollen Sie das folgende Dokument innerhalb der Buchung löschen?")
            Else
                v_strbuilder.AppendLine("Wollen Sie die folgenden Dokumente innerhalb der Buchung löschen?")
            End If

            For Each v_item As documents_v01 In v_deldocs
                v_strbuilder.AppendLine(v_item.bezeichnung)
            Next
            v_strbuilder.AppendLine("Achtung: Vorgang kann nicht rückgängig gemacht werden!")

            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_dialog_window As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.Windows.OfType(Of Window).SingleOrDefault(Function(x) x.IsActive), MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_dialog_window.ShowMessageAsync("Eintrag löschen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                While v_deldocs.Count > 0
                    DocRepositoryManager(v_deldocs.First.path, Dokmanager_action.delete)
                    DocumentList.Remove(v_deldocs.First)
                End While
                dbo.SaveChanges()
            End If
        End Sub
        Private Function TransactionDocCanDelete(v_obj As Object()) As Boolean
            If v_obj Is Nothing Then Return False
            If v_obj(0) Is Nothing Then Return False
            If v_obj(1) Is Nothing Then Return False
            Return True
        End Function

        ''' <summary>
        ''' Views the document externally with the corresponding program e.g. PDF in Adobe 
        ''' </summary>
        ''' <param name="v_document">Repository Path of the Document (relativ)</param>
        Private Sub TransactionDocShow(v_document As documents_v01)
            If v_document Is Nothing Then Exit Sub
            DocRepositoryManager(v_document.path, Dokmanager_action.open)
        End Sub
#End Region




#End Region

    End Class
End Namespace