﻿Imports System.Collections.ObjectModel
Imports System.Data.Entity
Imports System.Text
Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Transationen Template:

        Private WithEvents __transactions_template As New ObservableCollection(Of transactions_template_v01)
        Private WithEvents __ttemp2k As New ObservableCollection(Of transtemp_2_kat)
        ''' <summary>
        ''' Alle Repeat Transaktionen
        ''' </summary>
        ''' <returns></returns>
        Public Property Transactions_Template As ListCollectionView


        'Helper property to define the visibility of the Ribbongroupbox Transaction Templates in the MainWindow.
        Public ReadOnly Property Trans_temp_visibility As Visibility
            Get
                If SettingsCurrent.active_templates Then
                    If __transactions_template.Count > 0 Then
                        Return Visibility.Visible
                    Else
                        Return Visibility.Collapsed
                    End If
                Else
                    Return Visibility.Collapsed
                End If
            End Get
        End Property


        Private Sub TransactionsTemplateLoad()
            __transactions_template.Clear()
            __ttemp2k.Clear()

            dbo.m_transactions_template_v01.Load
            dbo.m_transtemp_2_kat.Load
            __transactions_template = dbo.m_transactions_template_v01.Local
            __ttemp2k = dbo.m_transtemp_2_kat.Local
            Transactions_Template = New ListCollectionView(__transactions_template)

            'necessary to avoid an bug which causes the duplicate and delete command to be switched of if just 1 item is available:
            TransTempSelectedItems = __transactions_template.ToList
            TransTempSelectedItems.Clear()
            TransTempSelectedItems.Add(__transactions_template.FirstOrDefault)

        End Sub

        Private Sub __transactions_template_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __transactions_template.CollectionChanged
            'If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not Transactions_Template Is Nothing Then
                If Not Transactions_Template.MoveCurrentToNext Then Transactions_Template.MoveCurrentToPrevious()
            End If
            RaisePropertyChanged("Trans_temp_visibility")
        End Sub

#Region "Commands"
        Public Property cmdTransactionTemplateAdd As New RelayCommand(Of Object())(Sub(p) TransactionTemplateAdd(p), Function(p) TransactionTemplateAddCanExecute(p))
        Public Property cmdTransactionTemplateEdit As New RelayCommand(Of transactions_template_v01)(Sub(p) TransactionTemplateEdit(p), Function(p) TransactionTemplateCanEdit(p))
        ''' <summary>
        ''' This command is necessary to receive the currently selected Repeat Transactions from the containing listview of the view
        ''' Command is necessary because datagrid selecteditems is not a dependency property see:
        ''' http://blog.galasoft.ch/posts/2010/05/handling-datagrid-selecteditems-in-an-mvvm-friendly-manner/
        ''' </summary>
        ''' <returns></returns>
        Public Property cmdTransactionTemplateSelectionChanged As New RelayCommand(Of IList)(Sub(p) TransactionTemplateSelectionChanged(p))
        ''' <summary>
        ''' Edits an Object of Type TransactionTemplate by using the current selected Item of the ListcollectionView (used by Ribbon Menu)
        ''' </summary>
        ''' <returns></returns>
        Public Property cmdTransactionTemplateEditIndirect As New RelayCommand(AddressOf TransactionTemplateEditIndirect, Function() Transactions_Template.Count > 0 And Transactions_Template.CurrentItem IsNot Nothing)
        Public Property cmdTransactionTemplateDuplicate As New RelayCommand(AddressOf TransactionTemplateDuplicate, Function() TransactionsTemplateCanDeleteDuplicate())
        'Deletes more than one Transaction at once
        Public Property cmdTransactionsTemplateDelete As New RelayCommand(AddressOf TransactionstemplateDelete, Function() TransactionsTemplateCanDeleteDuplicate())
        Public Property cmdTransactionTemplateCatAdd As New RelayCommand(Of transactions_template_v01)(Sub(p) TransactionTemplateCatAdd(p), Function(p) p IsNot Nothing)
        Public Property cmdTransactionTemplateCatDelete As New RelayCommand(Of Object())(Sub(p) TransactionTemplateCatDelete(p), Function(p) TransactionTemplateCatCanDelete(p))
        Public Property cmdTransactionTemplateCatEdit As New RelayCommand(Of transtemp_2_kat)(Sub(p) TransactionTemplateCatEdit(p), Function(p) p IsNot Nothing)
        Public Property cmdTransactionTemplateSaveChanges As New RelayCommand(Of transactions_template_v01)(Sub(p) TransactionTemplateSaveChanges(p), Function(p) TransactionTemplateCanSaveChanges(p))

        Public Property cmdExecuteTransactionTemp As New RelayCommand(Of transactions_template_v01)(Sub(p) ExecuteTransactionTemp(p), Function(p) p IsNot Nothing)


        Public Property cmdTransTempImage As New RelayCommand(Of transactions_template_v01)(Sub(p) TransTempImage(p), Function(p) p IsNot Nothing)

        Private Sub ExecuteTransactionTemp(v_seltemplate As transactions_template_v01)
            If v_seltemplate Is Nothing Then Exit Sub

            Dim v_newtrans As New transactions_v01
            With v_newtrans
                .comment = v_seltemplate.comment
                .datum = Date.Now
                .konto_id = v_seltemplate.konto_id
                .to_konto_id = v_seltemplate.to_konto_id
                .transtyp_id = v_seltemplate.transtyp_id
                .transstatus_id = v_seltemplate.transstatus_id
                .receiver_id = v_seltemplate.receiver_id
                .person_id = v_seltemplate.person_id
                'Copy Categories:
                If v_seltemplate.nv_transtemp_2_kat.Count > 0 Then
                    For Each v_tt2kat As transtemp_2_kat In v_seltemplate.nv_transtemp_2_kat
                        .nv_trans_t2k.Add(New trans_2_kat With {.amount = v_tt2kat.amount, .category_id = v_tt2kat.category_id, .transaction_id = .transaction_id})
                    Next
                End If
                'Copy tags:
                If v_seltemplate.nv_transtemp_2_tag.Count > 0 Then
                    For Each v_tag As transtemp_tag_v01 In v_seltemplate.nv_transtemp_2_tag
                        .nv_trans_transtag.Add(New trans_tag_v01 With {.tagid = v_tag.tagid, .bezeichnung_help = v_tag.bezeichnung_help})
                    Next
                End If
            End With
            'Add the newly created transaction to the transaction pool by using the TransactionAdd Routine and give newly created Item to it
            TransactionAdd(,, v_newtrans)

        End Sub

        Private Async Sub TransactionTemplateAdd(Optional v_obj As Object() = Nothing)
            Dim v_dia As New frm_transactiontemplate_addedit
            Dim v_newtemptrans As New transactions_template_v01
            Dim v_typ As String = ""
            Dim v_konto As konto_v01 = Nothing
            If v_obj IsNot Nothing Then
                v_typ = v_obj(0).ToString
                v_konto = TryCast(v_obj(1), konto_v01)
            End If

            If v_typ = "" Then v_typ = "ein"
            Dim v_transtyp As New trans_typ_v01
            v_transtyp = __typen.Where(Function(x) x.internal_name = v_typ).First
            v_newtemptrans.transtyp_id = v_transtyp.typ_id
            v_transtyp = Nothing
            If v_konto Is Nothing Then
                If Konten_Aktiv.CurrentItem Is Nothing Then Konten_Aktiv.MoveCurrentToFirst()
                v_newtemptrans.konto_id = DirectCast(Konten_Aktiv.CurrentItem, konto_v01).kto_id
            Else
                v_newtemptrans.konto_id = v_konto.kto_id
            End If

            With v_dia
                .Title = "Vorlage-Buchung hinzufügen"
                .DataContext = v_newtemptrans
                .ShowDialog()
                If .DialogResult Then

                    'check if a new status shell be added if status is used in database
                    If SettingsCurrent.active_status Then v_newtemptrans.transstatus_id = Await check_status(.cmb_status.SelectedItem, .cmb_status.Text)
                    'check if a new person shell be added if person is used in database
                    If SettingsCurrent.active_person Then v_newtemptrans.person_id = Await check_person(.cmb_person.SelectedItem, .cmb_person.Text)
                    'check if a new receiver shell be added if receiver is used in database
                    If SettingsCurrent.active_receiver Then v_newtemptrans.receiver_id = Await check_receiver(.cmb_empf.SelectedItem, .cmb_empf.Text)


                    If transactiontemplate_consistency_checker(v_newtemptrans) Then
                        Transactions_Template.AddNewItem(v_newtemptrans)
                        Transactions_Template.CommitNew()
                        dbo.SaveChanges()
                        dbo.ChangeTracker.DetectChanges()
                    Else
                        cls_logger.v_logger.Error("Template Transaction Consistency Check failed")
                        Throw New System.Exception("Validierung der Vorlage-Transaktion fehlgeschlagen, um Fehler zu vermeiden wird das Programm beendet")
                    End If
                End If
            End With
        End Sub

        Dim TransTempSelectedItems As IList(Of transactions_template_v01) = Nothing

        Private Sub TransactionTemplateSelectionChanged(v_selected_items As IList)
            If Not TransTempSelectedItems Is Nothing Then TransTempSelectedItems.Clear()
            TransTempSelectedItems = CType(v_selected_items, System.Collections.IList).Cast(Of transactions_template_v01).Cast(Of transactions_template_v01).ToList
        End Sub

        Private Function TransactionTemplateAddCanExecute(v_obj As Object()) As Boolean
            'if no konto is present disable command:
            If Konten_Aktiv.Count = 0 Then Return False
            If v_obj Is Nothing Then Return False
            Dim v_typ As String = v_obj(0).ToString
            If v_typ = "" Then Return False
            Return True
        End Function

        Private Async Sub TransactionTemplateEdit(v_trans As transactions_template_v01)
            If v_trans Is Nothing Then Exit Sub
            'Editieren einer WiederholungsTransaktion:
            Dim v_dia As New frm_transactiontemplate_addedit
            v_trans.BeginEdit()
            With v_dia
                .Title = "Vorlage Buchung bearbeiten"
                .DataContext = v_trans
                .ShowDialog()
                If .DialogResult Then

                    'check if a new status shell be added if status is used in database
                    If SettingsCurrent.active_status Then v_trans.transstatus_id = Await check_status(.cmb_status.SelectedItem, .cmb_status.Text)
                    'check if a new person shell be added if person is used in database
                    If SettingsCurrent.active_person Then v_trans.person_id = Await check_person(.cmb_person.SelectedItem, .cmb_person.Text)
                    'check if a new receiver shell be added if receiver is used in database
                    If SettingsCurrent.active_receiver Then v_trans.receiver_id = Await check_receiver(.cmb_empf.SelectedItem, .cmb_empf.Text)

                    If transactiontemplate_consistency_checker(v_trans) Then
                        v_trans.EndEdit()
                        dbo.SaveChanges()
                        dbo.ChangeTracker.DetectChanges()
                        v_trans.Collection_CollectionChanged(Me, Nothing)
                    Else
                        cls_logger.v_logger.Error("Template Transaction Consistency Check failed")
                        Throw New System.Exception("Validierung der Vorlage-Transaktion fehlgeschlagen, um Fehler zu vermeiden wird das Programm beendet")
                    End If
                Else
                    v_trans.CancelEdit()
                End If
            End With
        End Sub


        Private Function TransactionTemplateCanEdit(v_trans As transactions_template_v01) As Boolean
            'if no konto is present disable command:
            If Konten_Aktiv.Count = 0 Then Return False
            If v_trans Is Nothing Then Return False
            Return True
        End Function

        Private Async Sub TransactionTemplateEditIndirect()
            Dim v_trans As transactions_template_v01 = CType(Transactions_Template.CurrentItem, transactions_template_v01)
            If v_trans Is Nothing Then Exit Sub
            'Editieren einer Vorlagebuchung:
            Dim v_dia As New frm_transactiontemplate_addedit
            v_trans.BeginEdit()
            With v_dia
                .Title = "Vorlage Buchung bearbeiten"
                .DataContext = v_trans
                .ShowDialog()
                If .DialogResult Then

                    'check if a new status shell be added if status is used in database
                    If SettingsCurrent.active_status Then v_trans.transstatus_id = Await check_status(.cmb_status.SelectedItem, .cmb_status.Text)
                    'check if a new person shell be added if person is used in database
                    If SettingsCurrent.active_person Then v_trans.person_id = Await check_person(.cmb_person.SelectedItem, .cmb_person.Text)
                    'check if a new receiver shell be added if receiver is used in database
                    If SettingsCurrent.active_receiver Then v_trans.receiver_id = Await check_receiver(.cmb_empf.SelectedItem, .cmb_empf.Text)

                    If transactiontemplate_consistency_checker(v_trans) Then
                        v_trans.EndEdit()
                        dbo.SaveChanges()
                        dbo.ChangeTracker.DetectChanges()
                    Else
                        cls_logger.v_logger.Error("Template Transaction Consistency Check failed")
                        Throw New System.Exception("Validierung der Vorlage-Transaktion fehlgeschlagen, um Fehler zu vermeiden wird das Programm beendet")
                    End If
                Else
                    v_trans.CancelEdit()
                End If
            End With
        End Sub

        ''' <summary>
        ''' Duplicates the currently selected Template Transaction(s)
        ''' </summary>
        Private Async Sub TransactionTemplateDuplicate()
            If TransTempSelectedItems Is Nothing Or TransTempSelectedItems.Count = 0 Then Exit Sub
            Dim v_question As String
            Dim v_header As String = "Vorlage-Buchung{0} duplizieren"
            If TransTempSelectedItems.Count = 1 Then
                v_question = "Wollen Sie die gewählte Vorlage-Buchung duplizieren?"
                v_header = String.Format(v_header, "")
            Else
                v_question = "Wollen Sie die gewählten {0} Vorlage-Buchungen duplizieren?"
                v_question = String.Format(v_question, TransTempSelectedItems.Count.ToString)
                v_header = String.Format(v_header, "en")
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync(v_header, v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                'Start the duplicate process
                'Because the duplication process changes the Selection of the Listview we have to transfer the IDs of the formerly selected items to a list:
                Dim v_selected_ids As New List(Of Integer)
                For Each item As transactions_template_v01 In TransTempSelectedItems
                    v_selected_ids.Add(item.transtemp_id)
                Next
                For Each v_item_id As Integer In v_selected_ids
                    Dim v_quelle As transactions_template_v01 = dbo.m_transactions_template_v01.First(Function(x) x.transtemp_id = v_item_id)
                    Dim v_duplicate As transactions_template_v01 = dbo.m_transactions_template_v01.AsNoTracking().First(Function(e) e.transtemp_id = v_item_id)
                    dbo.m_transactions_template_v01.Add(v_duplicate)
                    'Save to db to get the new ID
                    dbo.SaveChanges()
                    'Transfer all categories:
                    For Each v_item As transtemp_2_kat In v_quelle.nv_transtemp_2_kat
                        Dim v_temp As transtemp_2_kat = dbo.m_transtemp_2_kat.AsNoTracking.First(Function(x) x.Id = v_item.Id)
                        If Not v_temp Is Nothing Then v_duplicate.nv_transtemp_2_kat.Add(v_temp)
                    Next
                    'Tranfer all Tags:
                    For Each v_item As transtemp_tag_v01 In v_quelle.nv_transtemp_2_tag
                        Dim v_temp As transtemp_tag_v01 = dbo.m_transtemp_tag_v01.AsNoTracking.First(Function(x) x.Id = v_item.Id)
                        If Not v_temp Is Nothing Then v_duplicate.nv_transtemp_2_tag.Add(v_temp)
                    Next
                    dbo.SaveChanges()
                    dbo.ChangeTracker.DetectChanges()

                Next
                Transactions_Template.MoveCurrentToLast()
            End If
        End Sub

        Private Function TransactionsTemplateCanDeleteDuplicate() As Boolean
            If TransTempSelectedItems Is Nothing OrElse TransTempSelectedItems.Count = 0 Then Return False
            If TransTempSelectedItems.Count = 1 Then
                If TransTempSelectedItems.FirstOrDefault Is Nothing Then Return False
            End If

            Return True
        End Function


        ''' <summary>
        ''' Checks if a Transaction doesn't provide konto and to_konto if not type is transfer
        ''' if the Transaction has a failure it will be repaired automatically
        ''' </summary>
        ''' <param name="v_transtemplate">TransactionRepeat to check</param>
        ''' <returns>Returns false if check fails</returns>
        Private Function transactiontemplate_consistency_checker(v_transtemplate As transactions_template_v01) As Boolean
            With v_transtemplate
                If v_transtemplate Is Nothing Then Return False
                'at this stage the nv_transtyp_trans_back property is empty in case the transaction is added new.
                'so check what item is represented bei transtyp_id

                Dim v_ctranstyp As trans_typ_v01 = __typen.First(Function(x) x.typ_id = .transtyp_id)

                If v_ctranstyp Is Nothing Then Return False

                If v_ctranstyp.multiplier = 0 Then
                    'Transfer:
                    'If transfer then set receiver_id to nothing because receiver of a transfer is another konto
                    If .receiver_id IsNot Nothing Then
                        .receiver_id = Nothing
                    End If
                Else
                    'not a transfer
                    If .to_konto_id IsNot Nothing Then
                        .to_konto_id = Nothing
                    End If
                End If
                Return True
            End With
        End Function

        Private Async Sub TransactionsTemplateDelete()
            If TransTempSelectedItems Is Nothing Or TransTempSelectedItems.Count = 0 Then Exit Sub
            Dim v_question As String
            Dim v_header As String = "Vorlage-Buchung{0} löschen"
            If TransTempSelectedItems.Count = 1 Then
                v_question = "Wollen Sie die gewählte Vorlage-Buchung löschen?"
                v_header = String.Format(v_header, "")
            Else
                v_question = "Wollen Sie die gewählten {0} Vorlage-Buchungen löschen?"
                v_question = String.Format(v_question, TransTempSelectedItems.Count.ToString)
                v_header = String.Format(v_header, "en")
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync(v_header, v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                'Very stupid solution first creating a list of integer with all ids then searching with LINQ in the collection to remove ist...
                Dim v_idlist As New List(Of Integer)

                For i As Integer = 0 To TransTempSelectedItems.Count - 1
                    v_idlist.Add(CType(TransTempSelectedItems(i), transactions_template_v01).transtemp_id)
                Next

                For i As Integer = 0 To v_idlist.Count - 1
                    Dim v_i As Integer = i
                    __transactions_template.Remove(__transactions_template.Where(Function(x) x.transtemp_id = v_idlist(v_i)).First)
                Next
                dbo.SaveChanges()
            End If
        End Sub

        Private Function TransactionsTemplateCanDelete(v_obj As IList(Of Object)) As Boolean
            If v_obj Is Nothing Then Return False
            If v_obj.Count = 0 Then Return False
            Return True
        End Function

        Private Sub TransTempImage(v_transtemp As transactions_template_v01)
            If v_transtemp Is Nothing Then Exit Sub
            Dim v_image As Byte() = get_symbol_from_dialog()
            If v_image IsNot Nothing Then
                v_transtemp.symbol = v_image
            End If
        End Sub

#Region "Transaktion Template Kategorie"

        Private Sub TransactionTemplateCatAdd(v_trans As transactions_template_v01)
            Dim v_t2k As New transtemp_2_kat
            Dim v_dia As New frm_transcat_addedit
            With v_dia
                .Title = "Eintrag hinzufügen"
                .DataContext = v_t2k
                .ShowDialog()
                If .DialogResult Then
                    'Add
                    v_trans.nv_transtemp_2_kat.Add(v_t2k)
                    dbo.ChangeTracker.DetectChanges()
                    v_trans.Collection_CollectionChanged(Me, Nothing)
                Else
                    v_t2k = Nothing
                End If
            End With
        End Sub

        Private Async Sub TransactionTemplateCatDelete(v_obj As Object())
            If v_obj Is Nothing Then Exit Sub
            Dim v_transtemp As transactions_template_v01 = DirectCast(v_obj(0), transactions_template_v01)
            Dim v_t2ks As IEnumerable(Of transtemp_2_kat) = DirectCast(v_obj(1), IList).Cast(Of transtemp_2_kat)
            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie die folgenden Kategorien innerhalb der Vorlage-Buchung löschen?")
            For Each v_item As transtemp_2_kat In v_t2ks
                'It's possible that the transtemp_2_kat property is nothing
                If v_item.nv_cat_2_transtemp_back Is Nothing Then
                    v_strbuilder.AppendLine(getCatBezeichnungById(v_item.category_id))
                Else
                    v_strbuilder.AppendLine(v_item.nv_cat_2_transtemp_back.bezeichnung)
                End If
            Next
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Eintrag löschen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                While v_t2ks.Count > 0
                    If __ttemp2k.Remove(v_t2ks.First) = False Then
                        'Category could not removed from observablecollection => happens if a newly created transaction tries to delete a newly created t2k
                        v_transtemp.nv_transtemp_2_kat.Remove(v_t2ks.First)
                    End If
                End While
                dbo.SaveChanges()
            End If
        End Sub

        Private Function TransactionTemplateCatCanDelete(v_obj As Object()) As Boolean
            If v_obj Is Nothing Then Return False
            If v_obj(0) Is Nothing Then Return False
            If v_obj(1) Is Nothing Then Return False
            Return True
        End Function

        Private Sub TransactionTemplateCatEdit(v_t2k As transtemp_2_kat)
            If v_t2k Is Nothing Then Exit Sub
            Dim v_dia As New frm_transcat_addedit
            Dim v_trans_rep As transactions_template_v01 = v_t2k.nv_transtemp_2_kat_back

            v_t2k.BeginEdit()

            With v_dia
                .Title = "Eintrag bearbeiten"
                .DataContext = v_t2k
                .ShowDialog()
                If .DialogResult Then
                    'Bearbeitung speichern
                    v_t2k.EndEdit()
                    dbo.SaveChanges()
                    dbo.ChangeTracker.DetectChanges()
                    v_trans_rep.Collection_CollectionChanged(Me, Nothing)
                Else
                    v_t2k.CancelEdit()
                    v_t2k = Nothing
                End If
            End With
        End Sub

        ''' <summary>
        ''' Saves Changes in a given Template Transation used mainly in ucl_transactiontemplate at DetailView
        ''' </summary>
        ''' <param name="v_trans"></param>
        Private Async Sub TransactionTemplateSaveChanges(v_trans As transactions_template_v01)
            If v_trans Is Nothing Then Exit Sub
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Änderungen speichern", "Wollen Sie die Änderungen an der Vorlage-Buchung speichern?", MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                If transactiontemplate_consistency_checker(v_trans) Then
                    v_trans.EndEdit()
                    dbo.SaveChanges()
                Else
                    v_trans.CancelEdit()
                End If
                v_trans.EndEdit()
            Else
                v_trans.CancelEdit()
            End If
        End Sub

        Private Function TransactionTemplateCanSaveChanges(v_trans As transactions_template_v01) As Boolean
            If v_trans Is Nothing Then Return False
            If v_trans.hasErrors Then Return False
            Return True
        End Function

#End Region

#End Region

    End Class
End Namespace